/*
	Copyright (c) 2004-2006, The Dojo Foundation
	All Rights Reserved.

	Licensed under the Academic Free License version 2.1 or above OR the
	modified BSD license. For more information on Dojo licensing, see:

		http://dojotoolkit.org/community/licensing.shtml
*/

/*
	This is a compiled version of Dojo, built for deployment and not for
	development. To get an editable version, please visit:

		http://dojotoolkit.org

	for documentation and information on getting the source.
*/

if(typeof dojo=="undefined"){
var dj_global=this;
var dj_currentContext=this;
function dj_undef(_1,_2){
return (typeof (_2||dj_currentContext)[_1]=="undefined");
}
if(dj_undef("djConfig",this)){
var djConfig={};
}
if(dj_undef("dojo",this)){
var dojo={};
}
dojo.global=function(){
return dj_currentContext;
};
dojo.locale=djConfig.locale;
dojo.version={major:0,minor:4,patch:1,flag:"p1xdomain",revision:Number("$Rev: 8615 $".match(/[0-9]+/)[0]),toString:function(){
with(dojo.version){
return major+"."+minor+"."+patch+flag+" ("+revision+")";
}
}};
dojo.evalProp=function(_3,_4,_5){
if((!_4)||(!_3)){
return undefined;
}
if(!dj_undef(_3,_4)){
return _4[_3];
}
return (_5?(_4[_3]={}):undefined);
};
dojo.parseObjPath=function(_6,_7,_8){
var _9=(_7||dojo.global());
var _a=_6.split(".");
var _b=_a.pop();
for(var i=0,l=_a.length;i<l&&_9;i++){
_9=dojo.evalProp(_a[i],_9,_8);
}
return {obj:_9,prop:_b};
};
dojo.evalObjPath=function(_e,_f){
if(typeof _e!="string"){
return dojo.global();
}
if(_e.indexOf(".")==-1){
return dojo.evalProp(_e,dojo.global(),_f);
}
var ref=dojo.parseObjPath(_e,dojo.global(),_f);
if(ref){
return dojo.evalProp(ref.prop,ref.obj,_f);
}
return null;
};
dojo.errorToString=function(_11){
if(!dj_undef("message",_11)){
return _11.message;
}else{
if(!dj_undef("description",_11)){
return _11.description;
}else{
return _11;
}
}
};
dojo.raise=function(_12,_13){
if(_13){
_12=_12+": "+dojo.errorToString(_13);
}else{
_12=dojo.errorToString(_12);
}
try{
if(djConfig.isDebug){
dojo.hostenv.println("FATAL exception raised: "+_12);
}
}
catch(e){
}
throw _13||Error(_12);
};
dojo.debug=function(){
};
dojo.debugShallow=function(obj){
};
dojo.profile={start:function(){
},end:function(){
},stop:function(){
},dump:function(){
}};
function dj_eval(_15){
return dj_global.eval?dj_global.eval(_15):eval(_15);
}
dojo.unimplemented=function(_16,_17){
var _18="'"+_16+"' not implemented";
if(_17!=null){
_18+=" "+_17;
}
dojo.raise(_18);
};
dojo.deprecated=function(_19,_1a,_1b){
var _1c="DEPRECATED: "+_19;
if(_1a){
_1c+=" "+_1a;
}
if(_1b){
_1c+=" -- will be removed in version: "+_1b;
}
dojo.debug(_1c);
};
dojo.render=(function(){
function vscaffold(_1d,_1e){
var tmp={capable:false,support:{builtin:false,plugin:false},prefixes:_1d};
for(var i=0;i<_1e.length;i++){
tmp[_1e[i]]=false;
}
return tmp;
}
return {name:"",ver:dojo.version,os:{win:false,linux:false,osx:false},html:vscaffold(["html"],["ie","opera","khtml","safari","moz"]),svg:vscaffold(["svg"],["corel","adobe","batik"]),vml:vscaffold(["vml"],["ie"]),swf:vscaffold(["Swf","Flash","Mm"],["mm"]),swt:vscaffold(["Swt"],["ibm"])};
})();
dojo.hostenv=(function(){
var _21={isDebug:false,allowQueryConfig:false,baseScriptUri:"",baseRelativePath:"",libraryScriptUri:"",iePreventClobber:false,ieClobberMinimal:true,preventBackButtonFix:true,delayMozLoadingFix:false,searchIds:[],parseWidgets:true};
if(typeof djConfig=="undefined"){
djConfig=_21;
}else{
for(var _22 in _21){
if(typeof djConfig[_22]=="undefined"){
djConfig[_22]=_21[_22];
}
}
}
return {name_:"(unset)",version_:"(unset)",getName:function(){
return this.name_;
},getVersion:function(){
return this.version_;
},getText:function(uri){
dojo.unimplemented("getText","uri="+uri);
}};
})();
dojo.hostenv.getBaseScriptUri=function(){
if(djConfig.baseScriptUri.length){
return djConfig.baseScriptUri;
}
var uri=new String(djConfig.libraryScriptUri||djConfig.baseRelativePath);
if(!uri){
dojo.raise("Nothing returned by getLibraryScriptUri(): "+uri);
}
var _25=uri.lastIndexOf("/");
djConfig.baseScriptUri=djConfig.baseRelativePath;
return djConfig.baseScriptUri;
};
(function(){
var _26={pkgFileName:"__package__",loading_modules_:{},loaded_modules_:{},addedToLoadingCount:[],removedFromLoadingCount:[],inFlightCount:0,modulePrefixes_:{dojo:{name:"dojo",value:"src"}},setModulePrefix:function(_27,_28){
this.modulePrefixes_[_27]={name:_27,value:_28};
},moduleHasPrefix:function(_29){
var mp=this.modulePrefixes_;
return Boolean(mp[_29]&&mp[_29].value);
},getModulePrefix:function(_2b){
if(this.moduleHasPrefix(_2b)){
return this.modulePrefixes_[_2b].value;
}
return _2b;
},getTextStack:[],loadUriStack:[],loadedUris:[],post_load_:false,modulesLoadedListeners:[],unloadListeners:[],loadNotifying:false};
for(var _2c in _26){
dojo.hostenv[_2c]=_26[_2c];
}
})();
dojo.hostenv.loadPath=function(_2d,_2e,cb){
var uri;
if(_2d.charAt(0)=="/"||_2d.match(/^\w+:/)){
uri=_2d;
}else{
uri=this.getBaseScriptUri()+_2d;
}
if(djConfig.cacheBust&&dojo.render.html.capable){
uri+="?"+String(djConfig.cacheBust).replace(/\W+/g,"");
}
try{
return !_2e?this.loadUri(uri,cb):this.loadUriAndCheck(uri,_2e,cb);
}
catch(e){
dojo.debug(e);
return false;
}
};
dojo.hostenv.loadUri=function(uri,cb){
if(this.loadedUris[uri]){
return true;
}
var _33=this.getText(uri,null,true);
if(!_33){
return false;
}
this.loadedUris[uri]=true;
if(cb){
_33="("+_33+")";
}
var _34=dj_eval(_33);
if(cb){
cb(_34);
}
return true;
};
dojo.hostenv.loadUriAndCheck=function(uri,_36,cb){
var ok=true;
try{
ok=this.loadUri(uri,cb);
}
catch(e){
dojo.debug("failed loading ",uri," with error: ",e);
}
return Boolean(ok&&this.findModule(_36,false));
};
dojo.loaded=function(){
};
dojo.unloaded=function(){
};
dojo.hostenv.loaded=function(){
this.loadNotifying=true;
this.post_load_=true;
var mll=this.modulesLoadedListeners;
for(var x=0;x<mll.length;x++){
mll[x]();
}
this.modulesLoadedListeners=[];
this.loadNotifying=false;
dojo.loaded();
};
dojo.hostenv.unloaded=function(){
var mll=this.unloadListeners;
while(mll.length){
(mll.pop())();
}
dojo.unloaded();
};
dojo.addOnLoad=function(obj,_3d){
var dh=dojo.hostenv;
if(arguments.length==1){
dh.modulesLoadedListeners.push(obj);
}else{
if(arguments.length>1){
dh.modulesLoadedListeners.push(function(){
obj[_3d]();
});
}
}
if(dh.post_load_&&dh.inFlightCount==0&&!dh.loadNotifying){
dh.callLoaded();
}
};
dojo.addOnUnload=function(obj,_40){
var dh=dojo.hostenv;
if(arguments.length==1){
dh.unloadListeners.push(obj);
}else{
if(arguments.length>1){
dh.unloadListeners.push(function(){
obj[_40]();
});
}
}
};
dojo.hostenv.modulesLoaded=function(){
if(this.post_load_){
return;
}
if(this.loadUriStack.length==0&&this.getTextStack.length==0){
if(this.inFlightCount>0){
dojo.debug("files still in flight!");
return;
}
dojo.hostenv.callLoaded();
}
};
dojo.hostenv.callLoaded=function(){
if(typeof setTimeout=="object"){
setTimeout("dojo.hostenv.loaded();",0);
}else{
dojo.hostenv.loaded();
}
};
dojo.hostenv.getModuleSymbols=function(_42){
var _43=_42.split(".");
for(var i=_43.length;i>0;i--){
var _45=_43.slice(0,i).join(".");
if((i==1)&&!this.moduleHasPrefix(_45)){
_43[0]="../"+_43[0];
}else{
var _46=this.getModulePrefix(_45);
if(_46!=_45){
_43.splice(0,i,_46);
break;
}
}
}
return _43;
};
dojo.hostenv._global_omit_module_check=false;
dojo.hostenv.loadModule=function(_47,_48,_49){
if(!_47){
return;
}
_49=this._global_omit_module_check||_49;
var _4a=this.findModule(_47,false);
if(_4a){
return _4a;
}
if(dj_undef(_47,this.loading_modules_)){
this.addedToLoadingCount.push(_47);
}
this.loading_modules_[_47]=1;
var _4b=_47.replace(/\./g,"/")+".js";
var _4c=_47.split(".");
var _4d=this.getModuleSymbols(_47);
var _4e=((_4d[0].charAt(0)!="/")&&!_4d[0].match(/^\w+:/));
var _4f=_4d[_4d.length-1];
var ok;
if(_4f=="*"){
_47=_4c.slice(0,-1).join(".");
while(_4d.length){
_4d.pop();
_4d.push(this.pkgFileName);
_4b=_4d.join("/")+".js";
if(_4e&&_4b.charAt(0)=="/"){
_4b=_4b.slice(1);
}
ok=this.loadPath(_4b,!_49?_47:null);
if(ok){
break;
}
_4d.pop();
}
}else{
_4b=_4d.join("/")+".js";
_47=_4c.join(".");
var _51=!_49?_47:null;
ok=this.loadPath(_4b,_51);
if(!ok&&!_48){
_4d.pop();
while(_4d.length){
_4b=_4d.join("/")+".js";
ok=this.loadPath(_4b,_51);
if(ok){
break;
}
_4d.pop();
_4b=_4d.join("/")+"/"+this.pkgFileName+".js";
if(_4e&&_4b.charAt(0)=="/"){
_4b=_4b.slice(1);
}
ok=this.loadPath(_4b,_51);
if(ok){
break;
}
}
}
if(!ok&&!_49){
dojo.raise("Could not load '"+_47+"'; last tried '"+_4b+"'");
}
}
if(!_49&&!this["isXDomain"]){
_4a=this.findModule(_47,false);
if(!_4a){
dojo.raise("symbol '"+_47+"' is not defined after loading '"+_4b+"'");
}
}
return _4a;
};
dojo.hostenv.startPackage=function(_52){
var _53=String(_52);
var _54=_53;
var _55=_52.split(/\./);
if(_55[_55.length-1]=="*"){
_55.pop();
_54=_55.join(".");
}
var _56=dojo.evalObjPath(_54,true);
this.loaded_modules_[_53]=_56;
this.loaded_modules_[_54]=_56;
return _56;
};
dojo.hostenv.findModule=function(_57,_58){
var lmn=String(_57);
if(this.loaded_modules_[lmn]){
return this.loaded_modules_[lmn];
}
if(_58){
dojo.raise("no loaded module named '"+_57+"'");
}
return null;
};
dojo.kwCompoundRequire=function(_5a){
var _5b=_5a["common"]||[];
var _5c=_5a[dojo.hostenv.name_]?_5b.concat(_5a[dojo.hostenv.name_]||[]):_5b.concat(_5a["default"]||[]);
for(var x=0;x<_5c.length;x++){
var _5e=_5c[x];
if(_5e.constructor==Array){
dojo.hostenv.loadModule.apply(dojo.hostenv,_5e);
}else{
dojo.hostenv.loadModule(_5e);
}
}
};
dojo.require=function(_5f){
dojo.hostenv.loadModule.apply(dojo.hostenv,arguments);
};
dojo.requireIf=function(_60,_61){
var _62=arguments[0];
if((_62===true)||(_62=="common")||(_62&&dojo.render[_62].capable)){
var _63=[];
for(var i=1;i<arguments.length;i++){
_63.push(arguments[i]);
}
dojo.require.apply(dojo,_63);
}
};
dojo.requireAfterIf=dojo.requireIf;
dojo.provide=function(_65){
return dojo.hostenv.startPackage.apply(dojo.hostenv,arguments);
};
dojo.registerModulePath=function(_66,_67){
return dojo.hostenv.setModulePrefix(_66,_67);
};
dojo.setModulePrefix=function(_68,_69){
dojo.deprecated("dojo.setModulePrefix(\""+_68+"\", \""+_69+"\")","replaced by dojo.registerModulePath","0.5");
return dojo.registerModulePath(_68,_69);
};
dojo.exists=function(obj,_6b){
var p=_6b.split(".");
for(var i=0;i<p.length;i++){
if(!obj[p[i]]){
return false;
}
obj=obj[p[i]];
}
return true;
};
dojo.hostenv.normalizeLocale=function(_6e){
var _6f=_6e?_6e.toLowerCase():dojo.locale;
if(_6f=="root"){
_6f="ROOT";
}
return _6f;
};
dojo.hostenv.searchLocalePath=function(_70,_71,_72){
_70=dojo.hostenv.normalizeLocale(_70);
var _73=_70.split("-");
var _74=[];
for(var i=_73.length;i>0;i--){
_74.push(_73.slice(0,i).join("-"));
}
_74.push(false);
if(_71){
_74.reverse();
}
for(var j=_74.length-1;j>=0;j--){
var loc=_74[j]||"ROOT";
var _78=_72(loc);
if(_78){
break;
}
}
};
dojo.hostenv.localesGenerated;
dojo.hostenv.registerNlsPrefix=function(){
dojo.registerModulePath("nls","nls");
};
dojo.hostenv.preloadLocalizations=function(){
if(dojo.hostenv.localesGenerated){
dojo.hostenv.registerNlsPrefix();
function preload(_79){
_79=dojo.hostenv.normalizeLocale(_79);
dojo.hostenv.searchLocalePath(_79,true,function(loc){
for(var i=0;i<dojo.hostenv.localesGenerated.length;i++){
if(dojo.hostenv.localesGenerated[i]==loc){
dojo["require"]("nls.dojo_"+loc);
return true;
}
}
return false;
});
}
preload();
var _7c=djConfig.extraLocale||[];
for(var i=0;i<_7c.length;i++){
preload(_7c[i]);
}
}
dojo.hostenv.preloadLocalizations=function(){
};
};
dojo.requireLocalization=function(_7e,_7f,_80,_81){
dojo.hostenv.preloadLocalizations();
var _82=dojo.hostenv.normalizeLocale(_80);
var _83=[_7e,"nls",_7f].join(".");
var _84="";
if(_81){
var _85=_81.split(",");
for(var i=0;i<_85.length;i++){
if(_82.indexOf(_85[i])==0){
if(_85[i].length>_84.length){
_84=_85[i];
}
}
}
if(!_84){
_84="ROOT";
}
}
var _87=_81?_84:_82;
var _88=dojo.hostenv.findModule(_83);
var _89=null;
if(_88){
if(djConfig.localizationComplete&&_88._built){
return;
}
var _8a=_87.replace("-","_");
var _8b=_83+"."+_8a;
_89=dojo.hostenv.findModule(_8b);
}
if(!_89){
_88=dojo.hostenv.startPackage(_83);
var _8c=dojo.hostenv.getModuleSymbols(_7e);
var _8d=_8c.concat("nls").join("/");
var _8e;
dojo.hostenv.searchLocalePath(_87,_81,function(loc){
var _90=loc.replace("-","_");
var _91=_83+"."+_90;
var _92=false;
if(!dojo.hostenv.findModule(_91)){
dojo.hostenv.startPackage(_91);
var _93=[_8d];
if(loc!="ROOT"){
_93.push(loc);
}
_93.push(_7f);
var _94=_93.join("/")+".js";
_92=dojo.hostenv.loadPath(_94,null,function(_95){
var _96=function(){
};
_96.prototype=_8e;
_88[_90]=new _96();
for(var j in _95){
_88[_90][j]=_95[j];
}
});
}else{
_92=true;
}
if(_92&&_88[_90]){
_8e=_88[_90];
}else{
_88[_90]=_8e;
}
if(_81){
return true;
}
});
}
if(_81&&_82!=_84){
_88[_82.replace("-","_")]=_88[_84.replace("-","_")];
}
};
(function(){
var _98=djConfig.extraLocale;
if(_98){
if(!_98 instanceof Array){
_98=[_98];
}
var req=dojo.requireLocalization;
dojo.requireLocalization=function(m,b,_9c,_9d){
req(m,b,_9c,_9d);
if(_9c){
return;
}
for(var i=0;i<_98.length;i++){
req(m,b,_98[i],_9d);
}
};
}
})();
dojo.hostenv.resetXd=function(){
this.isXDomain=djConfig.forceXDomain||false;
this.xdTimer=0;
this.xdInFlight={};
this.xdOrderedReqs=[];
this.xdDepMap={};
this.xdContents=[];
};
dojo.hostenv.resetXd();
dojo.hostenv.createXdPackage=function(_9f){
var _a0=[];
var _a1=/dojo.(require|requireIf|requireAll|provide|requireAfterIf|requireAfter|kwCompoundRequire|conditionalRequire|hostenv\.conditionalLoadModule|.hostenv\.loadModule|hostenv\.moduleLoaded)\(([\w\W]*?)\)/mg;
var _a2;
while((_a2=_a1.exec(_9f))!=null){
_a0.push("\""+_a2[1]+"\", "+_a2[2]);
}
var _a3=[];
_a3.push("dojo.hostenv.packageLoaded({\n");
if(_a0.length>0){
_a3.push("depends: [");
for(var i=0;i<_a0.length;i++){
if(i>0){
_a3.push(",\n");
}
_a3.push("["+_a0[i]+"]");
}
_a3.push("],");
}
_a3.push("\ndefinePackage: function(dojo){");
_a3.push(_9f);
_a3.push("\n}});");
return _a3.join("");
};
dojo.hostenv.loadPath=function(_a5,_a6,cb){
var _a8=_a5.indexOf(":");
var _a9=_a5.indexOf("/");
var uri;
var _ab=false;
if(_a8>0&&_a8<_a9){
uri=_a5;
this.isXDomain=_ab=true;
}else{
uri=this.getBaseScriptUri()+_a5;
_a8=uri.indexOf(":");
_a9=uri.indexOf("/");
if(_a8>0&&_a8<_a9&&(!location.host||uri.indexOf("http://"+location.host)!=0)){
this.isXDomain=_ab=true;
}
}
if(djConfig.cacheBust&&dojo.render.html.capable){
uri+="?"+String(djConfig.cacheBust).replace(/\W+/g,"");
}
try{
return ((!_a6||this.isXDomain)?this.loadUri(uri,cb,_ab,_a6):this.loadUriAndCheck(uri,_a6,cb));
}
catch(e){
dojo.debug(e);
return false;
}
};
dojo.hostenv.loadUri=function(uri,cb,_ae,_af){
if(this.loadedUris[uri]){
return 1;
}
if(this.isXDomain){
this.xdOrderedReqs.push(_af);
if(uri.indexOf("__package__")!=-1){
_af+=".*";
}
this.xdInFlight[_af]=true;
this.inFlightCount++;
if(!this.xdTimer){
this.xdTimer=setInterval("dojo.hostenv.watchInFlightXDomain();",100);
}
this.xdStartTime=(new Date()).getTime();
}
if(_ae){
var _b0=uri.lastIndexOf(".");
if(_b0<=0){
_b0=uri.length-1;
}
var _b1=uri.substring(0,_b0)+".xd";
if(_b0!=uri.length-1){
_b1+=uri.substring(_b0,uri.length);
}
var _b2=document.createElement("script");
_b2.type="text/javascript";
_b2.src=_b1;
if(!this.headElement){
this.headElement=document.getElementsByTagName("head")[0];
}
this.headElement.appendChild(_b2);
}else{
var _b3=this.getText(uri,null,true);
if(_b3==null){
return 0;
}
if(this.isXDomain){
var pkg=this.createXdPackage(_b3);
dj_eval(pkg);
}else{
if(cb){
_b3="("+_b3+")";
}
var _b5=dj_eval(_b3);
if(cb){
cb(_b5);
}
}
}
this.loadedUris[uri]=true;
return 1;
};
dojo.hostenv.packageLoaded=function(pkg){
var _b7=pkg.depends;
var _b8=null;
var _b9=null;
var _ba=[];
if(_b7&&_b7.length>0){
var dep=null;
var _bc=0;
var _bd=false;
for(var i=0;i<_b7.length;i++){
dep=_b7[i];
if(dep[0]=="provide"||dep[0]=="hostenv.moduleLoaded"){
_ba.push(dep[1]);
}else{
if(!_b8){
_b8=[];
}
if(!_b9){
_b9=[];
}
var _bf=this.unpackXdDependency(dep);
if(_bf.requires){
_b8=_b8.concat(_bf.requires);
}
if(_bf.requiresAfter){
_b9=_b9.concat(_bf.requiresAfter);
}
}
var _c0=dep[0];
var _c1=_c0.split(".");
if(_c1.length==2){
dojo[_c1[0]][_c1[1]].apply(dojo[_c1[0]],dep.slice(1));
}else{
dojo[_c0].apply(dojo,dep.slice(1));
}
}
var _c2=this.xdContents.push({content:pkg.definePackage,isDefined:false})-1;
for(var i=0;i<_ba.length;i++){
this.xdDepMap[_ba[i]]={requires:_b8,requiresAfter:_b9,contentIndex:_c2};
}
for(var i=0;i<_ba.length;i++){
this.xdInFlight[_ba[i]]=false;
}
}
};
dojo.hostenv.xdLoadFlattenedBundle=function(_c3,_c4,_c5,_c6){
_c5=_c5||"root";
var _c7=dojo.hostenv.normalizeLocale(_c5).replace("-","_");
var _c8=[_c3,"nls",_c4].join(".");
var _c9=dojo.hostenv.startPackage(_c8);
_c9[_c7]=_c6;
var _ca=[_c3,_c7,_c4].join(".");
var _cb=dojo.hostenv.xdBundleMap[_ca];
if(_cb){
for(var _cc in _cb){
_c9[_cc]=_c6;
}
}
};
dojo.hostenv.xdBundleMap={};
dojo.xdRequireLocalization=function(_cd,_ce,_cf,_d0){
var _d1=_d0.split(",");
var _d2=dojo.hostenv.normalizeLocale(_cf);
var _d3="";
for(var i=0;i<_d1.length;i++){
if(_d2.indexOf(_d1[i])==0){
if(_d1[i].length>_d3.length){
_d3=_d1[i];
}
}
}
var _d5=_d3.replace("-","_");
var _d6=dojo.evalObjPath([_cd,"nls",_ce].join("."));
if(_d6&&_d6[_d5]){
bundle[_d2.replace("-","_")]=_d6[_d5];
}else{
var _d7=[_cd,(_d5||"root"),_ce].join(".");
var _d8=dojo.hostenv.xdBundleMap[_d7];
if(!_d8){
_d8=dojo.hostenv.xdBundleMap[_d7]={};
}
_d8[_d2.replace("-","_")]=true;
dojo.require(_cd+".nls"+(_d3?"."+_d3:"")+"."+_ce);
}
};
(function(){
var _d9=djConfig.extraLocale;
if(_d9){
if(!_d9 instanceof Array){
_d9=[_d9];
}
dojo._xdReqLoc=dojo.xdRequireLocalization;
dojo.xdRequireLocalization=function(m,b,_dc,_dd){
dojo._xdReqLoc(m,b,_dc,_dd);
if(_dc){
return;
}
for(var i=0;i<_d9.length;i++){
dojo._xdReqLoc(m,b,_d9[i],_dd);
}
};
}
})();
dojo.hostenv.unpackXdDependency=function(dep){
var _e0=null;
var _e1=null;
switch(dep[0]){
case "requireIf":
case "requireAfterIf":
case "conditionalRequire":
if((dep[1]===true)||(dep[1]=="common")||(dep[1]&&dojo.render[dep[1]].capable)){
_e0=[{name:dep[2],content:null}];
}
break;
case "requireAll":
dep.shift();
_e0=dep;
dojo.hostenv.flattenRequireArray(_e0);
break;
case "kwCompoundRequire":
case "hostenv.conditionalLoadModule":
var _e2=dep[1];
var _e3=_e2["common"]||[];
var _e0=(_e2[dojo.hostenv.name_])?_e3.concat(_e2[dojo.hostenv.name_]||[]):_e3.concat(_e2["default"]||[]);
dojo.hostenv.flattenRequireArray(_e0);
break;
case "require":
case "requireAfter":
case "hostenv.loadModule":
_e0=[{name:dep[1],content:null}];
break;
}
if(dep[0]=="requireAfterIf"){
_e1=_e0;
_e0=null;
}
return {requires:_e0,requiresAfter:_e1};
};
dojo.hostenv.xdWalkReqs=function(){
var _e4=null;
var req;
for(var i=0;i<this.xdOrderedReqs.length;i++){
req=this.xdOrderedReqs[i];
if(this.xdDepMap[req]){
_e4=[req];
_e4[req]=true;
this.xdEvalReqs(_e4);
}
}
};
dojo.hostenv.xdTraceReqs=function(_e7,_e8){
if(_e7&&_e7.length>0){
var _e9;
for(var i=0;i<_e7.length;i++){
_e9=_e7[i].name;
if(_e9&&!_e8[_e9]){
_e8.push(_e9);
_e8[_e9]=true;
this.xdEvalReqs(_e8);
}
}
}
};
dojo.hostenv.xdEvalReqs=function(_eb){
if(_eb.length>0){
var req=_eb[_eb.length-1];
var pkg=this.xdDepMap[req];
if(pkg){
this.xdTraceReqs(pkg.requires,_eb);
var _ee=this.xdContents[pkg.contentIndex];
if(!_ee.isDefined){
_ee.content(dojo);
_ee.isDefined=true;
}
this.xdDepMap[req]=null;
this.xdTraceReqs(pkg.requiresAfter,_eb);
}
_eb.pop();
this.xdEvalReqs(_eb);
}
};
dojo.hostenv.clearXdInterval=function(){
clearInterval(this.xdTimer);
this.xdTimer=0;
};
dojo.hostenv.watchInFlightXDomain=function(){
var _ef=(djConfig.xdWaitSeconds||30)*1000;
if(this.xdStartTime+_ef<(new Date()).getTime()){
this.clearXdInterval();
var _f0="";
for(var _f1 in this.xdInFlight){
if(this.xdInFlight[_f1]){
_f0+=_f1+" ";
}
}
dojo.raise("Could not load cross-domain packages: "+_f0);
}
for(var _f1 in this.xdInFlight){
if(this.xdInFlight[_f1]){
return;
}
}
this.clearXdInterval();
this.xdWalkReqs();
for(var i=0;i<this.xdContents.length;i++){
var _f3=this.xdContents[i];
if(_f3.content&&!_f3.isDefined){
_f3.content(dojo);
}
}
this.resetXd();
this.inFlightCount=0;
this.callLoaded();
};
dojo.hostenv.flattenRequireArray=function(_f4){
if(_f4){
for(var i=0;i<_f4.length;i++){
if(_f4[i] instanceof Array){
_f4[i]={name:_f4[i][0],content:null};
}else{
_f4[i]={name:_f4[i],content:null};
}
}
}
};
dojo.hostenv.xdHasCalledPreload=false;
dojo.hostenv.xdRealCallLoaded=dojo.hostenv.callLoaded;
dojo.hostenv.callLoaded=function(){
if(this.xdHasCalledPreload||dojo.hostenv.getModulePrefix("dojo")=="src"||!this.localesGenerated){
this.xdRealCallLoaded();
this.xdHasCalledPreload=true;
}else{
if(this.localesGenerated){
this.registerNlsPrefix=function(){
dojo.registerModulePath("nls",dojo.hostenv.getModulePrefix("dojo")+"/../nls");
};
this.preloadLocalizations();
}
this.xdHasCalledPreload=true;
}
};
}
if(typeof window!="undefined"){
(function(){
if(djConfig.allowQueryConfig){
var _f6=document.location.toString();
var _f7=_f6.split("?",2);
if(_f7.length>1){
var _f8=_f7[1];
var _f9=_f8.split("&");
for(var x in _f9){
var sp=_f9[x].split("=");
if((sp[0].length>9)&&(sp[0].substr(0,9)=="djConfig.")){
var opt=sp[0].substr(9);
try{
djConfig[opt]=eval(sp[1]);
}
catch(e){
djConfig[opt]=sp[1];
}
}
}
}
}
if(((djConfig["baseScriptUri"]=="")||(djConfig["baseRelativePath"]==""))&&(document&&document.getElementsByTagName)){
var _fd=document.getElementsByTagName("script");
var _fe=/(__package__|dojo|bootstrap1)\.js([\?\.]|$)/i;
for(var i=0;i<_fd.length;i++){
var src=_fd[i].getAttribute("src");
if(!src){
continue;
}
var m=src.match(_fe);
if(m){
var root=src.substring(0,m.index);
if(src.indexOf("bootstrap1")>-1){
root+="../";
}
if(!this["djConfig"]){
djConfig={};
}
if(djConfig["baseScriptUri"]==""){
djConfig["baseScriptUri"]=root;
}
if(djConfig["baseRelativePath"]==""){
djConfig["baseRelativePath"]=root;
}
break;
}
}
}
var dr=dojo.render;
var drh=dojo.render.html;
var drs=dojo.render.svg;
var dua=(drh.UA=navigator.userAgent);
var dav=(drh.AV=navigator.appVersion);
var t=true;
var f=false;
drh.capable=t;
drh.support.builtin=t;
dr.ver=parseFloat(drh.AV);
dr.os.mac=dav.indexOf("Macintosh")>=0;
dr.os.win=dav.indexOf("Windows")>=0;
dr.os.linux=dav.indexOf("X11")>=0;
drh.opera=dua.indexOf("Opera")>=0;
drh.khtml=(dav.indexOf("Konqueror")>=0)||(dav.indexOf("Safari")>=0);
drh.safari=dav.indexOf("Safari")>=0;
var _10a=dua.indexOf("Gecko");
drh.mozilla=drh.moz=(_10a>=0)&&(!drh.khtml);
if(drh.mozilla){
drh.geckoVersion=dua.substring(_10a+6,_10a+14);
}
drh.ie=(document.all)&&(!drh.opera);
drh.ie50=drh.ie&&dav.indexOf("MSIE 5.0")>=0;
drh.ie55=drh.ie&&dav.indexOf("MSIE 5.5")>=0;
drh.ie60=drh.ie&&dav.indexOf("MSIE 6.0")>=0;
drh.ie70=drh.ie&&dav.indexOf("MSIE 7.0")>=0;
var cm=document["compatMode"];
drh.quirks=(cm=="BackCompat")||(cm=="QuirksMode")||drh.ie55||drh.ie50;
dojo.locale=dojo.locale||(drh.ie?navigator.userLanguage:navigator.language).toLowerCase();
dr.vml.capable=drh.ie;
drs.capable=f;
drs.support.plugin=f;
drs.support.builtin=f;
var tdoc=window["document"];
var tdi=tdoc["implementation"];
if((tdi)&&(tdi["hasFeature"])&&(tdi.hasFeature("org.w3c.dom.svg","1.0"))){
drs.capable=t;
drs.support.builtin=t;
drs.support.plugin=f;
}
if(drh.safari){
var tmp=dua.split("AppleWebKit/")[1];
var ver=parseFloat(tmp.split(" ")[0]);
if(ver>=420){
drs.capable=t;
drs.support.builtin=t;
drs.support.plugin=f;
}
}else{
}
})();
dojo.hostenv.startPackage("dojo.hostenv");
dojo.render.name=dojo.hostenv.name_="browser";
dojo.hostenv.searchIds=[];
dojo.hostenv._XMLHTTP_PROGIDS=["Msxml2.XMLHTTP","Microsoft.XMLHTTP","Msxml2.XMLHTTP.4.0"];
dojo.hostenv.getXmlhttpObject=function(){
var http=null;
var _111=null;
try{
http=new XMLHttpRequest();
}
catch(e){
}
if(!http){
for(var i=0;i<3;++i){
var _113=dojo.hostenv._XMLHTTP_PROGIDS[i];
try{
http=new ActiveXObject(_113);
}
catch(e){
_111=e;
}
if(http){
dojo.hostenv._XMLHTTP_PROGIDS=[_113];
break;
}
}
}
if(!http){
return dojo.raise("XMLHTTP not available",_111);
}
return http;
};
dojo.hostenv._blockAsync=false;
dojo.hostenv.getText=function(uri,_115,_116){
if(!_115){
this._blockAsync=true;
}
var http=this.getXmlhttpObject();
function isDocumentOk(http){
var stat=http["status"];
return Boolean((!stat)||((200<=stat)&&(300>stat))||(stat==304));
}
if(_115){
var _11a=this,_11b=null,gbl=dojo.global();
var xhr=dojo.evalObjPath("dojo.io.XMLHTTPTransport");
http.onreadystatechange=function(){
if(_11b){
gbl.clearTimeout(_11b);
_11b=null;
}
if(_11a._blockAsync||(xhr&&xhr._blockAsync)){
_11b=gbl.setTimeout(function(){
http.onreadystatechange.apply(this);
},10);
}else{
if(4==http.readyState){
if(isDocumentOk(http)){
_115(http.responseText);
}
}
}
};
}
http.open("GET",uri,_115?true:false);
try{
http.send(null);
if(_115){
return null;
}
if(!isDocumentOk(http)){
var err=Error("Unable to load "+uri+" status:"+http.status);
err.status=http.status;
err.responseText=http.responseText;
throw err;
}
}
catch(e){
this._blockAsync=false;
if((_116)&&(!_115)){
return null;
}else{
throw e;
}
}
this._blockAsync=false;
return http.responseText;
};
dojo.hostenv.defaultDebugContainerId="dojoDebug";
dojo.hostenv._println_buffer=[];
dojo.hostenv._println_safe=false;
dojo.hostenv.println=function(line){
if(!dojo.hostenv._println_safe){
dojo.hostenv._println_buffer.push(line);
}else{
try{
var _120=document.getElementById(djConfig.debugContainerId?djConfig.debugContainerId:dojo.hostenv.defaultDebugContainerId);
if(!_120){
_120=dojo.body();
}
var div=document.createElement("div");
div.appendChild(document.createTextNode(line));
_120.appendChild(div);
}
catch(e){
try{
document.write("<div>"+line+"</div>");
}
catch(e2){
window.status=line;
}
}
}
};
dojo.addOnLoad(function(){
dojo.hostenv._println_safe=true;
while(dojo.hostenv._println_buffer.length>0){
dojo.hostenv.println(dojo.hostenv._println_buffer.shift());
}
});
function dj_addNodeEvtHdlr(node,_123,fp){
var _125=node["on"+_123]||function(){
};
node["on"+_123]=function(){
fp.apply(node,arguments);
_125.apply(node,arguments);
};
return true;
}
function dj_load_init(e){
var type=(e&&e.type)?e.type.toLowerCase():"load";
if(arguments.callee.initialized||(type!="domcontentloaded"&&type!="load")){
return;
}
arguments.callee.initialized=true;
if(typeof (_timer)!="undefined"){
clearInterval(_timer);
delete _timer;
}
var _128=function(){
if(dojo.render.html.ie){
dojo.hostenv.makeWidgets();
}
};
if(dojo.hostenv.inFlightCount==0){
_128();
dojo.hostenv.modulesLoaded();
}else{
dojo.hostenv.modulesLoadedListeners.unshift(_128);
}
}
if(document.addEventListener){
if(dojo.render.html.opera||(dojo.render.html.moz&&!djConfig.delayMozLoadingFix)){
document.addEventListener("DOMContentLoaded",dj_load_init,null);
}
window.addEventListener("load",dj_load_init,null);
}
if(dojo.render.html.ie&&dojo.render.os.win){
document.attachEvent("onreadystatechange",function(e){
if(document.readyState=="complete"){
dj_load_init();
}
});
}
if(/(WebKit|khtml)/i.test(navigator.userAgent)){
var _timer=setInterval(function(){
if(/loaded|complete/.test(document.readyState)){
dj_load_init();
}
},10);
}
if(dojo.render.html.ie){
dj_addNodeEvtHdlr(window,"beforeunload",function(){
dojo.hostenv._unloading=true;
window.setTimeout(function(){
dojo.hostenv._unloading=false;
},0);
});
}
dj_addNodeEvtHdlr(window,"unload",function(){
dojo.hostenv.unloaded();
if((!dojo.render.html.ie)||(dojo.render.html.ie&&dojo.hostenv._unloading)){
dojo.hostenv.unloaded();
}
});
dojo.hostenv.makeWidgets=function(){
var sids=[];
if(djConfig.searchIds&&djConfig.searchIds.length>0){
sids=sids.concat(djConfig.searchIds);
}
if(dojo.hostenv.searchIds&&dojo.hostenv.searchIds.length>0){
sids=sids.concat(dojo.hostenv.searchIds);
}
if((djConfig.parseWidgets)||(sids.length>0)){
if(dojo.evalObjPath("dojo.widget.Parse")){
var _12b=new dojo.xml.Parse();
if(sids.length>0){
for(var x=0;x<sids.length;x++){
var _12d=document.getElementById(sids[x]);
if(!_12d){
continue;
}
var frag=_12b.parseElement(_12d,null,true);
dojo.widget.getParser().createComponents(frag);
}
}else{
if(djConfig.parseWidgets){
var frag=_12b.parseElement(dojo.body(),null,true);
dojo.widget.getParser().createComponents(frag);
}
}
}
}
};
dojo.addOnLoad(function(){
if(!dojo.render.html.ie){
dojo.hostenv.makeWidgets();
}
});
try{
if(dojo.render.html.ie){
document.namespaces.add("v","urn:schemas-microsoft-com:vml");
document.createStyleSheet().addRule("v\\:*","behavior:url(#default#VML)");
}
}
catch(e){
}
dojo.hostenv.writeIncludes=function(){
};
if(!dj_undef("document",this)){
dj_currentDocument=this.document;
}
dojo.doc=function(){
return dj_currentDocument;
};
dojo.body=function(){
return dojo.doc().body||dojo.doc().getElementsByTagName("body")[0];
};
dojo.byId=function(id,doc){
if((id)&&((typeof id=="string")||(id instanceof String))){
if(!doc){
doc=dj_currentDocument;
}
var ele=doc.getElementById(id);
if(ele&&(ele.id!=id)&&doc.all){
ele=null;
eles=doc.all[id];
if(eles){
if(eles.length){
for(var i=0;i<eles.length;i++){
if(eles[i].id==id){
ele=eles[i];
break;
}
}
}else{
ele=eles;
}
}
}
return ele;
}
return id;
};
dojo.setContext=function(_133,_134){
dj_currentContext=_133;
dj_currentDocument=_134;
};
dojo._fireCallback=function(_135,_136,_137){
if((_136)&&((typeof _135=="string")||(_135 instanceof String))){
_135=_136[_135];
}
return (_136?_135.apply(_136,_137||[]):_135());
};
dojo.withGlobal=function(_138,_139,_13a,_13b){
var rval;
var _13d=dj_currentContext;
var _13e=dj_currentDocument;
try{
dojo.setContext(_138,_138.document);
rval=dojo._fireCallback(_139,_13a,_13b);
}
finally{
dojo.setContext(_13d,_13e);
}
return rval;
};
dojo.withDoc=function(_13f,_140,_141,_142){
var rval;
var _144=dj_currentDocument;
try{
dj_currentDocument=_13f;
rval=dojo._fireCallback(_140,_141,_142);
}
finally{
dj_currentDocument=_144;
}
return rval;
};
}
(function(){
if(typeof dj_usingBootstrap!="undefined"){
return;
}
var _145=false;
var _146=false;
var _147=false;
if((typeof this["load"]=="function")&&((typeof this["Packages"]=="function")||(typeof this["Packages"]=="object"))){
_145=true;
}else{
if(typeof this["load"]=="function"){
_146=true;
}else{
if(window.widget){
_147=true;
}
}
}
var tmps=[];
if((this["djConfig"])&&((djConfig["isDebug"])||(djConfig["debugAtAllCosts"]))){
tmps.push("debug.js");
}
if((this["djConfig"])&&(djConfig["debugAtAllCosts"])&&(!_145)&&(!_147)){
tmps.push("browser_debug.js");
}
var _149=djConfig["baseScriptUri"];
if((this["djConfig"])&&(djConfig["baseLoaderUri"])){
_149=djConfig["baseLoaderUri"];
}
for(var x=0;x<tmps.length;x++){
var _14b=_149+"src/"+tmps[x];
if(_145||_146){
load(_14b);
}else{
try{
document.write("<scr"+"ipt type='text/javascript' src='"+_14b+"'></scr"+"ipt>");
}
catch(e){
var _14c=document.createElement("script");
_14c.src=_14b;
document.getElementsByTagName("head")[0].appendChild(_14c);
}
}
}
})();
dojo.provide("dojo.string.common");
dojo.string.trim=function(str,wh){
if(!str.replace){
return str;
}
if(!str.length){
return str;
}
var re=(wh>0)?(/^\s+/):(wh<0)?(/\s+$/):(/^\s+|\s+$/g);
return str.replace(re,"");
};
dojo.string.trimStart=function(str){
return dojo.string.trim(str,1);
};
dojo.string.trimEnd=function(str){
return dojo.string.trim(str,-1);
};
dojo.string.repeat=function(str,_153,_154){
var out="";
for(var i=0;i<_153;i++){
out+=str;
if(_154&&i<_153-1){
out+=_154;
}
}
return out;
};
dojo.string.pad=function(str,len,c,dir){
var out=String(str);
if(!c){
c="0";
}
if(!dir){
dir=1;
}
while(out.length<len){
if(dir>0){
out=c+out;
}else{
out+=c;
}
}
return out;
};
dojo.string.padLeft=function(str,len,c){
return dojo.string.pad(str,len,c,1);
};
dojo.string.padRight=function(str,len,c){
return dojo.string.pad(str,len,c,-1);
};
dojo.provide("dojo.string");
dojo.provide("dojo.lang.common");
dojo.lang.inherits=function(_162,_163){
if(!dojo.lang.isFunction(_163)){
dojo.raise("dojo.inherits: superclass argument ["+_163+"] must be a function (subclass: ["+_162+"']");
}
_162.prototype=new _163();
_162.prototype.constructor=_162;
_162.superclass=_163.prototype;
_162["super"]=_163.prototype;
};
dojo.lang._mixin=function(obj,_165){
var tobj={};
for(var x in _165){
if((typeof tobj[x]=="undefined")||(tobj[x]!=_165[x])){
obj[x]=_165[x];
}
}
if(dojo.render.html.ie&&(typeof (_165["toString"])=="function")&&(_165["toString"]!=obj["toString"])&&(_165["toString"]!=tobj["toString"])){
obj.toString=_165.toString;
}
return obj;
};
dojo.lang.mixin=function(obj,_169){
for(var i=1,l=arguments.length;i<l;i++){
dojo.lang._mixin(obj,arguments[i]);
}
return obj;
};
dojo.lang.extend=function(_16c,_16d){
for(var i=1,l=arguments.length;i<l;i++){
dojo.lang._mixin(_16c.prototype,arguments[i]);
}
return _16c;
};
dojo.inherits=dojo.lang.inherits;
dojo.mixin=dojo.lang.mixin;
dojo.extend=dojo.lang.extend;
dojo.lang.find=function(_170,_171,_172,_173){
if(!dojo.lang.isArrayLike(_170)&&dojo.lang.isArrayLike(_171)){
dojo.deprecated("dojo.lang.find(value, array)","use dojo.lang.find(array, value) instead","0.5");
var temp=_170;
_170=_171;
_171=temp;
}
var _175=dojo.lang.isString(_170);
if(_175){
_170=_170.split("");
}
if(_173){
var step=-1;
var i=_170.length-1;
var end=-1;
}else{
var step=1;
var i=0;
var end=_170.length;
}
if(_172){
while(i!=end){
if(_170[i]===_171){
return i;
}
i+=step;
}
}else{
while(i!=end){
if(_170[i]==_171){
return i;
}
i+=step;
}
}
return -1;
};
dojo.lang.indexOf=dojo.lang.find;
dojo.lang.findLast=function(_179,_17a,_17b){
return dojo.lang.find(_179,_17a,_17b,true);
};
dojo.lang.lastIndexOf=dojo.lang.findLast;
dojo.lang.inArray=function(_17c,_17d){
return dojo.lang.find(_17c,_17d)>-1;
};
dojo.lang.isObject=function(it){
if(typeof it=="undefined"){
return false;
}
return (typeof it=="object"||it===null||dojo.lang.isArray(it)||dojo.lang.isFunction(it));
};
dojo.lang.isArray=function(it){
return (it&&it instanceof Array||typeof it=="array");
};
dojo.lang.isArrayLike=function(it){
if((!it)||(dojo.lang.isUndefined(it))){
return false;
}
if(dojo.lang.isString(it)){
return false;
}
if(dojo.lang.isFunction(it)){
return false;
}
if(dojo.lang.isArray(it)){
return true;
}
if((it.tagName)&&(it.tagName.toLowerCase()=="form")){
return false;
}
if(dojo.lang.isNumber(it.length)&&isFinite(it.length)){
return true;
}
return false;
};
dojo.lang.isFunction=function(it){
return (it instanceof Function||typeof it=="function");
};
(function(){
if((dojo.render.html.capable)&&(dojo.render.html["safari"])){
dojo.lang.isFunction=function(it){
if((typeof (it)=="function")&&(it=="[object NodeList]")){
return false;
}
return (it instanceof Function||typeof it=="function");
};
}
})();
dojo.lang.isString=function(it){
return (typeof it=="string"||it instanceof String);
};
dojo.lang.isAlien=function(it){
if(!it){
return false;
}
return !dojo.lang.isFunction(it)&&/\{\s*\[native code\]\s*\}/.test(String(it));
};
dojo.lang.isBoolean=function(it){
return (it instanceof Boolean||typeof it=="boolean");
};
dojo.lang.isNumber=function(it){
return (it instanceof Number||typeof it=="number");
};
dojo.lang.isUndefined=function(it){
return ((typeof (it)=="undefined")&&(it==undefined));
};
dojo.provide("dojo.lang.extras");
dojo.lang.setTimeout=function(func,_189){
var _18a=window,_18b=2;
if(!dojo.lang.isFunction(func)){
_18a=func;
func=_189;
_189=arguments[2];
_18b++;
}
if(dojo.lang.isString(func)){
func=_18a[func];
}
var args=[];
for(var i=_18b;i<arguments.length;i++){
args.push(arguments[i]);
}
return dojo.global().setTimeout(function(){
func.apply(_18a,args);
},_189);
};
dojo.lang.clearTimeout=function(_18e){
dojo.global().clearTimeout(_18e);
};
dojo.lang.getNameInObj=function(ns,item){
if(!ns){
ns=dj_global;
}
for(var x in ns){
if(ns[x]===item){
return new String(x);
}
}
return null;
};
dojo.lang.shallowCopy=function(obj,deep){
var i,ret;
if(obj===null){
return null;
}
if(dojo.lang.isObject(obj)){
ret=new obj.constructor();
for(i in obj){
if(dojo.lang.isUndefined(ret[i])){
ret[i]=deep?dojo.lang.shallowCopy(obj[i],deep):obj[i];
}
}
}else{
if(dojo.lang.isArray(obj)){
ret=[];
for(i=0;i<obj.length;i++){
ret[i]=deep?dojo.lang.shallowCopy(obj[i],deep):obj[i];
}
}else{
ret=obj;
}
}
return ret;
};
dojo.lang.firstValued=function(){
for(var i=0;i<arguments.length;i++){
if(typeof arguments[i]!="undefined"){
return arguments[i];
}
}
return undefined;
};
dojo.lang.getObjPathValue=function(_197,_198,_199){
with(dojo.parseObjPath(_197,_198,_199)){
return dojo.evalProp(prop,obj,_199);
}
};
dojo.lang.setObjPathValue=function(_19a,_19b,_19c,_19d){
dojo.deprecated("dojo.lang.setObjPathValue","use dojo.parseObjPath and the '=' operator","0.6");
if(arguments.length<4){
_19d=true;
}
with(dojo.parseObjPath(_19a,_19c,_19d)){
if(obj&&(_19d||(prop in obj))){
obj[prop]=_19b;
}
}
};
dojo.provide("dojo.io.common");
dojo.io.transports=[];
dojo.io.hdlrFuncNames=["load","error","timeout"];
dojo.io.Request=function(url,_19f,_1a0,_1a1){
if((arguments.length==1)&&(arguments[0].constructor==Object)){
this.fromKwArgs(arguments[0]);
}else{
this.url=url;
if(_19f){
this.mimetype=_19f;
}
if(_1a0){
this.transport=_1a0;
}
if(arguments.length>=4){
this.changeUrl=_1a1;
}
}
};
dojo.lang.extend(dojo.io.Request,{url:"",mimetype:"text/plain",method:"GET",content:undefined,transport:undefined,changeUrl:undefined,formNode:undefined,sync:false,bindSuccess:false,useCache:false,preventCache:false,load:function(type,data,_1a4,_1a5){
},error:function(type,_1a7,_1a8,_1a9){
},timeout:function(type,_1ab,_1ac,_1ad){
},handle:function(type,data,_1b0,_1b1){
},timeoutSeconds:0,abort:function(){
},fromKwArgs:function(_1b2){
if(_1b2["url"]){
_1b2.url=_1b2.url.toString();
}
if(_1b2["formNode"]){
_1b2.formNode=dojo.byId(_1b2.formNode);
}
if(!_1b2["method"]&&_1b2["formNode"]&&_1b2["formNode"].method){
_1b2.method=_1b2["formNode"].method;
}
if(!_1b2["handle"]&&_1b2["handler"]){
_1b2.handle=_1b2.handler;
}
if(!_1b2["load"]&&_1b2["loaded"]){
_1b2.load=_1b2.loaded;
}
if(!_1b2["changeUrl"]&&_1b2["changeURL"]){
_1b2.changeUrl=_1b2.changeURL;
}
_1b2.encoding=dojo.lang.firstValued(_1b2["encoding"],djConfig["bindEncoding"],"");
_1b2.sendTransport=dojo.lang.firstValued(_1b2["sendTransport"],djConfig["ioSendTransport"],false);
var _1b3=dojo.lang.isFunction;
for(var x=0;x<dojo.io.hdlrFuncNames.length;x++){
var fn=dojo.io.hdlrFuncNames[x];
if(_1b2[fn]&&_1b3(_1b2[fn])){
continue;
}
if(_1b2["handle"]&&_1b3(_1b2["handle"])){
_1b2[fn]=_1b2.handle;
}
}
dojo.lang.mixin(this,_1b2);
}});
dojo.io.Error=function(msg,type,num){
this.message=msg;
this.type=type||"unknown";
this.number=num||0;
};
dojo.io.transports.addTransport=function(name){
this.push(name);
this[name]=dojo.io[name];
};
dojo.io.bind=function(_1ba){
if(!(_1ba instanceof dojo.io.Request)){
try{
_1ba=new dojo.io.Request(_1ba);
}
catch(e){
dojo.debug(e);
}
}
var _1bb="";
if(_1ba["transport"]){
_1bb=_1ba["transport"];
if(!this[_1bb]){
dojo.io.sendBindError(_1ba,"No dojo.io.bind() transport with name '"+_1ba["transport"]+"'.");
return _1ba;
}
if(!this[_1bb].canHandle(_1ba)){
dojo.io.sendBindError(_1ba,"dojo.io.bind() transport with name '"+_1ba["transport"]+"' cannot handle this type of request.");
return _1ba;
}
}else{
for(var x=0;x<dojo.io.transports.length;x++){
var tmp=dojo.io.transports[x];
if((this[tmp])&&(this[tmp].canHandle(_1ba))){
_1bb=tmp;
break;
}
}
if(_1bb==""){
dojo.io.sendBindError(_1ba,"None of the loaded transports for dojo.io.bind()"+" can handle the request.");
return _1ba;
}
}
this[_1bb].bind(_1ba);
_1ba.bindSuccess=true;
return _1ba;
};
dojo.io.sendBindError=function(_1be,_1bf){
if((typeof _1be.error=="function"||typeof _1be.handle=="function")&&(typeof setTimeout=="function"||typeof setTimeout=="object")){
var _1c0=new dojo.io.Error(_1bf);
setTimeout(function(){
_1be[(typeof _1be.error=="function")?"error":"handle"]("error",_1c0,null,_1be);
},50);
}else{
dojo.raise(_1bf);
}
};
dojo.io.queueBind=function(_1c1){
if(!(_1c1 instanceof dojo.io.Request)){
try{
_1c1=new dojo.io.Request(_1c1);
}
catch(e){
dojo.debug(e);
}
}
var _1c2=_1c1.load;
_1c1.load=function(){
dojo.io._queueBindInFlight=false;
var ret=_1c2.apply(this,arguments);
dojo.io._dispatchNextQueueBind();
return ret;
};
var _1c4=_1c1.error;
_1c1.error=function(){
dojo.io._queueBindInFlight=false;
var ret=_1c4.apply(this,arguments);
dojo.io._dispatchNextQueueBind();
return ret;
};
dojo.io._bindQueue.push(_1c1);
dojo.io._dispatchNextQueueBind();
return _1c1;
};
dojo.io._dispatchNextQueueBind=function(){
if(!dojo.io._queueBindInFlight){
dojo.io._queueBindInFlight=true;
if(dojo.io._bindQueue.length>0){
dojo.io.bind(dojo.io._bindQueue.shift());
}else{
dojo.io._queueBindInFlight=false;
}
}
};
dojo.io._bindQueue=[];
dojo.io._queueBindInFlight=false;
dojo.io.argsFromMap=function(map,_1c7,last){
var enc=/utf/i.test(_1c7||"")?encodeURIComponent:dojo.string.encodeAscii;
var _1ca=[];
var _1cb=new Object();
for(var name in map){
var _1cd=function(elt){
var val=enc(name)+"="+enc(elt);
_1ca[(last==name)?"push":"unshift"](val);
};
if(!_1cb[name]){
var _1d0=map[name];
if(dojo.lang.isArray(_1d0)){
dojo.lang.forEach(_1d0,_1cd);
}else{
_1cd(_1d0);
}
}
}
return _1ca.join("&");
};
dojo.io.setIFrameSrc=function(_1d1,src,_1d3){
try{
var r=dojo.render.html;
if(!_1d3){
if(r.safari){
_1d1.location=src;
}else{
frames[_1d1.name].location=src;
}
}else{
var idoc;
if(r.ie){
idoc=_1d1.contentWindow.document;
}else{
if(r.safari){
idoc=_1d1.document;
}else{
idoc=_1d1.contentWindow;
}
}
if(!idoc){
_1d1.location=src;
return;
}else{
idoc.location.replace(src);
}
}
}
catch(e){
dojo.debug(e);
dojo.debug("setIFrameSrc: "+e);
}
};
dojo.provide("dojo.lang.array");
dojo.lang.mixin(dojo.lang,{has:function(obj,name){
try{
return typeof obj[name]!="undefined";
}
catch(e){
return false;
}
},isEmpty:function(obj){
if(dojo.lang.isObject(obj)){
var tmp={};
var _1da=0;
for(var x in obj){
if(obj[x]&&(!tmp[x])){
_1da++;
break;
}
}
return _1da==0;
}else{
if(dojo.lang.isArrayLike(obj)||dojo.lang.isString(obj)){
return obj.length==0;
}
}
},map:function(arr,obj,_1de){
var _1df=dojo.lang.isString(arr);
if(_1df){
arr=arr.split("");
}
if(dojo.lang.isFunction(obj)&&(!_1de)){
_1de=obj;
obj=dj_global;
}else{
if(dojo.lang.isFunction(obj)&&_1de){
var _1e0=obj;
obj=_1de;
_1de=_1e0;
}
}
if(Array.map){
var _1e1=Array.map(arr,_1de,obj);
}else{
var _1e1=[];
for(var i=0;i<arr.length;++i){
_1e1.push(_1de.call(obj,arr[i]));
}
}
if(_1df){
return _1e1.join("");
}else{
return _1e1;
}
},reduce:function(arr,_1e4,obj,_1e6){
var _1e7=_1e4;
if(arguments.length==1){
dojo.debug("dojo.lang.reduce called with too few arguments!");
return false;
}else{
if(arguments.length==2){
_1e6=_1e4;
_1e7=arr.shift();
}else{
if(arguments.lenght==3){
if(dojo.lang.isFunction(obj)){
_1e6=obj;
obj=null;
}
}else{
if(dojo.lang.isFunction(obj)){
var tmp=_1e6;
_1e6=obj;
obj=tmp;
}
}
}
}
var ob=obj?obj:dj_global;
dojo.lang.map(arr,function(val){
_1e7=_1e6.call(ob,_1e7,val);
});
return _1e7;
},forEach:function(_1eb,_1ec,_1ed){
if(dojo.lang.isString(_1eb)){
_1eb=_1eb.split("");
}
if(Array.forEach){
Array.forEach(_1eb,_1ec,_1ed);
}else{
if(!_1ed){
_1ed=dj_global;
}
for(var i=0,l=_1eb.length;i<l;i++){
_1ec.call(_1ed,_1eb[i],i,_1eb);
}
}
},_everyOrSome:function(_1f0,arr,_1f2,_1f3){
if(dojo.lang.isString(arr)){
arr=arr.split("");
}
if(Array.every){
return Array[_1f0?"every":"some"](arr,_1f2,_1f3);
}else{
if(!_1f3){
_1f3=dj_global;
}
for(var i=0,l=arr.length;i<l;i++){
var _1f6=_1f2.call(_1f3,arr[i],i,arr);
if(_1f0&&!_1f6){
return false;
}else{
if((!_1f0)&&(_1f6)){
return true;
}
}
}
return Boolean(_1f0);
}
},every:function(arr,_1f8,_1f9){
return this._everyOrSome(true,arr,_1f8,_1f9);
},some:function(arr,_1fb,_1fc){
return this._everyOrSome(false,arr,_1fb,_1fc);
},filter:function(arr,_1fe,_1ff){
var _200=dojo.lang.isString(arr);
if(_200){
arr=arr.split("");
}
var _201;
if(Array.filter){
_201=Array.filter(arr,_1fe,_1ff);
}else{
if(!_1ff){
if(arguments.length>=3){
dojo.raise("thisObject doesn't exist!");
}
_1ff=dj_global;
}
_201=[];
for(var i=0;i<arr.length;i++){
if(_1fe.call(_1ff,arr[i],i,arr)){
_201.push(arr[i]);
}
}
}
if(_200){
return _201.join("");
}else{
return _201;
}
},unnest:function(){
var out=[];
for(var i=0;i<arguments.length;i++){
if(dojo.lang.isArrayLike(arguments[i])){
var add=dojo.lang.unnest.apply(this,arguments[i]);
out=out.concat(add);
}else{
out.push(arguments[i]);
}
}
return out;
},toArray:function(_206,_207){
var _208=[];
for(var i=_207||0;i<_206.length;i++){
_208.push(_206[i]);
}
return _208;
}});
dojo.provide("dojo.lang.func");
dojo.lang.hitch=function(_20a,_20b){
var fcn=(dojo.lang.isString(_20b)?_20a[_20b]:_20b)||function(){
};
return function(){
return fcn.apply(_20a,arguments);
};
};
dojo.lang.anonCtr=0;
dojo.lang.anon={};
dojo.lang.nameAnonFunc=function(_20d,_20e,_20f){
var nso=(_20e||dojo.lang.anon);
if((_20f)||((dj_global["djConfig"])&&(djConfig["slowAnonFuncLookups"]==true))){
for(var x in nso){
try{
if(nso[x]===_20d){
return x;
}
}
catch(e){
}
}
}
var ret="__"+dojo.lang.anonCtr++;
while(typeof nso[ret]!="undefined"){
ret="__"+dojo.lang.anonCtr++;
}
nso[ret]=_20d;
return ret;
};
dojo.lang.forward=function(_213){
return function(){
return this[_213].apply(this,arguments);
};
};
dojo.lang.curry=function(_214,func){
var _216=[];
_214=_214||dj_global;
if(dojo.lang.isString(func)){
func=_214[func];
}
for(var x=2;x<arguments.length;x++){
_216.push(arguments[x]);
}
var _218=(func["__preJoinArity"]||func.length)-_216.length;
function gather(_219,_21a,_21b){
var _21c=_21b;
var _21d=_21a.slice(0);
for(var x=0;x<_219.length;x++){
_21d.push(_219[x]);
}
_21b=_21b-_219.length;
if(_21b<=0){
var res=func.apply(_214,_21d);
_21b=_21c;
return res;
}else{
return function(){
return gather(arguments,_21d,_21b);
};
}
}
return gather([],_216,_218);
};
dojo.lang.curryArguments=function(_220,func,args,_223){
var _224=[];
var x=_223||0;
for(x=_223;x<args.length;x++){
_224.push(args[x]);
}
return dojo.lang.curry.apply(dojo.lang,[_220,func].concat(_224));
};
dojo.lang.tryThese=function(){
for(var x=0;x<arguments.length;x++){
try{
if(typeof arguments[x]=="function"){
var ret=(arguments[x]());
if(ret){
return ret;
}
}
}
catch(e){
dojo.debug(e);
}
}
};
dojo.lang.delayThese=function(farr,cb,_22a,_22b){
if(!farr.length){
if(typeof _22b=="function"){
_22b();
}
return;
}
if((typeof _22a=="undefined")&&(typeof cb=="number")){
_22a=cb;
cb=function(){
};
}else{
if(!cb){
cb=function(){
};
if(!_22a){
_22a=0;
}
}
}
setTimeout(function(){
(farr.shift())();
cb();
dojo.lang.delayThese(farr,cb,_22a,_22b);
},_22a);
};
dojo.provide("dojo.string.extras");
dojo.string.substituteParams=function(_22c,hash){
var map=(typeof hash=="object")?hash:dojo.lang.toArray(arguments,1);
return _22c.replace(/\%\{(\w+)\}/g,function(_22f,key){
if(typeof (map[key])!="undefined"&&map[key]!=null){
return map[key];
}
dojo.raise("Substitution not found: "+key);
});
};
dojo.string.capitalize=function(str){
if(!dojo.lang.isString(str)){
return "";
}
if(arguments.length==0){
str=this;
}
var _232=str.split(" ");
for(var i=0;i<_232.length;i++){
_232[i]=_232[i].charAt(0).toUpperCase()+_232[i].substring(1);
}
return _232.join(" ");
};
dojo.string.isBlank=function(str){
if(!dojo.lang.isString(str)){
return true;
}
return (dojo.string.trim(str).length==0);
};
dojo.string.encodeAscii=function(str){
if(!dojo.lang.isString(str)){
return str;
}
var ret="";
var _237=escape(str);
var _238,re=/%u([0-9A-F]{4})/i;
while((_238=_237.match(re))){
var num=Number("0x"+_238[1]);
var _23b=escape("&#"+num+";");
ret+=_237.substring(0,_238.index)+_23b;
_237=_237.substring(_238.index+_238[0].length);
}
ret+=_237.replace(/\+/g,"%2B");
return ret;
};
dojo.string.escape=function(type,str){
var args=dojo.lang.toArray(arguments,1);
switch(type.toLowerCase()){
case "xml":
case "html":
case "xhtml":
return dojo.string.escapeXml.apply(this,args);
case "sql":
return dojo.string.escapeSql.apply(this,args);
case "regexp":
case "regex":
return dojo.string.escapeRegExp.apply(this,args);
case "javascript":
case "jscript":
case "js":
return dojo.string.escapeJavaScript.apply(this,args);
case "ascii":
return dojo.string.encodeAscii.apply(this,args);
default:
return str;
}
};
dojo.string.escapeXml=function(str,_240){
str=str.replace(/&/gm,"&amp;").replace(/</gm,"&lt;").replace(/>/gm,"&gt;").replace(/"/gm,"&quot;");
if(!_240){
str=str.replace(/'/gm,"&#39;");
}
return str;
};
dojo.string.escapeSql=function(str){
return str.replace(/'/gm,"''");
};
dojo.string.escapeRegExp=function(str){
return str.replace(/\\/gm,"\\\\").replace(/([\f\b\n\t\r[\^$|?*+(){}])/gm,"\\$1");
};
dojo.string.escapeJavaScript=function(str){
return str.replace(/(["'\f\b\n\t\r])/gm,"\\$1");
};
dojo.string.escapeString=function(str){
return ("\""+str.replace(/(["\\])/g,"\\$1")+"\"").replace(/[\f]/g,"\\f").replace(/[\b]/g,"\\b").replace(/[\n]/g,"\\n").replace(/[\t]/g,"\\t").replace(/[\r]/g,"\\r");
};
dojo.string.summary=function(str,len){
if(!len||str.length<=len){
return str;
}
return str.substring(0,len).replace(/\.+$/,"")+"...";
};
dojo.string.endsWith=function(str,end,_249){
if(_249){
str=str.toLowerCase();
end=end.toLowerCase();
}
if((str.length-end.length)<0){
return false;
}
return str.lastIndexOf(end)==str.length-end.length;
};
dojo.string.endsWithAny=function(str){
for(var i=1;i<arguments.length;i++){
if(dojo.string.endsWith(str,arguments[i])){
return true;
}
}
return false;
};
dojo.string.startsWith=function(str,_24d,_24e){
if(_24e){
str=str.toLowerCase();
_24d=_24d.toLowerCase();
}
return str.indexOf(_24d)==0;
};
dojo.string.startsWithAny=function(str){
for(var i=1;i<arguments.length;i++){
if(dojo.string.startsWith(str,arguments[i])){
return true;
}
}
return false;
};
dojo.string.has=function(str){
for(var i=1;i<arguments.length;i++){
if(str.indexOf(arguments[i])>-1){
return true;
}
}
return false;
};
dojo.string.normalizeNewlines=function(text,_254){
if(_254=="\n"){
text=text.replace(/\r\n/g,"\n");
text=text.replace(/\r/g,"\n");
}else{
if(_254=="\r"){
text=text.replace(/\r\n/g,"\r");
text=text.replace(/\n/g,"\r");
}else{
text=text.replace(/([^\r])\n/g,"$1\r\n").replace(/\r([^\n])/g,"\r\n$1");
}
}
return text;
};
dojo.string.splitEscaped=function(str,_256){
var _257=[];
for(var i=0,_259=0;i<str.length;i++){
if(str.charAt(i)=="\\"){
i++;
continue;
}
if(str.charAt(i)==_256){
_257.push(str.substring(_259,i));
_259=i+1;
}
}
_257.push(str.substr(_259));
return _257;
};
dojo.provide("dojo.dom");
dojo.dom.ELEMENT_NODE=1;
dojo.dom.ATTRIBUTE_NODE=2;
dojo.dom.TEXT_NODE=3;
dojo.dom.CDATA_SECTION_NODE=4;
dojo.dom.ENTITY_REFERENCE_NODE=5;
dojo.dom.ENTITY_NODE=6;
dojo.dom.PROCESSING_INSTRUCTION_NODE=7;
dojo.dom.COMMENT_NODE=8;
dojo.dom.DOCUMENT_NODE=9;
dojo.dom.DOCUMENT_TYPE_NODE=10;
dojo.dom.DOCUMENT_FRAGMENT_NODE=11;
dojo.dom.NOTATION_NODE=12;
dojo.dom.dojoml="http://www.dojotoolkit.org/2004/dojoml";
dojo.dom.xmlns={svg:"http://www.w3.org/2000/svg",smil:"http://www.w3.org/2001/SMIL20/",mml:"http://www.w3.org/1998/Math/MathML",cml:"http://www.xml-cml.org",xlink:"http://www.w3.org/1999/xlink",xhtml:"http://www.w3.org/1999/xhtml",xul:"http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul",xbl:"http://www.mozilla.org/xbl",fo:"http://www.w3.org/1999/XSL/Format",xsl:"http://www.w3.org/1999/XSL/Transform",xslt:"http://www.w3.org/1999/XSL/Transform",xi:"http://www.w3.org/2001/XInclude",xforms:"http://www.w3.org/2002/01/xforms",saxon:"http://icl.com/saxon",xalan:"http://xml.apache.org/xslt",xsd:"http://www.w3.org/2001/XMLSchema",dt:"http://www.w3.org/2001/XMLSchema-datatypes",xsi:"http://www.w3.org/2001/XMLSchema-instance",rdf:"http://www.w3.org/1999/02/22-rdf-syntax-ns#",rdfs:"http://www.w3.org/2000/01/rdf-schema#",dc:"http://purl.org/dc/elements/1.1/",dcq:"http://purl.org/dc/qualifiers/1.0","soap-env":"http://schemas.xmlsoap.org/soap/envelope/",wsdl:"http://schemas.xmlsoap.org/wsdl/",AdobeExtensions:"http://ns.adobe.com/AdobeSVGViewerExtensions/3.0/"};
dojo.dom.isNode=function(wh){
if(typeof Element=="function"){
try{
return wh instanceof Element;
}
catch(e){
}
}else{
return wh&&!isNaN(wh.nodeType);
}
};
dojo.dom.getUniqueId=function(){
var _25b=dojo.doc();
do{
var id="dj_unique_"+(++arguments.callee._idIncrement);
}while(_25b.getElementById(id));
return id;
};
dojo.dom.getUniqueId._idIncrement=0;
dojo.dom.firstElement=dojo.dom.getFirstChildElement=function(_25d,_25e){
var node=_25d.firstChild;
while(node&&node.nodeType!=dojo.dom.ELEMENT_NODE){
node=node.nextSibling;
}
if(_25e&&node&&node.tagName&&node.tagName.toLowerCase()!=_25e.toLowerCase()){
node=dojo.dom.nextElement(node,_25e);
}
return node;
};
dojo.dom.lastElement=dojo.dom.getLastChildElement=function(_260,_261){
var node=_260.lastChild;
while(node&&node.nodeType!=dojo.dom.ELEMENT_NODE){
node=node.previousSibling;
}
if(_261&&node&&node.tagName&&node.tagName.toLowerCase()!=_261.toLowerCase()){
node=dojo.dom.prevElement(node,_261);
}
return node;
};
dojo.dom.nextElement=dojo.dom.getNextSiblingElement=function(node,_264){
if(!node){
return null;
}
do{
node=node.nextSibling;
}while(node&&node.nodeType!=dojo.dom.ELEMENT_NODE);
if(node&&_264&&_264.toLowerCase()!=node.tagName.toLowerCase()){
return dojo.dom.nextElement(node,_264);
}
return node;
};
dojo.dom.prevElement=dojo.dom.getPreviousSiblingElement=function(node,_266){
if(!node){
return null;
}
if(_266){
_266=_266.toLowerCase();
}
do{
node=node.previousSibling;
}while(node&&node.nodeType!=dojo.dom.ELEMENT_NODE);
if(node&&_266&&_266.toLowerCase()!=node.tagName.toLowerCase()){
return dojo.dom.prevElement(node,_266);
}
return node;
};
dojo.dom.moveChildren=function(_267,_268,trim){
var _26a=0;
if(trim){
while(_267.hasChildNodes()&&_267.firstChild.nodeType==dojo.dom.TEXT_NODE){
_267.removeChild(_267.firstChild);
}
while(_267.hasChildNodes()&&_267.lastChild.nodeType==dojo.dom.TEXT_NODE){
_267.removeChild(_267.lastChild);
}
}
while(_267.hasChildNodes()){
_268.appendChild(_267.firstChild);
_26a++;
}
return _26a;
};
dojo.dom.copyChildren=function(_26b,_26c,trim){
var _26e=_26b.cloneNode(true);
return this.moveChildren(_26e,_26c,trim);
};
dojo.dom.replaceChildren=function(node,_270){
var _271=[];
if(dojo.render.html.ie){
for(var i=0;i<node.childNodes.length;i++){
_271.push(node.childNodes[i]);
}
}
dojo.dom.removeChildren(node);
node.appendChild(_270);
for(var i=0;i<_271.length;i++){
dojo.dom.destroyNode(_271[i]);
}
};
dojo.dom.removeChildren=function(node){
var _274=node.childNodes.length;
while(node.hasChildNodes()){
dojo.dom.removeNode(node.firstChild);
}
return _274;
};
dojo.dom.replaceNode=function(node,_276){
return node.parentNode.replaceChild(_276,node);
};
dojo.dom.destroyNode=function(node){
if(node.parentNode){
node=dojo.dom.removeNode(node);
}
if(node.nodeType!=3){
if(dojo.evalObjPath("dojo.event.browser.clean",false)){
dojo.event.browser.clean(node);
}
if(dojo.render.html.ie){
node.outerHTML="";
}
}
};
dojo.dom.removeNode=function(node){
if(node&&node.parentNode){
return node.parentNode.removeChild(node);
}
};
dojo.dom.getAncestors=function(node,_27a,_27b){
var _27c=[];
var _27d=(_27a&&(_27a instanceof Function||typeof _27a=="function"));
while(node){
if(!_27d||_27a(node)){
_27c.push(node);
}
if(_27b&&_27c.length>0){
return _27c[0];
}
node=node.parentNode;
}
if(_27b){
return null;
}
return _27c;
};
dojo.dom.getAncestorsByTag=function(node,tag,_280){
tag=tag.toLowerCase();
return dojo.dom.getAncestors(node,function(el){
return ((el.tagName)&&(el.tagName.toLowerCase()==tag));
},_280);
};
dojo.dom.getFirstAncestorByTag=function(node,tag){
return dojo.dom.getAncestorsByTag(node,tag,true);
};
dojo.dom.isDescendantOf=function(node,_285,_286){
if(_286&&node){
node=node.parentNode;
}
while(node){
if(node==_285){
return true;
}
node=node.parentNode;
}
return false;
};
dojo.dom.innerXML=function(node){
if(node.innerXML){
return node.innerXML;
}else{
if(node.xml){
return node.xml;
}else{
if(typeof XMLSerializer!="undefined"){
return (new XMLSerializer()).serializeToString(node);
}
}
}
};
dojo.dom.createDocument=function(){
var doc=null;
var _289=dojo.doc();
if(!dj_undef("ActiveXObject")){
var _28a=["MSXML2","Microsoft","MSXML","MSXML3"];
for(var i=0;i<_28a.length;i++){
try{
doc=new ActiveXObject(_28a[i]+".XMLDOM");
}
catch(e){
}
if(doc){
break;
}
}
}else{
if((_289.implementation)&&(_289.implementation.createDocument)){
doc=_289.implementation.createDocument("","",null);
}
}
return doc;
};
dojo.dom.createDocumentFromText=function(str,_28d){
if(!_28d){
_28d="text/xml";
}
if(!dj_undef("DOMParser")){
var _28e=new DOMParser();
return _28e.parseFromString(str,_28d);
}else{
if(!dj_undef("ActiveXObject")){
var _28f=dojo.dom.createDocument();
if(_28f){
_28f.async=false;
_28f.loadXML(str);
return _28f;
}else{
dojo.debug("toXml didn't work?");
}
}else{
var _290=dojo.doc();
if(_290.createElement){
var tmp=_290.createElement("xml");
tmp.innerHTML=str;
if(_290.implementation&&_290.implementation.createDocument){
var _292=_290.implementation.createDocument("foo","",null);
for(var i=0;i<tmp.childNodes.length;i++){
_292.importNode(tmp.childNodes.item(i),true);
}
return _292;
}
return ((tmp.document)&&(tmp.document.firstChild?tmp.document.firstChild:tmp));
}
}
}
return null;
};
dojo.dom.prependChild=function(node,_295){
if(_295.firstChild){
_295.insertBefore(node,_295.firstChild);
}else{
_295.appendChild(node);
}
return true;
};
dojo.dom.insertBefore=function(node,ref,_298){
if((_298!=true)&&(node===ref||node.nextSibling===ref)){
return false;
}
var _299=ref.parentNode;
_299.insertBefore(node,ref);
return true;
};
dojo.dom.insertAfter=function(node,ref,_29c){
var pn=ref.parentNode;
if(ref==pn.lastChild){
if((_29c!=true)&&(node===ref)){
return false;
}
pn.appendChild(node);
}else{
return this.insertBefore(node,ref.nextSibling,_29c);
}
return true;
};
dojo.dom.insertAtPosition=function(node,ref,_2a0){
if((!node)||(!ref)||(!_2a0)){
return false;
}
switch(_2a0.toLowerCase()){
case "before":
return dojo.dom.insertBefore(node,ref);
case "after":
return dojo.dom.insertAfter(node,ref);
case "first":
if(ref.firstChild){
return dojo.dom.insertBefore(node,ref.firstChild);
}else{
ref.appendChild(node);
return true;
}
break;
default:
ref.appendChild(node);
return true;
}
};
dojo.dom.insertAtIndex=function(node,_2a2,_2a3){
var _2a4=_2a2.childNodes;
if(!_2a4.length||_2a4.length==_2a3){
_2a2.appendChild(node);
return true;
}
if(_2a3==0){
return dojo.dom.prependChild(node,_2a2);
}
return dojo.dom.insertAfter(node,_2a4[_2a3-1]);
};
dojo.dom.textContent=function(node,text){
if(arguments.length>1){
var _2a7=dojo.doc();
dojo.dom.replaceChildren(node,_2a7.createTextNode(text));
return text;
}else{
if(node.textContent!=undefined){
return node.textContent;
}
var _2a8="";
if(node==null){
return _2a8;
}
for(var i=0;i<node.childNodes.length;i++){
switch(node.childNodes[i].nodeType){
case 1:
case 5:
_2a8+=dojo.dom.textContent(node.childNodes[i]);
break;
case 3:
case 2:
case 4:
_2a8+=node.childNodes[i].nodeValue;
break;
default:
break;
}
}
return _2a8;
}
};
dojo.dom.hasParent=function(node){
return Boolean(node&&node.parentNode&&dojo.dom.isNode(node.parentNode));
};
dojo.dom.isTag=function(node){
if(node&&node.tagName){
for(var i=1;i<arguments.length;i++){
if(node.tagName==String(arguments[i])){
return String(arguments[i]);
}
}
}
return "";
};
dojo.dom.setAttributeNS=function(elem,_2ae,_2af,_2b0){
if(elem==null||((elem==undefined)&&(typeof elem=="undefined"))){
dojo.raise("No element given to dojo.dom.setAttributeNS");
}
if(!((elem.setAttributeNS==undefined)&&(typeof elem.setAttributeNS=="undefined"))){
elem.setAttributeNS(_2ae,_2af,_2b0);
}else{
var _2b1=elem.ownerDocument;
var _2b2=_2b1.createNode(2,_2af,_2ae);
_2b2.nodeValue=_2b0;
elem.setAttributeNode(_2b2);
}
};
dojo.provide("dojo.undo.browser");
try{
if((!djConfig["preventBackButtonFix"])&&(!dojo.hostenv.post_load_)){
document.write("<iframe style='border: 0px; width: 1px; height: 1px; position: absolute; bottom: 0px; right: 0px; visibility: visible;' name='djhistory' id='djhistory' src='"+(dojo.hostenv.getBaseScriptUri()+"iframe_history.html")+"'></iframe>");
}
}
catch(e){
}
if(dojo.render.html.opera){
dojo.debug("Opera is not supported with dojo.undo.browser, so back/forward detection will not work.");
}
dojo.undo.browser={initialHref:(!dj_undef("window"))?window.location.href:"",initialHash:(!dj_undef("window"))?window.location.hash:"",moveForward:false,historyStack:[],forwardStack:[],historyIframe:null,bookmarkAnchor:null,locationTimer:null,setInitialState:function(args){
this.initialState=this._createState(this.initialHref,args,this.initialHash);
},addToHistory:function(args){
this.forwardStack=[];
var hash=null;
var url=null;
if(!this.historyIframe){
this.historyIframe=window.frames["djhistory"];
}
if(!this.bookmarkAnchor){
this.bookmarkAnchor=document.createElement("a");
dojo.body().appendChild(this.bookmarkAnchor);
this.bookmarkAnchor.style.display="none";
}
if(args["changeUrl"]){
hash="#"+((args["changeUrl"]!==true)?args["changeUrl"]:(new Date()).getTime());
if(this.historyStack.length==0&&this.initialState.urlHash==hash){
this.initialState=this._createState(url,args,hash);
return;
}else{
if(this.historyStack.length>0&&this.historyStack[this.historyStack.length-1].urlHash==hash){
this.historyStack[this.historyStack.length-1]=this._createState(url,args,hash);
return;
}
}
this.changingUrl=true;
setTimeout("window.location.href = '"+hash+"'; dojo.undo.browser.changingUrl = false;",1);
this.bookmarkAnchor.href=hash;
if(dojo.render.html.ie){
url=this._loadIframeHistory();
var _2b7=args["back"]||args["backButton"]||args["handle"];
var tcb=function(_2b9){
if(window.location.hash!=""){
setTimeout("window.location.href = '"+hash+"';",1);
}
_2b7.apply(this,[_2b9]);
};
if(args["back"]){
args.back=tcb;
}else{
if(args["backButton"]){
args.backButton=tcb;
}else{
if(args["handle"]){
args.handle=tcb;
}
}
}
var _2ba=args["forward"]||args["forwardButton"]||args["handle"];
var tfw=function(_2bc){
if(window.location.hash!=""){
window.location.href=hash;
}
if(_2ba){
_2ba.apply(this,[_2bc]);
}
};
if(args["forward"]){
args.forward=tfw;
}else{
if(args["forwardButton"]){
args.forwardButton=tfw;
}else{
if(args["handle"]){
args.handle=tfw;
}
}
}
}else{
if(dojo.render.html.moz){
if(!this.locationTimer){
this.locationTimer=setInterval("dojo.undo.browser.checkLocation();",200);
}
}
}
}else{
url=this._loadIframeHistory();
}
this.historyStack.push(this._createState(url,args,hash));
},checkLocation:function(){
if(!this.changingUrl){
var hsl=this.historyStack.length;
if((window.location.hash==this.initialHash||window.location.href==this.initialHref)&&(hsl==1)){
this.handleBackButton();
return;
}
if(this.forwardStack.length>0){
if(this.forwardStack[this.forwardStack.length-1].urlHash==window.location.hash){
this.handleForwardButton();
return;
}
}
if((hsl>=2)&&(this.historyStack[hsl-2])){
if(this.historyStack[hsl-2].urlHash==window.location.hash){
this.handleBackButton();
return;
}
}
}
},iframeLoaded:function(evt,_2bf){
if(!dojo.render.html.opera){
var _2c0=this._getUrlQuery(_2bf.href);
if(_2c0==null){
if(this.historyStack.length==1){
this.handleBackButton();
}
return;
}
if(this.moveForward){
this.moveForward=false;
return;
}
if(this.historyStack.length>=2&&_2c0==this._getUrlQuery(this.historyStack[this.historyStack.length-2].url)){
this.handleBackButton();
}else{
if(this.forwardStack.length>0&&_2c0==this._getUrlQuery(this.forwardStack[this.forwardStack.length-1].url)){
this.handleForwardButton();
}
}
}
},handleBackButton:function(){
var _2c1=this.historyStack.pop();
if(!_2c1){
return;
}
var last=this.historyStack[this.historyStack.length-1];
if(!last&&this.historyStack.length==0){
last=this.initialState;
}
if(last){
if(last.kwArgs["back"]){
last.kwArgs["back"]();
}else{
if(last.kwArgs["backButton"]){
last.kwArgs["backButton"]();
}else{
if(last.kwArgs["handle"]){
last.kwArgs.handle("back");
}
}
}
}
this.forwardStack.push(_2c1);
},handleForwardButton:function(){
var last=this.forwardStack.pop();
if(!last){
return;
}
if(last.kwArgs["forward"]){
last.kwArgs.forward();
}else{
if(last.kwArgs["forwardButton"]){
last.kwArgs.forwardButton();
}else{
if(last.kwArgs["handle"]){
last.kwArgs.handle("forward");
}
}
}
this.historyStack.push(last);
},_createState:function(url,args,hash){
return {"url":url,"kwArgs":args,"urlHash":hash};
},_getUrlQuery:function(url){
var _2c8=url.split("?");
if(_2c8.length<2){
return null;
}else{
return _2c8[1];
}
},_loadIframeHistory:function(){
var url=dojo.hostenv.getBaseScriptUri()+"iframe_history.html?"+(new Date()).getTime();
this.moveForward=true;
dojo.io.setIFrameSrc(this.historyIframe,url,false);
return url;
}};
dojo.provide("dojo.io.BrowserIO");
if(!dj_undef("window")){
dojo.io.checkChildrenForFile=function(node){
var _2cb=false;
var _2cc=node.getElementsByTagName("input");
dojo.lang.forEach(_2cc,function(_2cd){
if(_2cb){
return;
}
if(_2cd.getAttribute("type")=="file"){
_2cb=true;
}
});
return _2cb;
};
dojo.io.formHasFile=function(_2ce){
return dojo.io.checkChildrenForFile(_2ce);
};
dojo.io.updateNode=function(node,_2d0){
node=dojo.byId(node);
var args=_2d0;
if(dojo.lang.isString(_2d0)){
args={url:_2d0};
}
args.mimetype="text/html";
args.load=function(t,d,e){
while(node.firstChild){
dojo.dom.destroyNode(node.firstChild);
}
node.innerHTML=d;
};
dojo.io.bind(args);
};
dojo.io.formFilter=function(node){
var type=(node.type||"").toLowerCase();
return !node.disabled&&node.name&&!dojo.lang.inArray(["file","submit","image","reset","button"],type);
};
dojo.io.encodeForm=function(_2d7,_2d8,_2d9){
if((!_2d7)||(!_2d7.tagName)||(!_2d7.tagName.toLowerCase()=="form")){
dojo.raise("Attempted to encode a non-form element.");
}
if(!_2d9){
_2d9=dojo.io.formFilter;
}
var enc=/utf/i.test(_2d8||"")?encodeURIComponent:dojo.string.encodeAscii;
var _2db=[];
for(var i=0;i<_2d7.elements.length;i++){
var elm=_2d7.elements[i];
if(!elm||elm.tagName.toLowerCase()=="fieldset"||!_2d9(elm)){
continue;
}
var name=enc(elm.name);
var type=elm.type.toLowerCase();
if(type=="select-multiple"){
for(var j=0;j<elm.options.length;j++){
if(elm.options[j].selected){
_2db.push(name+"="+enc(elm.options[j].value));
}
}
}else{
if(dojo.lang.inArray(["radio","checkbox"],type)){
if(elm.checked){
_2db.push(name+"="+enc(elm.value));
}
}else{
_2db.push(name+"="+enc(elm.value));
}
}
}
var _2e1=_2d7.getElementsByTagName("input");
for(var i=0;i<_2e1.length;i++){
var _2e2=_2e1[i];
if(_2e2.type.toLowerCase()=="image"&&_2e2.form==_2d7&&_2d9(_2e2)){
var name=enc(_2e2.name);
_2db.push(name+"="+enc(_2e2.value));
_2db.push(name+".x=0");
_2db.push(name+".y=0");
}
}
return _2db.join("&")+"&";
};
dojo.io.FormBind=function(args){
this.bindArgs={};
if(args&&args.formNode){
this.init(args);
}else{
if(args){
this.init({formNode:args});
}
}
};
dojo.lang.extend(dojo.io.FormBind,{form:null,bindArgs:null,clickedButton:null,init:function(args){
var form=dojo.byId(args.formNode);
if(!form||!form.tagName||form.tagName.toLowerCase()!="form"){
throw new Error("FormBind: Couldn't apply, invalid form");
}else{
if(this.form==form){
return;
}else{
if(this.form){
throw new Error("FormBind: Already applied to a form");
}
}
}
dojo.lang.mixin(this.bindArgs,args);
this.form=form;
this.connect(form,"onsubmit","submit");
for(var i=0;i<form.elements.length;i++){
var node=form.elements[i];
if(node&&node.type&&dojo.lang.inArray(["submit","button"],node.type.toLowerCase())){
this.connect(node,"onclick","click");
}
}
var _2e8=form.getElementsByTagName("input");
for(var i=0;i<_2e8.length;i++){
var _2e9=_2e8[i];
if(_2e9.type.toLowerCase()=="image"&&_2e9.form==form){
this.connect(_2e9,"onclick","click");
}
}
},onSubmit:function(form){
return true;
},submit:function(e){
e.preventDefault();
if(this.onSubmit(this.form)){
dojo.io.bind(dojo.lang.mixin(this.bindArgs,{formFilter:dojo.lang.hitch(this,"formFilter")}));
}
},click:function(e){
var node=e.currentTarget;
if(node.disabled){
return;
}
this.clickedButton=node;
},formFilter:function(node){
var type=(node.type||"").toLowerCase();
var _2f0=false;
if(node.disabled||!node.name){
_2f0=false;
}else{
if(dojo.lang.inArray(["submit","button","image"],type)){
if(!this.clickedButton){
this.clickedButton=node;
}
_2f0=node==this.clickedButton;
}else{
_2f0=!dojo.lang.inArray(["file","submit","reset","button"],type);
}
}
return _2f0;
},connect:function(_2f1,_2f2,_2f3){
if(dojo.evalObjPath("dojo.event.connect")){
dojo.event.connect(_2f1,_2f2,this,_2f3);
}else{
var fcn=dojo.lang.hitch(this,_2f3);
_2f1[_2f2]=function(e){
if(!e){
e=window.event;
}
if(!e.currentTarget){
e.currentTarget=e.srcElement;
}
if(!e.preventDefault){
e.preventDefault=function(){
window.event.returnValue=false;
};
}
fcn(e);
};
}
}});
dojo.io.XMLHTTPTransport=new function(){
var _2f6=this;
var _2f7={};
this.useCache=false;
this.preventCache=false;
function getCacheKey(url,_2f9,_2fa){
return url+"|"+_2f9+"|"+_2fa.toLowerCase();
}
function addToCache(url,_2fc,_2fd,http){
_2f7[getCacheKey(url,_2fc,_2fd)]=http;
}
function getFromCache(url,_300,_301){
return _2f7[getCacheKey(url,_300,_301)];
}
this.clearCache=function(){
_2f7={};
};
function doLoad(_302,http,url,_305,_306){
if(((http.status>=200)&&(http.status<300))||(http.status==304)||(location.protocol=="file:"&&(http.status==0||http.status==undefined))||(location.protocol=="chrome:"&&(http.status==0||http.status==undefined))){
var ret;
if(_302.method.toLowerCase()=="head"){
var _308=http.getAllResponseHeaders();
ret={};
ret.toString=function(){
return _308;
};
var _309=_308.split(/[\r\n]+/g);
for(var i=0;i<_309.length;i++){
var pair=_309[i].match(/^([^:]+)\s*:\s*(.+)$/i);
if(pair){
ret[pair[1]]=pair[2];
}
}
}else{
if(_302.mimetype=="text/javascript"){
try{
ret=dj_eval(http.responseText);
}
catch(e){
dojo.debug(e);
dojo.debug(http.responseText);
ret=null;
}
}else{
if(_302.mimetype=="text/json"||_302.mimetype=="application/json"){
try{
ret=dj_eval("("+http.responseText+")");
}
catch(e){
dojo.debug(e);
dojo.debug(http.responseText);
ret=false;
}
}else{
if((_302.mimetype=="application/xml")||(_302.mimetype=="text/xml")){
ret=http.responseXML;
if(!ret||typeof ret=="string"||!http.getResponseHeader("Content-Type")){
ret=dojo.dom.createDocumentFromText(http.responseText);
}
}else{
ret=http.responseText;
}
}
}
}
if(_306){
addToCache(url,_305,_302.method,http);
}
_302[(typeof _302.load=="function")?"load":"handle"]("load",ret,http,_302);
}else{
var _30c=new dojo.io.Error("XMLHttpTransport Error: "+http.status+" "+http.statusText);
_302[(typeof _302.error=="function")?"error":"handle"]("error",_30c,http,_302);
}
}
function setHeaders(http,_30e){
if(_30e["headers"]){
for(var _30f in _30e["headers"]){
if(_30f.toLowerCase()=="content-type"&&!_30e["contentType"]){
_30e["contentType"]=_30e["headers"][_30f];
}else{
http.setRequestHeader(_30f,_30e["headers"][_30f]);
}
}
}
}
this.inFlight=[];
this.inFlightTimer=null;
this.startWatchingInFlight=function(){
if(!this.inFlightTimer){
this.inFlightTimer=setTimeout("dojo.io.XMLHTTPTransport.watchInFlight();",10);
}
};
this.watchInFlight=function(){
var now=null;
if(!dojo.hostenv._blockAsync&&!_2f6._blockAsync){
for(var x=this.inFlight.length-1;x>=0;x--){
try{
var tif=this.inFlight[x];
if(!tif||tif.http._aborted||!tif.http.readyState){
this.inFlight.splice(x,1);
continue;
}
if(4==tif.http.readyState){
this.inFlight.splice(x,1);
doLoad(tif.req,tif.http,tif.url,tif.query,tif.useCache);
}else{
if(tif.startTime){
if(!now){
now=(new Date()).getTime();
}
if(tif.startTime+(tif.req.timeoutSeconds*1000)<now){
if(typeof tif.http.abort=="function"){
tif.http.abort();
}
this.inFlight.splice(x,1);
tif.req[(typeof tif.req.timeout=="function")?"timeout":"handle"]("timeout",null,tif.http,tif.req);
}
}
}
}
catch(e){
try{
var _313=new dojo.io.Error("XMLHttpTransport.watchInFlight Error: "+e);
tif.req[(typeof tif.req.error=="function")?"error":"handle"]("error",_313,tif.http,tif.req);
}
catch(e2){
dojo.debug("XMLHttpTransport error callback failed: "+e2);
}
}
}
}
clearTimeout(this.inFlightTimer);
if(this.inFlight.length==0){
this.inFlightTimer=null;
return;
}
this.inFlightTimer=setTimeout("dojo.io.XMLHTTPTransport.watchInFlight();",10);
};
var _314=dojo.hostenv.getXmlhttpObject()?true:false;
this.canHandle=function(_315){
return _314&&dojo.lang.inArray(["text/plain","text/html","application/xml","text/xml","text/javascript","text/json","application/json"],(_315["mimetype"].toLowerCase()||""))&&!(_315["formNode"]&&dojo.io.formHasFile(_315["formNode"]));
};
this.multipartBoundary="45309FFF-BD65-4d50-99C9-36986896A96F";
this.bind=function(_316){
if(!_316["url"]){
if(!_316["formNode"]&&(_316["backButton"]||_316["back"]||_316["changeUrl"]||_316["watchForURL"])&&(!djConfig.preventBackButtonFix)){
dojo.deprecated("Using dojo.io.XMLHTTPTransport.bind() to add to browser history without doing an IO request","Use dojo.undo.browser.addToHistory() instead.","0.4");
dojo.undo.browser.addToHistory(_316);
return true;
}
}
var url=_316.url;
var _318="";
if(_316["formNode"]){
var ta=_316.formNode.getAttribute("action");
if((ta)&&(!_316["url"])){
url=ta;
}
var tp=_316.formNode.getAttribute("method");
if((tp)&&(!_316["method"])){
_316.method=tp;
}
_318+=dojo.io.encodeForm(_316.formNode,_316.encoding,_316["formFilter"]);
}
if(url.indexOf("#")>-1){
dojo.debug("Warning: dojo.io.bind: stripping hash values from url:",url);
url=url.split("#")[0];
}
if(_316["file"]){
_316.method="post";
}
if(!_316["method"]){
_316.method="get";
}
if(_316.method.toLowerCase()=="get"){
_316.multipart=false;
}else{
if(_316["file"]){
_316.multipart=true;
}else{
if(!_316["multipart"]){
_316.multipart=false;
}
}
}
if(_316["backButton"]||_316["back"]||_316["changeUrl"]){
dojo.undo.browser.addToHistory(_316);
}
var _31b=_316["content"]||{};
if(_316.sendTransport){
_31b["dojo.transport"]="xmlhttp";
}
do{
if(_316.postContent){
_318=_316.postContent;
break;
}
if(_31b){
_318+=dojo.io.argsFromMap(_31b,_316.encoding);
}
if(_316.method.toLowerCase()=="get"||!_316.multipart){
break;
}
var t=[];
if(_318.length){
var q=_318.split("&");
for(var i=0;i<q.length;++i){
if(q[i].length){
var p=q[i].split("=");
t.push("--"+this.multipartBoundary,"Content-Disposition: form-data; name=\""+p[0]+"\"","",p[1]);
}
}
}
if(_316.file){
if(dojo.lang.isArray(_316.file)){
for(var i=0;i<_316.file.length;++i){
var o=_316.file[i];
t.push("--"+this.multipartBoundary,"Content-Disposition: form-data; name=\""+o.name+"\"; filename=\""+("fileName" in o?o.fileName:o.name)+"\"","Content-Type: "+("contentType" in o?o.contentType:"application/octet-stream"),"",o.content);
}
}else{
var o=_316.file;
t.push("--"+this.multipartBoundary,"Content-Disposition: form-data; name=\""+o.name+"\"; filename=\""+("fileName" in o?o.fileName:o.name)+"\"","Content-Type: "+("contentType" in o?o.contentType:"application/octet-stream"),"",o.content);
}
}
if(t.length){
t.push("--"+this.multipartBoundary+"--","");
_318=t.join("\r\n");
}
}while(false);
var _321=_316["sync"]?false:true;
var _322=_316["preventCache"]||(this.preventCache==true&&_316["preventCache"]!=false);
var _323=_316["useCache"]==true||(this.useCache==true&&_316["useCache"]!=false);
if(!_322&&_323){
var _324=getFromCache(url,_318,_316.method);
if(_324){
doLoad(_316,_324,url,_318,false);
return;
}
}
var http=dojo.hostenv.getXmlhttpObject(_316);
var _326=false;
if(_321){
var _327=this.inFlight.push({"req":_316,"http":http,"url":url,"query":_318,"useCache":_323,"startTime":_316.timeoutSeconds?(new Date()).getTime():0});
this.startWatchingInFlight();
}else{
_2f6._blockAsync=true;
}
if(_316.method.toLowerCase()=="post"){
if(!_316.user){
http.open("POST",url,_321);
}else{
http.open("POST",url,_321,_316.user,_316.password);
}
setHeaders(http,_316);
http.setRequestHeader("Content-Type",_316.multipart?("multipart/form-data; boundary="+this.multipartBoundary):(_316.contentType||"application/x-www-form-urlencoded"));
try{
http.send(_318);
}
catch(e){
if(typeof http.abort=="function"){
http.abort();
}
doLoad(_316,{status:404},url,_318,_323);
}
}else{
var _328=url;
if(_318!=""){
_328+=(_328.indexOf("?")>-1?"&":"?")+_318;
}
if(_322){
_328+=(dojo.string.endsWithAny(_328,"?","&")?"":(_328.indexOf("?")>-1?"&":"?"))+"dojo.preventCache="+new Date().valueOf();
}
if(!_316.user){
http.open(_316.method.toUpperCase(),_328,_321);
}else{
http.open(_316.method.toUpperCase(),_328,_321,_316.user,_316.password);
}
setHeaders(http,_316);
try{
http.send(null);
}
catch(e){
if(typeof http.abort=="function"){
http.abort();
}
doLoad(_316,{status:404},url,_318,_323);
}
}
if(!_321){
doLoad(_316,http,url,_318,_323);
_2f6._blockAsync=false;
}
_316.abort=function(){
try{
http._aborted=true;
}
catch(e){
}
return http.abort();
};
return;
};
dojo.io.transports.addTransport("XMLHTTPTransport");
};
}
dojo.provide("dojo.io.cookie");
dojo.io.cookie.setCookie=function(name,_32a,days,path,_32d,_32e){
var _32f=-1;
if((typeof days=="number")&&(days>=0)){
var d=new Date();
d.setTime(d.getTime()+(days*24*60*60*1000));
_32f=d.toGMTString();
}
_32a=escape(_32a);
document.cookie=name+"="+_32a+";"+(_32f!=-1?" expires="+_32f+";":"")+(path?"path="+path:"")+(_32d?"; domain="+_32d:"")+(_32e?"; secure":"");
};
dojo.io.cookie.set=dojo.io.cookie.setCookie;
dojo.io.cookie.getCookie=function(name){
var idx=document.cookie.lastIndexOf(name+"=");
if(idx==-1){
return null;
}
var _333=document.cookie.substring(idx+name.length+1);
var end=_333.indexOf(";");
if(end==-1){
end=_333.length;
}
_333=_333.substring(0,end);
_333=unescape(_333);
return _333;
};
dojo.io.cookie.get=dojo.io.cookie.getCookie;
dojo.io.cookie.deleteCookie=function(name){
dojo.io.cookie.setCookie(name,"-",0);
};
dojo.io.cookie.setObjectCookie=function(name,obj,days,path,_33a,_33b,_33c){
if(arguments.length==5){
_33c=_33a;
_33a=null;
_33b=null;
}
var _33d=[],_33e,_33f="";
if(!_33c){
_33e=dojo.io.cookie.getObjectCookie(name);
}
if(days>=0){
if(!_33e){
_33e={};
}
for(var prop in obj){
if(obj[prop]==null){
delete _33e[prop];
}else{
if((typeof obj[prop]=="string")||(typeof obj[prop]=="number")){
_33e[prop]=obj[prop];
}
}
}
prop=null;
for(var prop in _33e){
_33d.push(escape(prop)+"="+escape(_33e[prop]));
}
_33f=_33d.join("&");
}
dojo.io.cookie.setCookie(name,_33f,days,path,_33a,_33b);
};
dojo.io.cookie.getObjectCookie=function(name){
var _342=null,_343=dojo.io.cookie.getCookie(name);
if(_343){
_342={};
var _344=_343.split("&");
for(var i=0;i<_344.length;i++){
var pair=_344[i].split("=");
var _347=pair[1];
if(isNaN(_347)){
_347=unescape(pair[1]);
}
_342[unescape(pair[0])]=_347;
}
}
return _342;
};
dojo.io.cookie.isSupported=function(){
if(typeof navigator.cookieEnabled!="boolean"){
dojo.io.cookie.setCookie("__TestingYourBrowserForCookieSupport__","CookiesAllowed",90,null);
var _348=dojo.io.cookie.getCookie("__TestingYourBrowserForCookieSupport__");
navigator.cookieEnabled=(_348=="CookiesAllowed");
if(navigator.cookieEnabled){
this.deleteCookie("__TestingYourBrowserForCookieSupport__");
}
}
return navigator.cookieEnabled;
};
if(!dojo.io.cookies){
dojo.io.cookies=dojo.io.cookie;
}
dojo.provide("dojo.io.*");
dojo.provide("dojo.event.common");
dojo.event=new function(){
this._canTimeout=dojo.lang.isFunction(dj_global["setTimeout"])||dojo.lang.isAlien(dj_global["setTimeout"]);
function interpolateArgs(args,_34a){
var dl=dojo.lang;
var ao={srcObj:dj_global,srcFunc:null,adviceObj:dj_global,adviceFunc:null,aroundObj:null,aroundFunc:null,adviceType:(args.length>2)?args[0]:"after",precedence:"last",once:false,delay:null,rate:0,adviceMsg:false};
switch(args.length){
case 0:
return;
case 1:
return;
case 2:
ao.srcFunc=args[0];
ao.adviceFunc=args[1];
break;
case 3:
if((dl.isObject(args[0]))&&(dl.isString(args[1]))&&(dl.isString(args[2]))){
ao.adviceType="after";
ao.srcObj=args[0];
ao.srcFunc=args[1];
ao.adviceFunc=args[2];
}else{
if((dl.isString(args[1]))&&(dl.isString(args[2]))){
ao.srcFunc=args[1];
ao.adviceFunc=args[2];
}else{
if((dl.isObject(args[0]))&&(dl.isString(args[1]))&&(dl.isFunction(args[2]))){
ao.adviceType="after";
ao.srcObj=args[0];
ao.srcFunc=args[1];
var _34d=dl.nameAnonFunc(args[2],ao.adviceObj,_34a);
ao.adviceFunc=_34d;
}else{
if((dl.isFunction(args[0]))&&(dl.isObject(args[1]))&&(dl.isString(args[2]))){
ao.adviceType="after";
ao.srcObj=dj_global;
var _34d=dl.nameAnonFunc(args[0],ao.srcObj,_34a);
ao.srcFunc=_34d;
ao.adviceObj=args[1];
ao.adviceFunc=args[2];
}
}
}
}
break;
case 4:
if((dl.isObject(args[0]))&&(dl.isObject(args[2]))){
ao.adviceType="after";
ao.srcObj=args[0];
ao.srcFunc=args[1];
ao.adviceObj=args[2];
ao.adviceFunc=args[3];
}else{
if((dl.isString(args[0]))&&(dl.isString(args[1]))&&(dl.isObject(args[2]))){
ao.adviceType=args[0];
ao.srcObj=dj_global;
ao.srcFunc=args[1];
ao.adviceObj=args[2];
ao.adviceFunc=args[3];
}else{
if((dl.isString(args[0]))&&(dl.isFunction(args[1]))&&(dl.isObject(args[2]))){
ao.adviceType=args[0];
ao.srcObj=dj_global;
var _34d=dl.nameAnonFunc(args[1],dj_global,_34a);
ao.srcFunc=_34d;
ao.adviceObj=args[2];
ao.adviceFunc=args[3];
}else{
if((dl.isString(args[0]))&&(dl.isObject(args[1]))&&(dl.isString(args[2]))&&(dl.isFunction(args[3]))){
ao.srcObj=args[1];
ao.srcFunc=args[2];
var _34d=dl.nameAnonFunc(args[3],dj_global,_34a);
ao.adviceObj=dj_global;
ao.adviceFunc=_34d;
}else{
if(dl.isObject(args[1])){
ao.srcObj=args[1];
ao.srcFunc=args[2];
ao.adviceObj=dj_global;
ao.adviceFunc=args[3];
}else{
if(dl.isObject(args[2])){
ao.srcObj=dj_global;
ao.srcFunc=args[1];
ao.adviceObj=args[2];
ao.adviceFunc=args[3];
}else{
ao.srcObj=ao.adviceObj=ao.aroundObj=dj_global;
ao.srcFunc=args[1];
ao.adviceFunc=args[2];
ao.aroundFunc=args[3];
}
}
}
}
}
}
break;
case 6:
ao.srcObj=args[1];
ao.srcFunc=args[2];
ao.adviceObj=args[3];
ao.adviceFunc=args[4];
ao.aroundFunc=args[5];
ao.aroundObj=dj_global;
break;
default:
ao.srcObj=args[1];
ao.srcFunc=args[2];
ao.adviceObj=args[3];
ao.adviceFunc=args[4];
ao.aroundObj=args[5];
ao.aroundFunc=args[6];
ao.once=args[7];
ao.delay=args[8];
ao.rate=args[9];
ao.adviceMsg=args[10];
break;
}
if(dl.isFunction(ao.aroundFunc)){
var _34d=dl.nameAnonFunc(ao.aroundFunc,ao.aroundObj,_34a);
ao.aroundFunc=_34d;
}
if(dl.isFunction(ao.srcFunc)){
ao.srcFunc=dl.getNameInObj(ao.srcObj,ao.srcFunc);
}
if(dl.isFunction(ao.adviceFunc)){
ao.adviceFunc=dl.getNameInObj(ao.adviceObj,ao.adviceFunc);
}
if((ao.aroundObj)&&(dl.isFunction(ao.aroundFunc))){
ao.aroundFunc=dl.getNameInObj(ao.aroundObj,ao.aroundFunc);
}
if(!ao.srcObj){
dojo.raise("bad srcObj for srcFunc: "+ao.srcFunc);
}
if(!ao.adviceObj){
dojo.raise("bad adviceObj for adviceFunc: "+ao.adviceFunc);
}
if(!ao.adviceFunc){
dojo.debug("bad adviceFunc for srcFunc: "+ao.srcFunc);
dojo.debugShallow(ao);
}
return ao;
}
this.connect=function(){
if(arguments.length==1){
var ao=arguments[0];
}else{
var ao=interpolateArgs(arguments,true);
}
if(dojo.lang.isString(ao.srcFunc)&&(ao.srcFunc.toLowerCase()=="onkey")){
if(dojo.render.html.ie){
ao.srcFunc="onkeydown";
this.connect(ao);
}
ao.srcFunc="onkeypress";
}
if(dojo.lang.isArray(ao.srcObj)&&ao.srcObj!=""){
var _34f={};
for(var x in ao){
_34f[x]=ao[x];
}
var mjps=[];
dojo.lang.forEach(ao.srcObj,function(src){
if((dojo.render.html.capable)&&(dojo.lang.isString(src))){
src=dojo.byId(src);
}
_34f.srcObj=src;
mjps.push(dojo.event.connect.call(dojo.event,_34f));
});
return mjps;
}
var mjp=dojo.event.MethodJoinPoint.getForMethod(ao.srcObj,ao.srcFunc);
if(ao.adviceFunc){
var mjp2=dojo.event.MethodJoinPoint.getForMethod(ao.adviceObj,ao.adviceFunc);
}
mjp.kwAddAdvice(ao);
return mjp;
};
this.log=function(a1,a2){
var _357;
if((arguments.length==1)&&(typeof a1=="object")){
_357=a1;
}else{
_357={srcObj:a1,srcFunc:a2};
}
_357.adviceFunc=function(){
var _358=[];
for(var x=0;x<arguments.length;x++){
_358.push(arguments[x]);
}
dojo.debug("("+_357.srcObj+")."+_357.srcFunc,":",_358.join(", "));
};
this.kwConnect(_357);
};
this.connectBefore=function(){
var args=["before"];
for(var i=0;i<arguments.length;i++){
args.push(arguments[i]);
}
return this.connect.apply(this,args);
};
this.connectAround=function(){
var args=["around"];
for(var i=0;i<arguments.length;i++){
args.push(arguments[i]);
}
return this.connect.apply(this,args);
};
this.connectOnce=function(){
var ao=interpolateArgs(arguments,true);
ao.once=true;
return this.connect(ao);
};
this._kwConnectImpl=function(_35f,_360){
var fn=(_360)?"disconnect":"connect";
if(typeof _35f["srcFunc"]=="function"){
_35f.srcObj=_35f["srcObj"]||dj_global;
var _362=dojo.lang.nameAnonFunc(_35f.srcFunc,_35f.srcObj,true);
_35f.srcFunc=_362;
}
if(typeof _35f["adviceFunc"]=="function"){
_35f.adviceObj=_35f["adviceObj"]||dj_global;
var _362=dojo.lang.nameAnonFunc(_35f.adviceFunc,_35f.adviceObj,true);
_35f.adviceFunc=_362;
}
_35f.srcObj=_35f["srcObj"]||dj_global;
_35f.adviceObj=_35f["adviceObj"]||_35f["targetObj"]||dj_global;
_35f.adviceFunc=_35f["adviceFunc"]||_35f["targetFunc"];
return dojo.event[fn](_35f);
};
this.kwConnect=function(_363){
return this._kwConnectImpl(_363,false);
};
this.disconnect=function(){
if(arguments.length==1){
var ao=arguments[0];
}else{
var ao=interpolateArgs(arguments,true);
}
if(!ao.adviceFunc){
return;
}
if(dojo.lang.isString(ao.srcFunc)&&(ao.srcFunc.toLowerCase()=="onkey")){
if(dojo.render.html.ie){
ao.srcFunc="onkeydown";
this.disconnect(ao);
}
ao.srcFunc="onkeypress";
}
if(!ao.srcObj[ao.srcFunc]){
return null;
}
var mjp=dojo.event.MethodJoinPoint.getForMethod(ao.srcObj,ao.srcFunc,true);
mjp.removeAdvice(ao.adviceObj,ao.adviceFunc,ao.adviceType,ao.once);
return mjp;
};
this.kwDisconnect=function(_366){
return this._kwConnectImpl(_366,true);
};
};
dojo.event.MethodInvocation=function(_367,obj,args){
this.jp_=_367;
this.object=obj;
this.args=[];
for(var x=0;x<args.length;x++){
this.args[x]=args[x];
}
this.around_index=-1;
};
dojo.event.MethodInvocation.prototype.proceed=function(){
this.around_index++;
if(this.around_index>=this.jp_.around.length){
return this.jp_.object[this.jp_.methodname].apply(this.jp_.object,this.args);
}else{
var ti=this.jp_.around[this.around_index];
var mobj=ti[0]||dj_global;
var meth=ti[1];
return mobj[meth].call(mobj,this);
}
};
dojo.event.MethodJoinPoint=function(obj,_36f){
this.object=obj||dj_global;
this.methodname=_36f;
this.methodfunc=this.object[_36f];
this.squelch=false;
};
dojo.event.MethodJoinPoint.getForMethod=function(obj,_371){
if(!obj){
obj=dj_global;
}
if(!obj[_371]){
obj[_371]=function(){
};
if(!obj[_371]){
dojo.raise("Cannot set do-nothing method on that object "+_371);
}
}else{
if((!dojo.lang.isFunction(obj[_371]))&&(!dojo.lang.isAlien(obj[_371]))){
return null;
}
}
var _372=_371+"$joinpoint";
var _373=_371+"$joinpoint$method";
var _374=obj[_372];
if(!_374){
var _375=false;
if(dojo.event["browser"]){
if((obj["attachEvent"])||(obj["nodeType"])||(obj["addEventListener"])){
_375=true;
dojo.event.browser.addClobberNodeAttrs(obj,[_372,_373,_371]);
}
}
var _376=obj[_371].length;
obj[_373]=obj[_371];
_374=obj[_372]=new dojo.event.MethodJoinPoint(obj,_373);
obj[_371]=function(){
var args=[];
if((_375)&&(!arguments.length)){
var evt=null;
try{
if(obj.ownerDocument){
evt=obj.ownerDocument.parentWindow.event;
}else{
if(obj.documentElement){
evt=obj.documentElement.ownerDocument.parentWindow.event;
}else{
if(obj.event){
evt=obj.event;
}else{
evt=window.event;
}
}
}
}
catch(e){
evt=window.event;
}
if(evt){
args.push(dojo.event.browser.fixEvent(evt,this));
}
}else{
for(var x=0;x<arguments.length;x++){
if((x==0)&&(_375)&&(dojo.event.browser.isEvent(arguments[x]))){
args.push(dojo.event.browser.fixEvent(arguments[x],this));
}else{
args.push(arguments[x]);
}
}
}
return _374.run.apply(_374,args);
};
obj[_371].__preJoinArity=_376;
}
return _374;
};
dojo.lang.extend(dojo.event.MethodJoinPoint,{unintercept:function(){
this.object[this.methodname]=this.methodfunc;
this.before=[];
this.after=[];
this.around=[];
},disconnect:dojo.lang.forward("unintercept"),run:function(){
var obj=this.object||dj_global;
var args=arguments;
var _37c=[];
for(var x=0;x<args.length;x++){
_37c[x]=args[x];
}
var _37e=function(marr){
if(!marr){
dojo.debug("Null argument to unrollAdvice()");
return;
}
var _380=marr[0]||dj_global;
var _381=marr[1];
if(!_380[_381]){
dojo.raise("function \""+_381+"\" does not exist on \""+_380+"\"");
}
var _382=marr[2]||dj_global;
var _383=marr[3];
var msg=marr[6];
var _385;
var to={args:[],jp_:this,object:obj,proceed:function(){
return _380[_381].apply(_380,to.args);
}};
to.args=_37c;
var _387=parseInt(marr[4]);
var _388=((!isNaN(_387))&&(marr[4]!==null)&&(typeof marr[4]!="undefined"));
if(marr[5]){
var rate=parseInt(marr[5]);
var cur=new Date();
var _38b=false;
if((marr["last"])&&((cur-marr.last)<=rate)){
if(dojo.event._canTimeout){
if(marr["delayTimer"]){
clearTimeout(marr.delayTimer);
}
var tod=parseInt(rate*2);
var mcpy=dojo.lang.shallowCopy(marr);
marr.delayTimer=setTimeout(function(){
mcpy[5]=0;
_37e(mcpy);
},tod);
}
return;
}else{
marr.last=cur;
}
}
if(_383){
_382[_383].call(_382,to);
}else{
if((_388)&&((dojo.render.html)||(dojo.render.svg))){
dj_global["setTimeout"](function(){
if(msg){
_380[_381].call(_380,to);
}else{
_380[_381].apply(_380,args);
}
},_387);
}else{
if(msg){
_380[_381].call(_380,to);
}else{
_380[_381].apply(_380,args);
}
}
}
};
var _38e=function(){
if(this.squelch){
try{
return _37e.apply(this,arguments);
}
catch(e){
dojo.debug(e);
}
}else{
return _37e.apply(this,arguments);
}
};
if((this["before"])&&(this.before.length>0)){
dojo.lang.forEach(this.before.concat(new Array()),_38e);
}
var _38f;
try{
if((this["around"])&&(this.around.length>0)){
var mi=new dojo.event.MethodInvocation(this,obj,args);
_38f=mi.proceed();
}else{
if(this.methodfunc){
_38f=this.object[this.methodname].apply(this.object,args);
}
}
}
catch(e){
if(!this.squelch){
dojo.debug(e,"when calling",this.methodname,"on",this.object,"with arguments",args);
dojo.raise(e);
}
}
if((this["after"])&&(this.after.length>0)){
dojo.lang.forEach(this.after.concat(new Array()),_38e);
}
return (this.methodfunc)?_38f:null;
},getArr:function(kind){
var type="after";
if((typeof kind=="string")&&(kind.indexOf("before")!=-1)){
type="before";
}else{
if(kind=="around"){
type="around";
}
}
if(!this[type]){
this[type]=[];
}
return this[type];
},kwAddAdvice:function(args){
this.addAdvice(args["adviceObj"],args["adviceFunc"],args["aroundObj"],args["aroundFunc"],args["adviceType"],args["precedence"],args["once"],args["delay"],args["rate"],args["adviceMsg"]);
},addAdvice:function(_394,_395,_396,_397,_398,_399,once,_39b,rate,_39d){
var arr=this.getArr(_398);
if(!arr){
dojo.raise("bad this: "+this);
}
var ao=[_394,_395,_396,_397,_39b,rate,_39d];
if(once){
if(this.hasAdvice(_394,_395,_398,arr)>=0){
return;
}
}
if(_399=="first"){
arr.unshift(ao);
}else{
arr.push(ao);
}
},hasAdvice:function(_3a0,_3a1,_3a2,arr){
if(!arr){
arr=this.getArr(_3a2);
}
var ind=-1;
for(var x=0;x<arr.length;x++){
var aao=(typeof _3a1=="object")?(new String(_3a1)).toString():_3a1;
var a1o=(typeof arr[x][1]=="object")?(new String(arr[x][1])).toString():arr[x][1];
if((arr[x][0]==_3a0)&&(a1o==aao)){
ind=x;
}
}
return ind;
},removeAdvice:function(_3a8,_3a9,_3aa,once){
var arr=this.getArr(_3aa);
var ind=this.hasAdvice(_3a8,_3a9,_3aa,arr);
if(ind==-1){
return false;
}
while(ind!=-1){
arr.splice(ind,1);
if(once){
break;
}
ind=this.hasAdvice(_3a8,_3a9,_3aa,arr);
}
return true;
}});
dojo.provide("dojo.event.topic");
dojo.event.topic=new function(){
this.topics={};
this.getTopic=function(_3ae){
if(!this.topics[_3ae]){
this.topics[_3ae]=new this.TopicImpl(_3ae);
}
return this.topics[_3ae];
};
this.registerPublisher=function(_3af,obj,_3b1){
var _3af=this.getTopic(_3af);
_3af.registerPublisher(obj,_3b1);
};
this.subscribe=function(_3b2,obj,_3b4){
var _3b2=this.getTopic(_3b2);
_3b2.subscribe(obj,_3b4);
};
this.unsubscribe=function(_3b5,obj,_3b7){
var _3b5=this.getTopic(_3b5);
_3b5.unsubscribe(obj,_3b7);
};
this.destroy=function(_3b8){
this.getTopic(_3b8).destroy();
delete this.topics[_3b8];
};
this.publishApply=function(_3b9,args){
var _3b9=this.getTopic(_3b9);
_3b9.sendMessage.apply(_3b9,args);
};
this.publish=function(_3bb,_3bc){
var _3bb=this.getTopic(_3bb);
var args=[];
for(var x=1;x<arguments.length;x++){
args.push(arguments[x]);
}
_3bb.sendMessage.apply(_3bb,args);
};
};
dojo.event.topic.TopicImpl=function(_3bf){
this.topicName=_3bf;
this.subscribe=function(_3c0,_3c1){
var tf=_3c1||_3c0;
var to=(!_3c1)?dj_global:_3c0;
return dojo.event.kwConnect({srcObj:this,srcFunc:"sendMessage",adviceObj:to,adviceFunc:tf});
};
this.unsubscribe=function(_3c4,_3c5){
var tf=(!_3c5)?_3c4:_3c5;
var to=(!_3c5)?null:_3c4;
return dojo.event.kwDisconnect({srcObj:this,srcFunc:"sendMessage",adviceObj:to,adviceFunc:tf});
};
this._getJoinPoint=function(){
return dojo.event.MethodJoinPoint.getForMethod(this,"sendMessage");
};
this.setSquelch=function(_3c8){
this._getJoinPoint().squelch=_3c8;
};
this.destroy=function(){
this._getJoinPoint().disconnect();
};
this.registerPublisher=function(_3c9,_3ca){
dojo.event.connect(_3c9,_3ca,this,"sendMessage");
};
this.sendMessage=function(_3cb){
};
};
dojo.provide("dojo.event.browser");
dojo._ie_clobber=new function(){
this.clobberNodes=[];
function nukeProp(node,prop){
try{
node[prop]=null;
}
catch(e){
}
try{
delete node[prop];
}
catch(e){
}
try{
node.removeAttribute(prop);
}
catch(e){
}
}
this.clobber=function(_3ce){
var na;
var tna;
if(_3ce){
tna=_3ce.all||_3ce.getElementsByTagName("*");
na=[_3ce];
for(var x=0;x<tna.length;x++){
if(tna[x]["__doClobber__"]){
na.push(tna[x]);
}
}
}else{
try{
window.onload=null;
}
catch(e){
}
na=(this.clobberNodes.length)?this.clobberNodes:document.all;
}
tna=null;
var _3d2={};
for(var i=na.length-1;i>=0;i=i-1){
var el=na[i];
try{
if(el&&el["__clobberAttrs__"]){
for(var j=0;j<el.__clobberAttrs__.length;j++){
nukeProp(el,el.__clobberAttrs__[j]);
}
nukeProp(el,"__clobberAttrs__");
nukeProp(el,"__doClobber__");
}
}
catch(e){
}
}
na=null;
};
};
if(dojo.render.html.ie){
dojo.addOnUnload(function(){
dojo._ie_clobber.clobber();
try{
if((dojo["widget"])&&(dojo.widget["manager"])){
dojo.widget.manager.destroyAll();
}
}
catch(e){
}
if(dojo.widget){
for(var name in dojo.widget._templateCache){
if(dojo.widget._templateCache[name].node){
dojo.dom.destroyNode(dojo.widget._templateCache[name].node);
dojo.widget._templateCache[name].node=null;
delete dojo.widget._templateCache[name].node;
}
}
}
try{
window.onload=null;
}
catch(e){
}
try{
window.onunload=null;
}
catch(e){
}
dojo._ie_clobber.clobberNodes=[];
});
}
dojo.event.browser=new function(){
var _3d7=0;
this.normalizedEventName=function(_3d8){
switch(_3d8){
case "CheckboxStateChange":
case "DOMAttrModified":
case "DOMMenuItemActive":
case "DOMMenuItemInactive":
case "DOMMouseScroll":
case "DOMNodeInserted":
case "DOMNodeRemoved":
case "RadioStateChange":
return _3d8;
break;
default:
return _3d8.toLowerCase();
break;
}
};
this.clean=function(node){
if(dojo.render.html.ie){
dojo._ie_clobber.clobber(node);
}
};
this.addClobberNode=function(node){
if(!dojo.render.html.ie){
return;
}
if(!node["__doClobber__"]){
node.__doClobber__=true;
dojo._ie_clobber.clobberNodes.push(node);
node.__clobberAttrs__=[];
}
};
this.addClobberNodeAttrs=function(node,_3dc){
if(!dojo.render.html.ie){
return;
}
this.addClobberNode(node);
for(var x=0;x<_3dc.length;x++){
node.__clobberAttrs__.push(_3dc[x]);
}
};
this.removeListener=function(node,_3df,fp,_3e1){
if(!_3e1){
var _3e1=false;
}
_3df=dojo.event.browser.normalizedEventName(_3df);
if((_3df=="onkey")||(_3df=="key")){
if(dojo.render.html.ie){
this.removeListener(node,"onkeydown",fp,_3e1);
}
_3df="onkeypress";
}
if(_3df.substr(0,2)=="on"){
_3df=_3df.substr(2);
}
if(node.removeEventListener){
node.removeEventListener(_3df,fp,_3e1);
}
};
this.addListener=function(node,_3e3,fp,_3e5,_3e6){
if(!node){
return;
}
if(!_3e5){
var _3e5=false;
}
_3e3=dojo.event.browser.normalizedEventName(_3e3);
if((_3e3=="onkey")||(_3e3=="key")){
if(dojo.render.html.ie){
this.addListener(node,"onkeydown",fp,_3e5,_3e6);
}
_3e3="onkeypress";
}
if(_3e3.substr(0,2)!="on"){
_3e3="on"+_3e3;
}
if(!_3e6){
var _3e7=function(evt){
if(!evt){
evt=window.event;
}
var ret=fp(dojo.event.browser.fixEvent(evt,this));
if(_3e5){
dojo.event.browser.stopEvent(evt);
}
return ret;
};
}else{
_3e7=fp;
}
if(node.addEventListener){
node.addEventListener(_3e3.substr(2),_3e7,_3e5);
return _3e7;
}else{
if(typeof node[_3e3]=="function"){
var _3ea=node[_3e3];
node[_3e3]=function(e){
_3ea(e);
return _3e7(e);
};
}else{
node[_3e3]=_3e7;
}
if(dojo.render.html.ie){
this.addClobberNodeAttrs(node,[_3e3]);
}
return _3e7;
}
};
this.isEvent=function(obj){
return (typeof obj!="undefined")&&(obj)&&(typeof Event!="undefined")&&(obj.eventPhase);
};
this.currentEvent=null;
this.callListener=function(_3ed,_3ee){
if(typeof _3ed!="function"){
dojo.raise("listener not a function: "+_3ed);
}
dojo.event.browser.currentEvent.currentTarget=_3ee;
return _3ed.call(_3ee,dojo.event.browser.currentEvent);
};
this._stopPropagation=function(){
dojo.event.browser.currentEvent.cancelBubble=true;
};
this._preventDefault=function(){
dojo.event.browser.currentEvent.returnValue=false;
};
this.keys={KEY_BACKSPACE:8,KEY_TAB:9,KEY_CLEAR:12,KEY_ENTER:13,KEY_SHIFT:16,KEY_CTRL:17,KEY_ALT:18,KEY_PAUSE:19,KEY_CAPS_LOCK:20,KEY_ESCAPE:27,KEY_SPACE:32,KEY_PAGE_UP:33,KEY_PAGE_DOWN:34,KEY_END:35,KEY_HOME:36,KEY_LEFT_ARROW:37,KEY_UP_ARROW:38,KEY_RIGHT_ARROW:39,KEY_DOWN_ARROW:40,KEY_INSERT:45,KEY_DELETE:46,KEY_HELP:47,KEY_LEFT_WINDOW:91,KEY_RIGHT_WINDOW:92,KEY_SELECT:93,KEY_NUMPAD_0:96,KEY_NUMPAD_1:97,KEY_NUMPAD_2:98,KEY_NUMPAD_3:99,KEY_NUMPAD_4:100,KEY_NUMPAD_5:101,KEY_NUMPAD_6:102,KEY_NUMPAD_7:103,KEY_NUMPAD_8:104,KEY_NUMPAD_9:105,KEY_NUMPAD_MULTIPLY:106,KEY_NUMPAD_PLUS:107,KEY_NUMPAD_ENTER:108,KEY_NUMPAD_MINUS:109,KEY_NUMPAD_PERIOD:110,KEY_NUMPAD_DIVIDE:111,KEY_F1:112,KEY_F2:113,KEY_F3:114,KEY_F4:115,KEY_F5:116,KEY_F6:117,KEY_F7:118,KEY_F8:119,KEY_F9:120,KEY_F10:121,KEY_F11:122,KEY_F12:123,KEY_F13:124,KEY_F14:125,KEY_F15:126,KEY_NUM_LOCK:144,KEY_SCROLL_LOCK:145};
this.revKeys=[];
for(var key in this.keys){
this.revKeys[this.keys[key]]=key;
}
this.fixEvent=function(evt,_3f1){
if(!evt){
if(window["event"]){
evt=window.event;
}
}
if((evt["type"])&&(evt["type"].indexOf("key")==0)){
evt.keys=this.revKeys;
for(var key in this.keys){
evt[key]=this.keys[key];
}
if(evt["type"]=="keydown"&&dojo.render.html.ie){
switch(evt.keyCode){
case evt.KEY_SHIFT:
case evt.KEY_CTRL:
case evt.KEY_ALT:
case evt.KEY_CAPS_LOCK:
case evt.KEY_LEFT_WINDOW:
case evt.KEY_RIGHT_WINDOW:
case evt.KEY_SELECT:
case evt.KEY_NUM_LOCK:
case evt.KEY_SCROLL_LOCK:
case evt.KEY_NUMPAD_0:
case evt.KEY_NUMPAD_1:
case evt.KEY_NUMPAD_2:
case evt.KEY_NUMPAD_3:
case evt.KEY_NUMPAD_4:
case evt.KEY_NUMPAD_5:
case evt.KEY_NUMPAD_6:
case evt.KEY_NUMPAD_7:
case evt.KEY_NUMPAD_8:
case evt.KEY_NUMPAD_9:
case evt.KEY_NUMPAD_PERIOD:
break;
case evt.KEY_NUMPAD_MULTIPLY:
case evt.KEY_NUMPAD_PLUS:
case evt.KEY_NUMPAD_ENTER:
case evt.KEY_NUMPAD_MINUS:
case evt.KEY_NUMPAD_DIVIDE:
break;
case evt.KEY_PAUSE:
case evt.KEY_TAB:
case evt.KEY_BACKSPACE:
case evt.KEY_ENTER:
case evt.KEY_ESCAPE:
case evt.KEY_PAGE_UP:
case evt.KEY_PAGE_DOWN:
case evt.KEY_END:
case evt.KEY_HOME:
case evt.KEY_LEFT_ARROW:
case evt.KEY_UP_ARROW:
case evt.KEY_RIGHT_ARROW:
case evt.KEY_DOWN_ARROW:
case evt.KEY_INSERT:
case evt.KEY_DELETE:
case evt.KEY_F1:
case evt.KEY_F2:
case evt.KEY_F3:
case evt.KEY_F4:
case evt.KEY_F5:
case evt.KEY_F6:
case evt.KEY_F7:
case evt.KEY_F8:
case evt.KEY_F9:
case evt.KEY_F10:
case evt.KEY_F11:
case evt.KEY_F12:
case evt.KEY_F12:
case evt.KEY_F13:
case evt.KEY_F14:
case evt.KEY_F15:
case evt.KEY_CLEAR:
case evt.KEY_HELP:
evt.key=evt.keyCode;
break;
default:
if(evt.ctrlKey||evt.altKey){
var _3f3=evt.keyCode;
if(_3f3>=65&&_3f3<=90&&evt.shiftKey==false){
_3f3+=32;
}
if(_3f3>=1&&_3f3<=26&&evt.ctrlKey){
_3f3+=96;
}
evt.key=String.fromCharCode(_3f3);
}
}
}else{
if(evt["type"]=="keypress"){
if(dojo.render.html.opera){
if(evt.which==0){
evt.key=evt.keyCode;
}else{
if(evt.which>0){
switch(evt.which){
case evt.KEY_SHIFT:
case evt.KEY_CTRL:
case evt.KEY_ALT:
case evt.KEY_CAPS_LOCK:
case evt.KEY_NUM_LOCK:
case evt.KEY_SCROLL_LOCK:
break;
case evt.KEY_PAUSE:
case evt.KEY_TAB:
case evt.KEY_BACKSPACE:
case evt.KEY_ENTER:
case evt.KEY_ESCAPE:
evt.key=evt.which;
break;
default:
var _3f3=evt.which;
if((evt.ctrlKey||evt.altKey||evt.metaKey)&&(evt.which>=65&&evt.which<=90&&evt.shiftKey==false)){
_3f3+=32;
}
evt.key=String.fromCharCode(_3f3);
}
}
}
}else{
if(dojo.render.html.ie){
if(!evt.ctrlKey&&!evt.altKey&&evt.keyCode>=evt.KEY_SPACE){
evt.key=String.fromCharCode(evt.keyCode);
}
}else{
if(dojo.render.html.safari){
switch(evt.keyCode){
case 25:
evt.key=evt.KEY_TAB;
evt.shift=true;
break;
case 63232:
evt.key=evt.KEY_UP_ARROW;
break;
case 63233:
evt.key=evt.KEY_DOWN_ARROW;
break;
case 63234:
evt.key=evt.KEY_LEFT_ARROW;
break;
case 63235:
evt.key=evt.KEY_RIGHT_ARROW;
break;
case 63236:
evt.key=evt.KEY_F1;
break;
case 63237:
evt.key=evt.KEY_F2;
break;
case 63238:
evt.key=evt.KEY_F3;
break;
case 63239:
evt.key=evt.KEY_F4;
break;
case 63240:
evt.key=evt.KEY_F5;
break;
case 63241:
evt.key=evt.KEY_F6;
break;
case 63242:
evt.key=evt.KEY_F7;
break;
case 63243:
evt.key=evt.KEY_F8;
break;
case 63244:
evt.key=evt.KEY_F9;
break;
case 63245:
evt.key=evt.KEY_F10;
break;
case 63246:
evt.key=evt.KEY_F11;
break;
case 63247:
evt.key=evt.KEY_F12;
break;
case 63250:
evt.key=evt.KEY_PAUSE;
break;
case 63272:
evt.key=evt.KEY_DELETE;
break;
case 63273:
evt.key=evt.KEY_HOME;
break;
case 63275:
evt.key=evt.KEY_END;
break;
case 63276:
evt.key=evt.KEY_PAGE_UP;
break;
case 63277:
evt.key=evt.KEY_PAGE_DOWN;
break;
case 63302:
evt.key=evt.KEY_INSERT;
break;
case 63248:
case 63249:
case 63289:
break;
default:
evt.key=evt.charCode>=evt.KEY_SPACE?String.fromCharCode(evt.charCode):evt.keyCode;
}
}else{
evt.key=evt.charCode>0?String.fromCharCode(evt.charCode):evt.keyCode;
}
}
}
}
}
}
if(dojo.render.html.ie){
if(!evt.target){
evt.target=evt.srcElement;
}
if(!evt.currentTarget){
evt.currentTarget=(_3f1?_3f1:evt.srcElement);
}
if(!evt.layerX){
evt.layerX=evt.offsetX;
}
if(!evt.layerY){
evt.layerY=evt.offsetY;
}
var doc=(evt.srcElement&&evt.srcElement.ownerDocument)?evt.srcElement.ownerDocument:document;
var _3f5=((dojo.render.html.ie55)||(doc["compatMode"]=="BackCompat"))?doc.body:doc.documentElement;
if(!evt.pageX){
evt.pageX=evt.clientX+(_3f5.scrollLeft||0);
}
if(!evt.pageY){
evt.pageY=evt.clientY+(_3f5.scrollTop||0);
}
if(evt.type=="mouseover"){
evt.relatedTarget=evt.fromElement;
}
if(evt.type=="mouseout"){
evt.relatedTarget=evt.toElement;
}
this.currentEvent=evt;
evt.callListener=this.callListener;
evt.stopPropagation=this._stopPropagation;
evt.preventDefault=this._preventDefault;
}
return evt;
};
this.stopEvent=function(evt){
if(window.event){
evt.cancelBubble=true;
evt.returnValue=false;
}else{
evt.preventDefault();
evt.stopPropagation();
}
};
};
dojo.provide("dojo.event.*");
dojo.provide("dojo.gfx.color");
dojo.gfx.color.Color=function(r,g,b,a){
if(dojo.lang.isArray(r)){
this.r=r[0];
this.g=r[1];
this.b=r[2];
this.a=r[3]||1;
}else{
if(dojo.lang.isString(r)){
var rgb=dojo.gfx.color.extractRGB(r);
this.r=rgb[0];
this.g=rgb[1];
this.b=rgb[2];
this.a=g||1;
}else{
if(r instanceof dojo.gfx.color.Color){
this.r=r.r;
this.b=r.b;
this.g=r.g;
this.a=r.a;
}else{
this.r=r;
this.g=g;
this.b=b;
this.a=a;
}
}
}
};
dojo.gfx.color.Color.fromArray=function(arr){
return new dojo.gfx.color.Color(arr[0],arr[1],arr[2],arr[3]);
};
dojo.extend(dojo.gfx.color.Color,{toRgb:function(_3fd){
if(_3fd){
return this.toRgba();
}else{
return [this.r,this.g,this.b];
}
},toRgba:function(){
return [this.r,this.g,this.b,this.a];
},toHex:function(){
return dojo.gfx.color.rgb2hex(this.toRgb());
},toCss:function(){
return "rgb("+this.toRgb().join()+")";
},toString:function(){
return this.toHex();
},blend:function(_3fe,_3ff){
var rgb=null;
if(dojo.lang.isArray(_3fe)){
rgb=_3fe;
}else{
if(_3fe instanceof dojo.gfx.color.Color){
rgb=_3fe.toRgb();
}else{
rgb=new dojo.gfx.color.Color(_3fe).toRgb();
}
}
return dojo.gfx.color.blend(this.toRgb(),rgb,_3ff);
}});
dojo.gfx.color.named={white:[255,255,255],black:[0,0,0],red:[255,0,0],green:[0,255,0],lime:[0,255,0],blue:[0,0,255],navy:[0,0,128],gray:[128,128,128],silver:[192,192,192]};
dojo.gfx.color.blend=function(a,b,_403){
if(typeof a=="string"){
return dojo.gfx.color.blendHex(a,b,_403);
}
if(!_403){
_403=0;
}
_403=Math.min(Math.max(-1,_403),1);
_403=((_403+1)/2);
var c=[];
for(var x=0;x<3;x++){
c[x]=parseInt(b[x]+((a[x]-b[x])*_403));
}
return c;
};
dojo.gfx.color.blendHex=function(a,b,_408){
return dojo.gfx.color.rgb2hex(dojo.gfx.color.blend(dojo.gfx.color.hex2rgb(a),dojo.gfx.color.hex2rgb(b),_408));
};
dojo.gfx.color.extractRGB=function(_409){
var hex="0123456789abcdef";
_409=_409.toLowerCase();
if(_409.indexOf("rgb")==0){
var _40b=_409.match(/rgba*\((\d+), *(\d+), *(\d+)/i);
var ret=_40b.splice(1,3);
return ret;
}else{
var _40d=dojo.gfx.color.hex2rgb(_409);
if(_40d){
return _40d;
}else{
return dojo.gfx.color.named[_409]||[255,255,255];
}
}
};
dojo.gfx.color.hex2rgb=function(hex){
var _40f="0123456789ABCDEF";
var rgb=new Array(3);
if(hex.indexOf("#")==0){
hex=hex.substring(1);
}
hex=hex.toUpperCase();
if(hex.replace(new RegExp("["+_40f+"]","g"),"")!=""){
return null;
}
if(hex.length==3){
rgb[0]=hex.charAt(0)+hex.charAt(0);
rgb[1]=hex.charAt(1)+hex.charAt(1);
rgb[2]=hex.charAt(2)+hex.charAt(2);
}else{
rgb[0]=hex.substring(0,2);
rgb[1]=hex.substring(2,4);
rgb[2]=hex.substring(4);
}
for(var i=0;i<rgb.length;i++){
rgb[i]=_40f.indexOf(rgb[i].charAt(0))*16+_40f.indexOf(rgb[i].charAt(1));
}
return rgb;
};
dojo.gfx.color.rgb2hex=function(r,g,b){
if(dojo.lang.isArray(r)){
g=r[1]||0;
b=r[2]||0;
r=r[0]||0;
}
var ret=dojo.lang.map([r,g,b],function(x){
x=new Number(x);
var s=x.toString(16);
while(s.length<2){
s="0"+s;
}
return s;
});
ret.unshift("#");
return ret.join("");
};
dojo.provide("dojo.lfx.Animation");
dojo.lfx.Line=function(_418,end){
this.start=_418;
this.end=end;
if(dojo.lang.isArray(_418)){
var diff=[];
dojo.lang.forEach(this.start,function(s,i){
diff[i]=this.end[i]-s;
},this);
this.getValue=function(n){
var res=[];
dojo.lang.forEach(this.start,function(s,i){
res[i]=(diff[i]*n)+s;
},this);
return res;
};
}else{
var diff=end-_418;
this.getValue=function(n){
return (diff*n)+this.start;
};
}
};
dojo.lfx.easeDefault=function(n){
if(dojo.render.html.khtml){
return (parseFloat("0.5")+((Math.sin((n+parseFloat("1.5"))*Math.PI))/2));
}else{
return (0.5+((Math.sin((n+1.5)*Math.PI))/2));
}
};
dojo.lfx.easeIn=function(n){
return Math.pow(n,3);
};
dojo.lfx.easeOut=function(n){
return (1-Math.pow(1-n,3));
};
dojo.lfx.easeInOut=function(n){
return ((3*Math.pow(n,2))-(2*Math.pow(n,3)));
};
dojo.lfx.IAnimation=function(){
};
dojo.lang.extend(dojo.lfx.IAnimation,{curve:null,duration:1000,easing:null,repeatCount:0,rate:25,handler:null,beforeBegin:null,onBegin:null,onAnimate:null,onEnd:null,onPlay:null,onPause:null,onStop:null,play:null,pause:null,stop:null,connect:function(evt,_427,_428){
if(!_428){
_428=_427;
_427=this;
}
_428=dojo.lang.hitch(_427,_428);
var _429=this[evt]||function(){
};
this[evt]=function(){
var ret=_429.apply(this,arguments);
_428.apply(this,arguments);
return ret;
};
return this;
},fire:function(evt,args){
if(this[evt]){
this[evt].apply(this,(args||[]));
}
return this;
},repeat:function(_42d){
this.repeatCount=_42d;
return this;
},_active:false,_paused:false});
dojo.lfx.Animation=function(_42e,_42f,_430,_431,_432,rate){
dojo.lfx.IAnimation.call(this);
if(dojo.lang.isNumber(_42e)||(!_42e&&_42f.getValue)){
rate=_432;
_432=_431;
_431=_430;
_430=_42f;
_42f=_42e;
_42e=null;
}else{
if(_42e.getValue||dojo.lang.isArray(_42e)){
rate=_431;
_432=_430;
_431=_42f;
_430=_42e;
_42f=null;
_42e=null;
}
}
if(dojo.lang.isArray(_430)){
this.curve=new dojo.lfx.Line(_430[0],_430[1]);
}else{
this.curve=_430;
}
if(_42f!=null&&_42f>0){
this.duration=_42f;
}
if(_432){
this.repeatCount=_432;
}
if(rate){
this.rate=rate;
}
if(_42e){
dojo.lang.forEach(["handler","beforeBegin","onBegin","onEnd","onPlay","onStop","onAnimate"],function(item){
if(_42e[item]){
this.connect(item,_42e[item]);
}
},this);
}
if(_431&&dojo.lang.isFunction(_431)){
this.easing=_431;
}
};
dojo.inherits(dojo.lfx.Animation,dojo.lfx.IAnimation);
dojo.lang.extend(dojo.lfx.Animation,{_startTime:null,_endTime:null,_timer:null,_percent:0,_startRepeatCount:0,play:function(_435,_436){
if(_436){
clearTimeout(this._timer);
this._active=false;
this._paused=false;
this._percent=0;
}else{
if(this._active&&!this._paused){
return this;
}
}
this.fire("handler",["beforeBegin"]);
this.fire("beforeBegin");
if(_435>0){
setTimeout(dojo.lang.hitch(this,function(){
this.play(null,_436);
}),_435);
return this;
}
this._startTime=new Date().valueOf();
if(this._paused){
this._startTime-=(this.duration*this._percent/100);
}
this._endTime=this._startTime+this.duration;
this._active=true;
this._paused=false;
var step=this._percent/100;
var _438=this.curve.getValue(step);
if(this._percent==0){
if(!this._startRepeatCount){
this._startRepeatCount=this.repeatCount;
}
this.fire("handler",["begin",_438]);
this.fire("onBegin",[_438]);
}
this.fire("handler",["play",_438]);
this.fire("onPlay",[_438]);
this._cycle();
return this;
},pause:function(){
clearTimeout(this._timer);
if(!this._active){
return this;
}
this._paused=true;
var _439=this.curve.getValue(this._percent/100);
this.fire("handler",["pause",_439]);
this.fire("onPause",[_439]);
return this;
},gotoPercent:function(pct,_43b){
clearTimeout(this._timer);
this._active=true;
this._paused=true;
this._percent=pct;
if(_43b){
this.play();
}
return this;
},stop:function(_43c){
clearTimeout(this._timer);
var step=this._percent/100;
if(_43c){
step=1;
}
var _43e=this.curve.getValue(step);
this.fire("handler",["stop",_43e]);
this.fire("onStop",[_43e]);
this._active=false;
this._paused=false;
return this;
},status:function(){
if(this._active){
return this._paused?"paused":"playing";
}else{
return "stopped";
}
return this;
},_cycle:function(){
clearTimeout(this._timer);
if(this._active){
var curr=new Date().valueOf();
var step=(curr-this._startTime)/(this._endTime-this._startTime);
if(step>=1){
step=1;
this._percent=100;
}else{
this._percent=step*100;
}
if((this.easing)&&(dojo.lang.isFunction(this.easing))){
step=this.easing(step);
}
var _441=this.curve.getValue(step);
this.fire("handler",["animate",_441]);
this.fire("onAnimate",[_441]);
if(step<1){
this._timer=setTimeout(dojo.lang.hitch(this,"_cycle"),this.rate);
}else{
this._active=false;
this.fire("handler",["end"]);
this.fire("onEnd");
if(this.repeatCount>0){
this.repeatCount--;
this.play(null,true);
}else{
if(this.repeatCount==-1){
this.play(null,true);
}else{
if(this._startRepeatCount){
this.repeatCount=this._startRepeatCount;
this._startRepeatCount=0;
}
}
}
}
}
return this;
}});
dojo.lfx.Combine=function(_442){
dojo.lfx.IAnimation.call(this);
this._anims=[];
this._animsEnded=0;
var _443=arguments;
if(_443.length==1&&(dojo.lang.isArray(_443[0])||dojo.lang.isArrayLike(_443[0]))){
_443=_443[0];
}
dojo.lang.forEach(_443,function(anim){
this._anims.push(anim);
anim.connect("onEnd",dojo.lang.hitch(this,"_onAnimsEnded"));
},this);
};
dojo.inherits(dojo.lfx.Combine,dojo.lfx.IAnimation);
dojo.lang.extend(dojo.lfx.Combine,{_animsEnded:0,play:function(_445,_446){
if(!this._anims.length){
return this;
}
this.fire("beforeBegin");
if(_445>0){
setTimeout(dojo.lang.hitch(this,function(){
this.play(null,_446);
}),_445);
return this;
}
if(_446||this._anims[0].percent==0){
this.fire("onBegin");
}
this.fire("onPlay");
this._animsCall("play",null,_446);
return this;
},pause:function(){
this.fire("onPause");
this._animsCall("pause");
return this;
},stop:function(_447){
this.fire("onStop");
this._animsCall("stop",_447);
return this;
},_onAnimsEnded:function(){
this._animsEnded++;
if(this._animsEnded>=this._anims.length){
this.fire("onEnd");
}
return this;
},_animsCall:function(_448){
var args=[];
if(arguments.length>1){
for(var i=1;i<arguments.length;i++){
args.push(arguments[i]);
}
}
var _44b=this;
dojo.lang.forEach(this._anims,function(anim){
anim[_448](args);
},_44b);
return this;
}});
dojo.lfx.Chain=function(_44d){
dojo.lfx.IAnimation.call(this);
this._anims=[];
this._currAnim=-1;
var _44e=arguments;
if(_44e.length==1&&(dojo.lang.isArray(_44e[0])||dojo.lang.isArrayLike(_44e[0]))){
_44e=_44e[0];
}
var _44f=this;
dojo.lang.forEach(_44e,function(anim,i,_452){
this._anims.push(anim);
if(i<_452.length-1){
anim.connect("onEnd",dojo.lang.hitch(this,"_playNext"));
}else{
anim.connect("onEnd",dojo.lang.hitch(this,function(){
this.fire("onEnd");
}));
}
},this);
};
dojo.inherits(dojo.lfx.Chain,dojo.lfx.IAnimation);
dojo.lang.extend(dojo.lfx.Chain,{_currAnim:-1,play:function(_453,_454){
if(!this._anims.length){
return this;
}
if(_454||!this._anims[this._currAnim]){
this._currAnim=0;
}
var _455=this._anims[this._currAnim];
this.fire("beforeBegin");
if(_453>0){
setTimeout(dojo.lang.hitch(this,function(){
this.play(null,_454);
}),_453);
return this;
}
if(_455){
if(this._currAnim==0){
this.fire("handler",["begin",this._currAnim]);
this.fire("onBegin",[this._currAnim]);
}
this.fire("onPlay",[this._currAnim]);
_455.play(null,_454);
}
return this;
},pause:function(){
if(this._anims[this._currAnim]){
this._anims[this._currAnim].pause();
this.fire("onPause",[this._currAnim]);
}
return this;
},playPause:function(){
if(this._anims.length==0){
return this;
}
if(this._currAnim==-1){
this._currAnim=0;
}
var _456=this._anims[this._currAnim];
if(_456){
if(!_456._active||_456._paused){
this.play();
}else{
this.pause();
}
}
return this;
},stop:function(){
var _457=this._anims[this._currAnim];
if(_457){
_457.stop();
this.fire("onStop",[this._currAnim]);
}
return _457;
},_playNext:function(){
if(this._currAnim==-1||this._anims.length==0){
return this;
}
this._currAnim++;
if(this._anims[this._currAnim]){
this._anims[this._currAnim].play(null,true);
}
return this;
}});
dojo.lfx.combine=function(_458){
var _459=arguments;
if(dojo.lang.isArray(arguments[0])){
_459=arguments[0];
}
if(_459.length==1){
return _459[0];
}
return new dojo.lfx.Combine(_459);
};
dojo.lfx.chain=function(_45a){
var _45b=arguments;
if(dojo.lang.isArray(arguments[0])){
_45b=arguments[0];
}
if(_45b.length==1){
return _45b[0];
}
return new dojo.lfx.Chain(_45b);
};
dojo.provide("dojo.html.common");
dojo.lang.mixin(dojo.html,dojo.dom);
dojo.html.body=function(){
dojo.deprecated("dojo.html.body() moved to dojo.body()","0.5");
return dojo.body();
};
dojo.html.getEventTarget=function(evt){
if(!evt){
evt=dojo.global().event||{};
}
var t=(evt.srcElement?evt.srcElement:(evt.target?evt.target:null));
while((t)&&(t.nodeType!=1)){
t=t.parentNode;
}
return t;
};
dojo.html.getViewport=function(){
var _45e=dojo.global();
var _45f=dojo.doc();
var w=0;
var h=0;
if(dojo.render.html.mozilla){
w=_45f.documentElement.clientWidth;
h=_45e.innerHeight;
}else{
if(!dojo.render.html.opera&&_45e.innerWidth){
w=_45e.innerWidth;
h=_45e.innerHeight;
}else{
if(!dojo.render.html.opera&&dojo.exists(_45f,"documentElement.clientWidth")){
var w2=_45f.documentElement.clientWidth;
if(!w||w2&&w2<w){
w=w2;
}
h=_45f.documentElement.clientHeight;
}else{
if(dojo.body().clientWidth){
w=dojo.body().clientWidth;
h=dojo.body().clientHeight;
}
}
}
}
return {width:w,height:h};
};
dojo.html.getScroll=function(){
var _463=dojo.global();
var _464=dojo.doc();
var top=_463.pageYOffset||_464.documentElement.scrollTop||dojo.body().scrollTop||0;
var left=_463.pageXOffset||_464.documentElement.scrollLeft||dojo.body().scrollLeft||0;
return {top:top,left:left,offset:{x:left,y:top}};
};
dojo.html.getParentByType=function(node,type){
var _469=dojo.doc();
var _46a=dojo.byId(node);
type=type.toLowerCase();
while((_46a)&&(_46a.nodeName.toLowerCase()!=type)){
if(_46a==(_469["body"]||_469["documentElement"])){
return null;
}
_46a=_46a.parentNode;
}
return _46a;
};
dojo.html.getAttribute=function(node,attr){
node=dojo.byId(node);
if((!node)||(!node.getAttribute)){
return null;
}
var ta=typeof attr=="string"?attr:new String(attr);
var v=node.getAttribute(ta.toUpperCase());
if((v)&&(typeof v=="string")&&(v!="")){
return v;
}
if(v&&v.value){
return v.value;
}
if((node.getAttributeNode)&&(node.getAttributeNode(ta))){
return (node.getAttributeNode(ta)).value;
}else{
if(node.getAttribute(ta)){
return node.getAttribute(ta);
}else{
if(node.getAttribute(ta.toLowerCase())){
return node.getAttribute(ta.toLowerCase());
}
}
}
return null;
};
dojo.html.hasAttribute=function(node,attr){
return dojo.html.getAttribute(dojo.byId(node),attr)?true:false;
};
dojo.html.getCursorPosition=function(e){
e=e||dojo.global().event;
var _472={x:0,y:0};
if(e.pageX||e.pageY){
_472.x=e.pageX;
_472.y=e.pageY;
}else{
var de=dojo.doc().documentElement;
var db=dojo.body();
_472.x=e.clientX+((de||db)["scrollLeft"])-((de||db)["clientLeft"]);
_472.y=e.clientY+((de||db)["scrollTop"])-((de||db)["clientTop"]);
}
return _472;
};
dojo.html.isTag=function(node){
node=dojo.byId(node);
if(node&&node.tagName){
for(var i=1;i<arguments.length;i++){
if(node.tagName.toLowerCase()==String(arguments[i]).toLowerCase()){
return String(arguments[i]).toLowerCase();
}
}
}
return "";
};
if(dojo.render.html.ie&&!dojo.render.html.ie70){
if(window.location.href.substr(0,6).toLowerCase()!="https:"){
(function(){
var _477=dojo.doc().createElement("script");
_477.src="javascript:'dojo.html.createExternalElement=function(doc, tag){ return doc.createElement(tag); }'";
dojo.doc().getElementsByTagName("head")[0].appendChild(_477);
})();
}
}else{
dojo.html.createExternalElement=function(doc,tag){
return doc.createElement(tag);
};
}
dojo.html._callDeprecated=function(_47a,_47b,args,_47d,_47e){
dojo.deprecated("dojo.html."+_47a,"replaced by dojo.html."+_47b+"("+(_47d?"node, {"+_47d+": "+_47d+"}":"")+")"+(_47e?"."+_47e:""),"0.5");
var _47f=[];
if(_47d){
var _480={};
_480[_47d]=args[1];
_47f.push(args[0]);
_47f.push(_480);
}else{
_47f=args;
}
var ret=dojo.html[_47b].apply(dojo.html,args);
if(_47e){
return ret[_47e];
}else{
return ret;
}
};
dojo.html.getViewportWidth=function(){
return dojo.html._callDeprecated("getViewportWidth","getViewport",arguments,null,"width");
};
dojo.html.getViewportHeight=function(){
return dojo.html._callDeprecated("getViewportHeight","getViewport",arguments,null,"height");
};
dojo.html.getViewportSize=function(){
return dojo.html._callDeprecated("getViewportSize","getViewport",arguments);
};
dojo.html.getScrollTop=function(){
return dojo.html._callDeprecated("getScrollTop","getScroll",arguments,null,"top");
};
dojo.html.getScrollLeft=function(){
return dojo.html._callDeprecated("getScrollLeft","getScroll",arguments,null,"left");
};
dojo.html.getScrollOffset=function(){
return dojo.html._callDeprecated("getScrollOffset","getScroll",arguments,null,"offset");
};
dojo.provide("dojo.uri.Uri");
dojo.uri=new function(){
this.dojoUri=function(uri){
return new dojo.uri.Uri(dojo.hostenv.getBaseScriptUri(),uri);
};
this.moduleUri=function(_483,uri){
var loc=dojo.hostenv.getModuleSymbols(_483).join("/");
if(!loc){
return null;
}
if(loc.lastIndexOf("/")!=loc.length-1){
loc+="/";
}
return new dojo.uri.Uri(dojo.hostenv.getBaseScriptUri()+loc,uri);
};
this.Uri=function(){
var uri=arguments[0];
for(var i=1;i<arguments.length;i++){
if(!arguments[i]){
continue;
}
var _488=new dojo.uri.Uri(arguments[i].toString());
var _489=new dojo.uri.Uri(uri.toString());
if((_488.path=="")&&(_488.scheme==null)&&(_488.authority==null)&&(_488.query==null)){
if(_488.fragment!=null){
_489.fragment=_488.fragment;
}
_488=_489;
}else{
if(_488.scheme==null){
_488.scheme=_489.scheme;
if(_488.authority==null){
_488.authority=_489.authority;
if(_488.path.charAt(0)!="/"){
var path=_489.path.substring(0,_489.path.lastIndexOf("/")+1)+_488.path;
var segs=path.split("/");
for(var j=0;j<segs.length;j++){
if(segs[j]=="."){
if(j==segs.length-1){
segs[j]="";
}else{
segs.splice(j,1);
j--;
}
}else{
if(j>0&&!(j==1&&segs[0]=="")&&segs[j]==".."&&segs[j-1]!=".."){
if(j==segs.length-1){
segs.splice(j,1);
segs[j-1]="";
}else{
segs.splice(j-1,2);
j-=2;
}
}
}
}
_488.path=segs.join("/");
}
}
}
}
uri="";
if(_488.scheme!=null){
uri+=_488.scheme+":";
}
if(_488.authority!=null){
uri+="//"+_488.authority;
}
uri+=_488.path;
if(_488.query!=null){
uri+="?"+_488.query;
}
if(_488.fragment!=null){
uri+="#"+_488.fragment;
}
}
this.uri=uri.toString();
var _48d="^(([^:/?#]+):)?(//([^/?#]*))?([^?#]*)(\\?([^#]*))?(#(.*))?$";
var r=this.uri.match(new RegExp(_48d));
this.scheme=r[2]||(r[1]?"":null);
this.authority=r[4]||(r[3]?"":null);
this.path=r[5];
this.query=r[7]||(r[6]?"":null);
this.fragment=r[9]||(r[8]?"":null);
if(this.authority!=null){
_48d="^((([^:]+:)?([^@]+))@)?([^:]*)(:([0-9]+))?$";
r=this.authority.match(new RegExp(_48d));
this.user=r[3]||null;
this.password=r[4]||null;
this.host=r[5];
this.port=r[7]||null;
}
this.toString=function(){
return this.uri;
};
};
};
dojo.provide("dojo.html.style");
dojo.html.getClass=function(node){
node=dojo.byId(node);
if(!node){
return "";
}
var cs="";
if(node.className){
cs=node.className;
}else{
if(dojo.html.hasAttribute(node,"class")){
cs=dojo.html.getAttribute(node,"class");
}
}
return cs.replace(/^\s+|\s+$/g,"");
};
dojo.html.getClasses=function(node){
var c=dojo.html.getClass(node);
return (c=="")?[]:c.split(/\s+/g);
};
dojo.html.hasClass=function(node,_494){
return (new RegExp("(^|\\s+)"+_494+"(\\s+|$)")).test(dojo.html.getClass(node));
};
dojo.html.prependClass=function(node,_496){
_496+=" "+dojo.html.getClass(node);
return dojo.html.setClass(node,_496);
};
dojo.html.addClass=function(node,_498){
if(dojo.html.hasClass(node,_498)){
return false;
}
_498=(dojo.html.getClass(node)+" "+_498).replace(/^\s+|\s+$/g,"");
return dojo.html.setClass(node,_498);
};
dojo.html.setClass=function(node,_49a){
node=dojo.byId(node);
var cs=new String(_49a);
try{
if(typeof node.className=="string"){
node.className=cs;
}else{
if(node.setAttribute){
node.setAttribute("class",_49a);
node.className=cs;
}else{
return false;
}
}
}
catch(e){
dojo.debug("dojo.html.setClass() failed",e);
}
return true;
};
dojo.html.removeClass=function(node,_49d,_49e){
try{
if(!_49e){
var _49f=dojo.html.getClass(node).replace(new RegExp("(^|\\s+)"+_49d+"(\\s+|$)"),"$1$2");
}else{
var _49f=dojo.html.getClass(node).replace(_49d,"");
}
dojo.html.setClass(node,_49f);
}
catch(e){
dojo.debug("dojo.html.removeClass() failed",e);
}
return true;
};
dojo.html.replaceClass=function(node,_4a1,_4a2){
dojo.html.removeClass(node,_4a2);
dojo.html.addClass(node,_4a1);
};
dojo.html.classMatchType={ContainsAll:0,ContainsAny:1,IsOnly:2};
dojo.html.getElementsByClass=function(_4a3,_4a4,_4a5,_4a6,_4a7){
_4a7=false;
var _4a8=dojo.doc();
_4a4=dojo.byId(_4a4)||_4a8;
var _4a9=_4a3.split(/\s+/g);
var _4aa=[];
if(_4a6!=1&&_4a6!=2){
_4a6=0;
}
var _4ab=new RegExp("(\\s|^)(("+_4a9.join(")|(")+"))(\\s|$)");
var _4ac=_4a9.join(" ").length;
var _4ad=[];
if(!_4a7&&_4a8.evaluate){
var _4ae=".//"+(_4a5||"*")+"[contains(";
if(_4a6!=dojo.html.classMatchType.ContainsAny){
_4ae+="concat(' ',@class,' '), ' "+_4a9.join(" ') and contains(concat(' ',@class,' '), ' ")+" ')";
if(_4a6==2){
_4ae+=" and string-length(@class)="+_4ac+"]";
}else{
_4ae+="]";
}
}else{
_4ae+="concat(' ',@class,' '), ' "+_4a9.join(" ') or contains(concat(' ',@class,' '), ' ")+" ')]";
}
var _4af=_4a8.evaluate(_4ae,_4a4,null,XPathResult.ANY_TYPE,null);
var _4b0=_4af.iterateNext();
while(_4b0){
try{
_4ad.push(_4b0);
_4b0=_4af.iterateNext();
}
catch(e){
break;
}
}
return _4ad;
}else{
if(!_4a5){
_4a5="*";
}
_4ad=_4a4.getElementsByTagName(_4a5);
var node,i=0;
outer:
while(node=_4ad[i++]){
var _4b3=dojo.html.getClasses(node);
if(_4b3.length==0){
continue outer;
}
var _4b4=0;
for(var j=0;j<_4b3.length;j++){
if(_4ab.test(_4b3[j])){
if(_4a6==dojo.html.classMatchType.ContainsAny){
_4aa.push(node);
continue outer;
}else{
_4b4++;
}
}else{
if(_4a6==dojo.html.classMatchType.IsOnly){
continue outer;
}
}
}
if(_4b4==_4a9.length){
if((_4a6==dojo.html.classMatchType.IsOnly)&&(_4b4==_4b3.length)){
_4aa.push(node);
}else{
if(_4a6==dojo.html.classMatchType.ContainsAll){
_4aa.push(node);
}
}
}
}
return _4aa;
}
};
dojo.html.getElementsByClassName=dojo.html.getElementsByClass;
dojo.html.toCamelCase=function(_4b6){
var arr=_4b6.split("-"),cc=arr[0];
for(var i=1;i<arr.length;i++){
cc+=arr[i].charAt(0).toUpperCase()+arr[i].substring(1);
}
return cc;
};
dojo.html.toSelectorCase=function(_4ba){
return _4ba.replace(/([A-Z])/g,"-$1").toLowerCase();
};
dojo.html.getComputedStyle=function(node,_4bc,_4bd){
node=dojo.byId(node);
var _4bc=dojo.html.toSelectorCase(_4bc);
var _4be=dojo.html.toCamelCase(_4bc);
if(!node||!node.style){
return _4bd;
}else{
if(document.defaultView&&dojo.html.isDescendantOf(node,node.ownerDocument)){
try{
var cs=document.defaultView.getComputedStyle(node,"");
if(cs){
return cs.getPropertyValue(_4bc);
}
}
catch(e){
if(node.style.getPropertyValue){
return node.style.getPropertyValue(_4bc);
}else{
return _4bd;
}
}
}else{
if(node.currentStyle){
return node.currentStyle[_4be];
}
}
}
if(node.style.getPropertyValue){
return node.style.getPropertyValue(_4bc);
}else{
return _4bd;
}
};
dojo.html.getStyleProperty=function(node,_4c1){
node=dojo.byId(node);
return (node&&node.style?node.style[dojo.html.toCamelCase(_4c1)]:undefined);
};
dojo.html.getStyle=function(node,_4c3){
var _4c4=dojo.html.getStyleProperty(node,_4c3);
return (_4c4?_4c4:dojo.html.getComputedStyle(node,_4c3));
};
dojo.html.setStyle=function(node,_4c6,_4c7){
node=dojo.byId(node);
if(node&&node.style){
var _4c8=dojo.html.toCamelCase(_4c6);
node.style[_4c8]=_4c7;
}
};
dojo.html.setStyleText=function(_4c9,text){
try{
_4c9.style.cssText=text;
}
catch(e){
_4c9.setAttribute("style",text);
}
};
dojo.html.copyStyle=function(_4cb,_4cc){
if(!_4cc.style.cssText){
_4cb.setAttribute("style",_4cc.getAttribute("style"));
}else{
_4cb.style.cssText=_4cc.style.cssText;
}
dojo.html.addClass(_4cb,dojo.html.getClass(_4cc));
};
dojo.html.getUnitValue=function(node,_4ce,_4cf){
var s=dojo.html.getComputedStyle(node,_4ce);
if((!s)||((s=="auto")&&(_4cf))){
return {value:0,units:"px"};
}
var _4d1=s.match(/(\-?[\d.]+)([a-z%]*)/i);
if(!_4d1){
return dojo.html.getUnitValue.bad;
}
return {value:Number(_4d1[1]),units:_4d1[2].toLowerCase()};
};
dojo.html.getUnitValue.bad={value:NaN,units:""};
dojo.html.getPixelValue=function(node,_4d3,_4d4){
var _4d5=dojo.html.getUnitValue(node,_4d3,_4d4);
if(isNaN(_4d5.value)){
return 0;
}
if((_4d5.value)&&(_4d5.units!="px")){
return NaN;
}
return _4d5.value;
};
dojo.html.setPositivePixelValue=function(node,_4d7,_4d8){
if(isNaN(_4d8)){
return false;
}
node.style[_4d7]=Math.max(0,_4d8)+"px";
return true;
};
dojo.html.styleSheet=null;
dojo.html.insertCssRule=function(_4d9,_4da,_4db){
if(!dojo.html.styleSheet){
if(document.createStyleSheet){
dojo.html.styleSheet=document.createStyleSheet();
}else{
if(document.styleSheets[0]){
dojo.html.styleSheet=document.styleSheets[0];
}else{
return null;
}
}
}
if(arguments.length<3){
if(dojo.html.styleSheet.cssRules){
_4db=dojo.html.styleSheet.cssRules.length;
}else{
if(dojo.html.styleSheet.rules){
_4db=dojo.html.styleSheet.rules.length;
}else{
return null;
}
}
}
if(dojo.html.styleSheet.insertRule){
var rule=_4d9+" { "+_4da+" }";
return dojo.html.styleSheet.insertRule(rule,_4db);
}else{
if(dojo.html.styleSheet.addRule){
return dojo.html.styleSheet.addRule(_4d9,_4da,_4db);
}else{
return null;
}
}
};
dojo.html.removeCssRule=function(_4dd){
if(!dojo.html.styleSheet){
dojo.debug("no stylesheet defined for removing rules");
return false;
}
if(dojo.render.html.ie){
if(!_4dd){
_4dd=dojo.html.styleSheet.rules.length;
dojo.html.styleSheet.removeRule(_4dd);
}
}else{
if(document.styleSheets[0]){
if(!_4dd){
_4dd=dojo.html.styleSheet.cssRules.length;
}
dojo.html.styleSheet.deleteRule(_4dd);
}
}
return true;
};
dojo.html._insertedCssFiles=[];
dojo.html.insertCssFile=function(URI,doc,_4e0,_4e1){
if(!URI){
return;
}
if(!doc){
doc=document;
}
var _4e2=dojo.hostenv.getText(URI,false,_4e1);
if(_4e2===null){
return;
}
_4e2=dojo.html.fixPathsInCssText(_4e2,URI);
if(_4e0){
var idx=-1,node,ent=dojo.html._insertedCssFiles;
for(var i=0;i<ent.length;i++){
if((ent[i].doc==doc)&&(ent[i].cssText==_4e2)){
idx=i;
node=ent[i].nodeRef;
break;
}
}
if(node){
var _4e7=doc.getElementsByTagName("style");
for(var i=0;i<_4e7.length;i++){
if(_4e7[i]==node){
return;
}
}
dojo.html._insertedCssFiles.shift(idx,1);
}
}
var _4e8=dojo.html.insertCssText(_4e2,doc);
dojo.html._insertedCssFiles.push({"doc":doc,"cssText":_4e2,"nodeRef":_4e8});
if(_4e8&&djConfig.isDebug){
_4e8.setAttribute("dbgHref",URI);
}
return _4e8;
};
dojo.html.insertCssText=function(_4e9,doc,URI){
if(!_4e9){
return;
}
if(!doc){
doc=document;
}
if(URI){
_4e9=dojo.html.fixPathsInCssText(_4e9,URI);
}
var _4ec=doc.createElement("style");
_4ec.setAttribute("type","text/css");
var head=doc.getElementsByTagName("head")[0];
if(!head){
dojo.debug("No head tag in document, aborting styles");
return;
}else{
head.appendChild(_4ec);
}
if(_4ec.styleSheet){
var _4ee=function(){
try{
_4ec.styleSheet.cssText=_4e9;
}
catch(e){
dojo.debug(e);
}
};
if(_4ec.styleSheet.disabled){
setTimeout(_4ee,10);
}else{
_4ee();
}
}else{
var _4ef=doc.createTextNode(_4e9);
_4ec.appendChild(_4ef);
}
return _4ec;
};
dojo.html.fixPathsInCssText=function(_4f0,URI){
if(!_4f0||!URI){
return;
}
var _4f2,str="",url="",_4f5="[\\t\\s\\w\\(\\)\\/\\.\\\\'\"-:#=&?~]+";
var _4f6=new RegExp("url\\(\\s*("+_4f5+")\\s*\\)");
var _4f7=/(file|https?|ftps?):\/\//;
regexTrim=new RegExp("^[\\s]*(['\"]?)("+_4f5+")\\1[\\s]*?$");
if(dojo.render.html.ie55||dojo.render.html.ie60){
var _4f8=new RegExp("AlphaImageLoader\\((.*)src=['\"]("+_4f5+")['\"]");
while(_4f2=_4f8.exec(_4f0)){
url=_4f2[2].replace(regexTrim,"$2");
if(!_4f7.exec(url)){
url=(new dojo.uri.Uri(URI,url).toString());
}
str+=_4f0.substring(0,_4f2.index)+"AlphaImageLoader("+_4f2[1]+"src='"+url+"'";
_4f0=_4f0.substr(_4f2.index+_4f2[0].length);
}
_4f0=str+_4f0;
str="";
}
while(_4f2=_4f6.exec(_4f0)){
url=_4f2[1].replace(regexTrim,"$2");
if(!_4f7.exec(url)){
url=(new dojo.uri.Uri(URI,url).toString());
}
str+=_4f0.substring(0,_4f2.index)+"url("+url+")";
_4f0=_4f0.substr(_4f2.index+_4f2[0].length);
}
return str+_4f0;
};
dojo.html.setActiveStyleSheet=function(_4f9){
var i=0,a,els=dojo.doc().getElementsByTagName("link");
while(a=els[i++]){
if(a.getAttribute("rel").indexOf("style")!=-1&&a.getAttribute("title")){
a.disabled=true;
if(a.getAttribute("title")==_4f9){
a.disabled=false;
}
}
}
};
dojo.html.getActiveStyleSheet=function(){
var i=0,a,els=dojo.doc().getElementsByTagName("link");
while(a=els[i++]){
if(a.getAttribute("rel").indexOf("style")!=-1&&a.getAttribute("title")&&!a.disabled){
return a.getAttribute("title");
}
}
return null;
};
dojo.html.getPreferredStyleSheet=function(){
var i=0,a,els=dojo.doc().getElementsByTagName("link");
while(a=els[i++]){
if(a.getAttribute("rel").indexOf("style")!=-1&&a.getAttribute("rel").indexOf("alt")==-1&&a.getAttribute("title")){
return a.getAttribute("title");
}
}
return null;
};
dojo.html.applyBrowserClass=function(node){
var drh=dojo.render.html;
var _505={dj_ie:drh.ie,dj_ie55:drh.ie55,dj_ie6:drh.ie60,dj_ie7:drh.ie70,dj_iequirks:drh.ie&&drh.quirks,dj_opera:drh.opera,dj_opera8:drh.opera&&(Math.floor(dojo.render.version)==8),dj_opera9:drh.opera&&(Math.floor(dojo.render.version)==9),dj_khtml:drh.khtml,dj_safari:drh.safari,dj_gecko:drh.mozilla};
for(var p in _505){
if(_505[p]){
dojo.html.addClass(node,p);
}
}
};
dojo.provide("dojo.html.display");
dojo.html._toggle=function(node,_508,_509){
node=dojo.byId(node);
_509(node,!_508(node));
return _508(node);
};
dojo.html.show=function(node){
node=dojo.byId(node);
if(dojo.html.getStyleProperty(node,"display")=="none"){
dojo.html.setStyle(node,"display",(node.dojoDisplayCache||""));
node.dojoDisplayCache=undefined;
}
};
dojo.html.hide=function(node){
node=dojo.byId(node);
if(typeof node["dojoDisplayCache"]=="undefined"){
var d=dojo.html.getStyleProperty(node,"display");
if(d!="none"){
node.dojoDisplayCache=d;
}
}
dojo.html.setStyle(node,"display","none");
};
dojo.html.setShowing=function(node,_50e){
dojo.html[(_50e?"show":"hide")](node);
};
dojo.html.isShowing=function(node){
return (dojo.html.getStyleProperty(node,"display")!="none");
};
dojo.html.toggleShowing=function(node){
return dojo.html._toggle(node,dojo.html.isShowing,dojo.html.setShowing);
};
dojo.html.displayMap={tr:"",td:"",th:"",img:"inline",span:"inline",input:"inline",button:"inline"};
dojo.html.suggestDisplayByTagName=function(node){
node=dojo.byId(node);
if(node&&node.tagName){
var tag=node.tagName.toLowerCase();
return (tag in dojo.html.displayMap?dojo.html.displayMap[tag]:"block");
}
};
dojo.html.setDisplay=function(node,_514){
dojo.html.setStyle(node,"display",((_514 instanceof String||typeof _514=="string")?_514:(_514?dojo.html.suggestDisplayByTagName(node):"none")));
};
dojo.html.isDisplayed=function(node){
return (dojo.html.getComputedStyle(node,"display")!="none");
};
dojo.html.toggleDisplay=function(node){
return dojo.html._toggle(node,dojo.html.isDisplayed,dojo.html.setDisplay);
};
dojo.html.setVisibility=function(node,_518){
dojo.html.setStyle(node,"visibility",((_518 instanceof String||typeof _518=="string")?_518:(_518?"visible":"hidden")));
};
dojo.html.isVisible=function(node){
return (dojo.html.getComputedStyle(node,"visibility")!="hidden");
};
dojo.html.toggleVisibility=function(node){
return dojo.html._toggle(node,dojo.html.isVisible,dojo.html.setVisibility);
};
dojo.html.setOpacity=function(node,_51c,_51d){
node=dojo.byId(node);
var h=dojo.render.html;
if(!_51d){
if(_51c>=1){
if(h.ie){
dojo.html.clearOpacity(node);
return;
}else{
_51c=0.999999;
}
}else{
if(_51c<0){
_51c=0;
}
}
}
if(h.ie){
if(node.nodeName.toLowerCase()=="tr"){
var tds=node.getElementsByTagName("td");
for(var x=0;x<tds.length;x++){
tds[x].style.filter="Alpha(Opacity="+_51c*100+")";
}
}
node.style.filter="Alpha(Opacity="+_51c*100+")";
}else{
if(h.moz){
node.style.opacity=_51c;
node.style.MozOpacity=_51c;
}else{
if(h.safari){
node.style.opacity=_51c;
node.style.KhtmlOpacity=_51c;
}else{
node.style.opacity=_51c;
}
}
}
};
dojo.html.clearOpacity=function(node){
node=dojo.byId(node);
var ns=node.style;
var h=dojo.render.html;
if(h.ie){
try{
if(node.filters&&node.filters.alpha){
ns.filter="";
}
}
catch(e){
}
}else{
if(h.moz){
ns.opacity=1;
ns.MozOpacity=1;
}else{
if(h.safari){
ns.opacity=1;
ns.KhtmlOpacity=1;
}else{
ns.opacity=1;
}
}
}
};
dojo.html.getOpacity=function(node){
node=dojo.byId(node);
var h=dojo.render.html;
if(h.ie){
var opac=(node.filters&&node.filters.alpha&&typeof node.filters.alpha.opacity=="number"?node.filters.alpha.opacity:100)/100;
}else{
var opac=node.style.opacity||node.style.MozOpacity||node.style.KhtmlOpacity||1;
}
return opac>=0.999999?1:Number(opac);
};
dojo.provide("dojo.html.color");
dojo.html.getBackgroundColor=function(node){
node=dojo.byId(node);
var _528;
do{
_528=dojo.html.getStyle(node,"background-color");
if(_528.toLowerCase()=="rgba(0, 0, 0, 0)"){
_528="transparent";
}
if(node==document.getElementsByTagName("body")[0]){
node=null;
break;
}
node=node.parentNode;
}while(node&&dojo.lang.inArray(["transparent",""],_528));
if(_528=="transparent"){
_528=[255,255,255,0];
}else{
_528=dojo.gfx.color.extractRGB(_528);
}
return _528;
};
dojo.provide("dojo.html.layout");
dojo.html.sumAncestorProperties=function(node,prop){
node=dojo.byId(node);
if(!node){
return 0;
}
var _52b=0;
while(node){
if(dojo.html.getComputedStyle(node,"position")=="fixed"){
return 0;
}
var val=node[prop];
if(val){
_52b+=val-0;
if(node==dojo.body()){
break;
}
}
node=node.parentNode;
}
return _52b;
};
dojo.html.setStyleAttributes=function(node,_52e){
node=dojo.byId(node);
var _52f=_52e.replace(/(;)?\s*$/,"").split(";");
for(var i=0;i<_52f.length;i++){
var _531=_52f[i].split(":");
var name=_531[0].replace(/\s*$/,"").replace(/^\s*/,"").toLowerCase();
var _533=_531[1].replace(/\s*$/,"").replace(/^\s*/,"");
switch(name){
case "opacity":
dojo.html.setOpacity(node,_533);
break;
case "content-height":
dojo.html.setContentBox(node,{height:_533});
break;
case "content-width":
dojo.html.setContentBox(node,{width:_533});
break;
case "outer-height":
dojo.html.setMarginBox(node,{height:_533});
break;
case "outer-width":
dojo.html.setMarginBox(node,{width:_533});
break;
default:
node.style[dojo.html.toCamelCase(name)]=_533;
}
}
};
dojo.html.boxSizing={MARGIN_BOX:"margin-box",BORDER_BOX:"border-box",PADDING_BOX:"padding-box",CONTENT_BOX:"content-box"};
dojo.html.getAbsolutePosition=dojo.html.abs=function(node,_535,_536){
node=dojo.byId(node,node.ownerDocument);
var ret={x:0,y:0};
var bs=dojo.html.boxSizing;
if(!_536){
_536=bs.CONTENT_BOX;
}
var _539=2;
var _53a;
switch(_536){
case bs.MARGIN_BOX:
_53a=3;
break;
case bs.BORDER_BOX:
_53a=2;
break;
case bs.PADDING_BOX:
default:
_53a=1;
break;
case bs.CONTENT_BOX:
_53a=0;
break;
}
var h=dojo.render.html;
var db=document["body"]||document["documentElement"];
if(h.ie){
with(node.getBoundingClientRect()){
ret.x=left-2;
ret.y=top-2;
}
}else{
if(document.getBoxObjectFor){
_539=1;
try{
var bo=document.getBoxObjectFor(node);
ret.x=bo.x-dojo.html.sumAncestorProperties(node,"scrollLeft");
ret.y=bo.y-dojo.html.sumAncestorProperties(node,"scrollTop");
}
catch(e){
}
}else{
if(node["offsetParent"]){
var _53e;
if((h.safari)&&(node.style.getPropertyValue("position")=="absolute")&&(node.parentNode==db)){
_53e=db;
}else{
_53e=db.parentNode;
}
if(node.parentNode!=db){
var nd=node;
if(dojo.render.html.opera){
nd=db;
}
ret.x-=dojo.html.sumAncestorProperties(nd,"scrollLeft");
ret.y-=dojo.html.sumAncestorProperties(nd,"scrollTop");
}
var _540=node;
do{
var n=_540["offsetLeft"];
if(!h.opera||n>0){
ret.x+=isNaN(n)?0:n;
}
var m=_540["offsetTop"];
ret.y+=isNaN(m)?0:m;
_540=_540.offsetParent;
}while((_540!=_53e)&&(_540!=null));
}else{
if(node["x"]&&node["y"]){
ret.x+=isNaN(node.x)?0:node.x;
ret.y+=isNaN(node.y)?0:node.y;
}
}
}
}
if(_535){
var _543=dojo.html.getScroll();
ret.y+=_543.top;
ret.x+=_543.left;
}
var _544=[dojo.html.getPaddingExtent,dojo.html.getBorderExtent,dojo.html.getMarginExtent];
if(_539>_53a){
for(var i=_53a;i<_539;++i){
ret.y+=_544[i](node,"top");
ret.x+=_544[i](node,"left");
}
}else{
if(_539<_53a){
for(var i=_53a;i>_539;--i){
ret.y-=_544[i-1](node,"top");
ret.x-=_544[i-1](node,"left");
}
}
}
ret.top=ret.y;
ret.left=ret.x;
return ret;
};
dojo.html.isPositionAbsolute=function(node){
return (dojo.html.getComputedStyle(node,"position")=="absolute");
};
dojo.html._sumPixelValues=function(node,_548,_549){
var _54a=0;
for(var x=0;x<_548.length;x++){
_54a+=dojo.html.getPixelValue(node,_548[x],_549);
}
return _54a;
};
dojo.html.getMargin=function(node){
return {width:dojo.html._sumPixelValues(node,["margin-left","margin-right"],(dojo.html.getComputedStyle(node,"position")=="absolute")),height:dojo.html._sumPixelValues(node,["margin-top","margin-bottom"],(dojo.html.getComputedStyle(node,"position")=="absolute"))};
};
dojo.html.getBorder=function(node){
return {width:dojo.html.getBorderExtent(node,"left")+dojo.html.getBorderExtent(node,"right"),height:dojo.html.getBorderExtent(node,"top")+dojo.html.getBorderExtent(node,"bottom")};
};
dojo.html.getBorderExtent=function(node,side){
return (dojo.html.getStyle(node,"border-"+side+"-style")=="none"?0:dojo.html.getPixelValue(node,"border-"+side+"-width"));
};
dojo.html.getMarginExtent=function(node,side){
return dojo.html._sumPixelValues(node,["margin-"+side],dojo.html.isPositionAbsolute(node));
};
dojo.html.getPaddingExtent=function(node,side){
return dojo.html._sumPixelValues(node,["padding-"+side],true);
};
dojo.html.getPadding=function(node){
return {width:dojo.html._sumPixelValues(node,["padding-left","padding-right"],true),height:dojo.html._sumPixelValues(node,["padding-top","padding-bottom"],true)};
};
dojo.html.getPadBorder=function(node){
var pad=dojo.html.getPadding(node);
var _557=dojo.html.getBorder(node);
return {width:pad.width+_557.width,height:pad.height+_557.height};
};
dojo.html.getBoxSizing=function(node){
var h=dojo.render.html;
var bs=dojo.html.boxSizing;
if(((h.ie)||(h.opera))&&node.nodeName!="IMG"){
var cm=document["compatMode"];
if((cm=="BackCompat")||(cm=="QuirksMode")){
return bs.BORDER_BOX;
}else{
return bs.CONTENT_BOX;
}
}else{
if(arguments.length==0){
node=document.documentElement;
}
var _55c=dojo.html.getStyle(node,"-moz-box-sizing");
if(!_55c){
_55c=dojo.html.getStyle(node,"box-sizing");
}
return (_55c?_55c:bs.CONTENT_BOX);
}
};
dojo.html.isBorderBox=function(node){
return (dojo.html.getBoxSizing(node)==dojo.html.boxSizing.BORDER_BOX);
};
dojo.html.getBorderBox=function(node){
node=dojo.byId(node);
return {width:node.offsetWidth,height:node.offsetHeight};
};
dojo.html.getPaddingBox=function(node){
var box=dojo.html.getBorderBox(node);
var _561=dojo.html.getBorder(node);
return {width:box.width-_561.width,height:box.height-_561.height};
};
dojo.html.getContentBox=function(node){
node=dojo.byId(node);
var _563=dojo.html.getPadBorder(node);
return {width:node.offsetWidth-_563.width,height:node.offsetHeight-_563.height};
};
dojo.html.setContentBox=function(node,args){
node=dojo.byId(node);
var _566=0;
var _567=0;
var isbb=dojo.html.isBorderBox(node);
var _569=(isbb?dojo.html.getPadBorder(node):{width:0,height:0});
var ret={};
if(typeof args.width!="undefined"){
_566=args.width+_569.width;
ret.width=dojo.html.setPositivePixelValue(node,"width",_566);
}
if(typeof args.height!="undefined"){
_567=args.height+_569.height;
ret.height=dojo.html.setPositivePixelValue(node,"height",_567);
}
return ret;
};
dojo.html.getMarginBox=function(node){
var _56c=dojo.html.getBorderBox(node);
var _56d=dojo.html.getMargin(node);
return {width:_56c.width+_56d.width,height:_56c.height+_56d.height};
};
dojo.html.setMarginBox=function(node,args){
node=dojo.byId(node);
var _570=0;
var _571=0;
var isbb=dojo.html.isBorderBox(node);
var _573=(!isbb?dojo.html.getPadBorder(node):{width:0,height:0});
var _574=dojo.html.getMargin(node);
var ret={};
if(typeof args.width!="undefined"){
_570=args.width-_573.width;
_570-=_574.width;
ret.width=dojo.html.setPositivePixelValue(node,"width",_570);
}
if(typeof args.height!="undefined"){
_571=args.height-_573.height;
_571-=_574.height;
ret.height=dojo.html.setPositivePixelValue(node,"height",_571);
}
return ret;
};
dojo.html.getElementBox=function(node,type){
var bs=dojo.html.boxSizing;
switch(type){
case bs.MARGIN_BOX:
return dojo.html.getMarginBox(node);
case bs.BORDER_BOX:
return dojo.html.getBorderBox(node);
case bs.PADDING_BOX:
return dojo.html.getPaddingBox(node);
case bs.CONTENT_BOX:
default:
return dojo.html.getContentBox(node);
}
};
dojo.html.toCoordinateObject=dojo.html.toCoordinateArray=function(_579,_57a,_57b){
if(_579 instanceof Array||typeof _579=="array"){
dojo.deprecated("dojo.html.toCoordinateArray","use dojo.html.toCoordinateObject({left: , top: , width: , height: }) instead","0.5");
while(_579.length<4){
_579.push(0);
}
while(_579.length>4){
_579.pop();
}
var ret={left:_579[0],top:_579[1],width:_579[2],height:_579[3]};
}else{
if(!_579.nodeType&&!(_579 instanceof String||typeof _579=="string")&&("width" in _579||"height" in _579||"left" in _579||"x" in _579||"top" in _579||"y" in _579)){
var ret={left:_579.left||_579.x||0,top:_579.top||_579.y||0,width:_579.width||0,height:_579.height||0};
}else{
var node=dojo.byId(_579);
var pos=dojo.html.abs(node,_57a,_57b);
var _57f=dojo.html.getMarginBox(node);
var ret={left:pos.left,top:pos.top,width:_57f.width,height:_57f.height};
}
}
ret.x=ret.left;
ret.y=ret.top;
return ret;
};
dojo.html.setMarginBoxWidth=dojo.html.setOuterWidth=function(node,_581){
return dojo.html._callDeprecated("setMarginBoxWidth","setMarginBox",arguments,"width");
};
dojo.html.setMarginBoxHeight=dojo.html.setOuterHeight=function(){
return dojo.html._callDeprecated("setMarginBoxHeight","setMarginBox",arguments,"height");
};
dojo.html.getMarginBoxWidth=dojo.html.getOuterWidth=function(){
return dojo.html._callDeprecated("getMarginBoxWidth","getMarginBox",arguments,null,"width");
};
dojo.html.getMarginBoxHeight=dojo.html.getOuterHeight=function(){
return dojo.html._callDeprecated("getMarginBoxHeight","getMarginBox",arguments,null,"height");
};
dojo.html.getTotalOffset=function(node,type,_584){
return dojo.html._callDeprecated("getTotalOffset","getAbsolutePosition",arguments,null,type);
};
dojo.html.getAbsoluteX=function(node,_586){
return dojo.html._callDeprecated("getAbsoluteX","getAbsolutePosition",arguments,null,"x");
};
dojo.html.getAbsoluteY=function(node,_588){
return dojo.html._callDeprecated("getAbsoluteY","getAbsolutePosition",arguments,null,"y");
};
dojo.html.totalOffsetLeft=function(node,_58a){
return dojo.html._callDeprecated("totalOffsetLeft","getAbsolutePosition",arguments,null,"left");
};
dojo.html.totalOffsetTop=function(node,_58c){
return dojo.html._callDeprecated("totalOffsetTop","getAbsolutePosition",arguments,null,"top");
};
dojo.html.getMarginWidth=function(node){
return dojo.html._callDeprecated("getMarginWidth","getMargin",arguments,null,"width");
};
dojo.html.getMarginHeight=function(node){
return dojo.html._callDeprecated("getMarginHeight","getMargin",arguments,null,"height");
};
dojo.html.getBorderWidth=function(node){
return dojo.html._callDeprecated("getBorderWidth","getBorder",arguments,null,"width");
};
dojo.html.getBorderHeight=function(node){
return dojo.html._callDeprecated("getBorderHeight","getBorder",arguments,null,"height");
};
dojo.html.getPaddingWidth=function(node){
return dojo.html._callDeprecated("getPaddingWidth","getPadding",arguments,null,"width");
};
dojo.html.getPaddingHeight=function(node){
return dojo.html._callDeprecated("getPaddingHeight","getPadding",arguments,null,"height");
};
dojo.html.getPadBorderWidth=function(node){
return dojo.html._callDeprecated("getPadBorderWidth","getPadBorder",arguments,null,"width");
};
dojo.html.getPadBorderHeight=function(node){
return dojo.html._callDeprecated("getPadBorderHeight","getPadBorder",arguments,null,"height");
};
dojo.html.getBorderBoxWidth=dojo.html.getInnerWidth=function(){
return dojo.html._callDeprecated("getBorderBoxWidth","getBorderBox",arguments,null,"width");
};
dojo.html.getBorderBoxHeight=dojo.html.getInnerHeight=function(){
return dojo.html._callDeprecated("getBorderBoxHeight","getBorderBox",arguments,null,"height");
};
dojo.html.getContentBoxWidth=dojo.html.getContentWidth=function(){
return dojo.html._callDeprecated("getContentBoxWidth","getContentBox",arguments,null,"width");
};
dojo.html.getContentBoxHeight=dojo.html.getContentHeight=function(){
return dojo.html._callDeprecated("getContentBoxHeight","getContentBox",arguments,null,"height");
};
dojo.html.setContentBoxWidth=dojo.html.setContentWidth=function(node,_596){
return dojo.html._callDeprecated("setContentBoxWidth","setContentBox",arguments,"width");
};
dojo.html.setContentBoxHeight=dojo.html.setContentHeight=function(node,_598){
return dojo.html._callDeprecated("setContentBoxHeight","setContentBox",arguments,"height");
};
dojo.provide("dojo.lfx.html");
dojo.lfx.html._byId=function(_599){
if(!_599){
return [];
}
if(dojo.lang.isArrayLike(_599)){
if(!_599.alreadyChecked){
var n=[];
dojo.lang.forEach(_599,function(node){
n.push(dojo.byId(node));
});
n.alreadyChecked=true;
return n;
}else{
return _599;
}
}else{
var n=[];
n.push(dojo.byId(_599));
n.alreadyChecked=true;
return n;
}
};
dojo.lfx.html.propertyAnimation=function(_59c,_59d,_59e,_59f,_5a0){
_59c=dojo.lfx.html._byId(_59c);
var _5a1={"propertyMap":_59d,"nodes":_59c,"duration":_59e,"easing":_59f||dojo.lfx.easeDefault};
var _5a2=function(args){
if(args.nodes.length==1){
var pm=args.propertyMap;
if(!dojo.lang.isArray(args.propertyMap)){
var parr=[];
for(var _5a6 in pm){
pm[_5a6].property=_5a6;
parr.push(pm[_5a6]);
}
pm=args.propertyMap=parr;
}
dojo.lang.forEach(pm,function(prop){
if(dj_undef("start",prop)){
if(prop.property!="opacity"){
prop.start=parseInt(dojo.html.getComputedStyle(args.nodes[0],prop.property));
}else{
prop.start=dojo.html.getOpacity(args.nodes[0]);
}
}
});
}
};
var _5a8=function(_5a9){
var _5aa=[];
dojo.lang.forEach(_5a9,function(c){
_5aa.push(Math.round(c));
});
return _5aa;
};
var _5ac=function(n,_5ae){
n=dojo.byId(n);
if(!n||!n.style){
return;
}
for(var s in _5ae){
try{
if(s=="opacity"){
dojo.html.setOpacity(n,_5ae[s]);
}else{
n.style[s]=_5ae[s];
}
}
catch(e){
dojo.debug(e);
}
}
};
var _5b0=function(_5b1){
this._properties=_5b1;
this.diffs=new Array(_5b1.length);
dojo.lang.forEach(_5b1,function(prop,i){
if(dojo.lang.isFunction(prop.start)){
prop.start=prop.start(prop,i);
}
if(dojo.lang.isFunction(prop.end)){
prop.end=prop.end(prop,i);
}
if(dojo.lang.isArray(prop.start)){
this.diffs[i]=null;
}else{
if(prop.start instanceof dojo.gfx.color.Color){
prop.startRgb=prop.start.toRgb();
prop.endRgb=prop.end.toRgb();
}else{
this.diffs[i]=prop.end-prop.start;
}
}
},this);
this.getValue=function(n){
var ret={};
dojo.lang.forEach(this._properties,function(prop,i){
var _5b8=null;
if(dojo.lang.isArray(prop.start)){
}else{
if(prop.start instanceof dojo.gfx.color.Color){
_5b8=(prop.units||"rgb")+"(";
for(var j=0;j<prop.startRgb.length;j++){
_5b8+=Math.round(((prop.endRgb[j]-prop.startRgb[j])*n)+prop.startRgb[j])+(j<prop.startRgb.length-1?",":"");
}
_5b8+=")";
}else{
_5b8=((this.diffs[i])*n)+prop.start+(prop.property!="opacity"?prop.units||"px":"");
}
}
ret[dojo.html.toCamelCase(prop.property)]=_5b8;
},this);
return ret;
};
};
var anim=new dojo.lfx.Animation({beforeBegin:function(){
_5a2(_5a1);
anim.curve=new _5b0(_5a1.propertyMap);
},onAnimate:function(_5bb){
dojo.lang.forEach(_5a1.nodes,function(node){
_5ac(node,_5bb);
});
}},_5a1.duration,null,_5a1.easing);
if(_5a0){
for(var x in _5a0){
if(dojo.lang.isFunction(_5a0[x])){
anim.connect(x,anim,_5a0[x]);
}
}
}
return anim;
};
dojo.lfx.html._makeFadeable=function(_5be){
var _5bf=function(node){
if(dojo.render.html.ie){
if((node.style.zoom.length==0)&&(dojo.html.getStyle(node,"zoom")=="normal")){
node.style.zoom="1";
}
if((node.style.width.length==0)&&(dojo.html.getStyle(node,"width")=="auto")){
node.style.width="auto";
}
}
};
if(dojo.lang.isArrayLike(_5be)){
dojo.lang.forEach(_5be,_5bf);
}else{
_5bf(_5be);
}
};
dojo.lfx.html.fade=function(_5c1,_5c2,_5c3,_5c4,_5c5){
_5c1=dojo.lfx.html._byId(_5c1);
var _5c6={property:"opacity"};
if(!dj_undef("start",_5c2)){
_5c6.start=_5c2.start;
}else{
_5c6.start=function(){
return dojo.html.getOpacity(_5c1[0]);
};
}
if(!dj_undef("end",_5c2)){
_5c6.end=_5c2.end;
}else{
dojo.raise("dojo.lfx.html.fade needs an end value");
}
var anim=dojo.lfx.propertyAnimation(_5c1,[_5c6],_5c3,_5c4);
anim.connect("beforeBegin",function(){
dojo.lfx.html._makeFadeable(_5c1);
});
if(_5c5){
anim.connect("onEnd",function(){
_5c5(_5c1,anim);
});
}
return anim;
};
dojo.lfx.html.fadeIn=function(_5c8,_5c9,_5ca,_5cb){
return dojo.lfx.html.fade(_5c8,{end:1},_5c9,_5ca,_5cb);
};
dojo.lfx.html.fadeOut=function(_5cc,_5cd,_5ce,_5cf){
return dojo.lfx.html.fade(_5cc,{end:0},_5cd,_5ce,_5cf);
};
dojo.lfx.html.fadeShow=function(_5d0,_5d1,_5d2,_5d3){
_5d0=dojo.lfx.html._byId(_5d0);
dojo.lang.forEach(_5d0,function(node){
dojo.html.setOpacity(node,0);
});
var anim=dojo.lfx.html.fadeIn(_5d0,_5d1,_5d2,_5d3);
anim.connect("beforeBegin",function(){
if(dojo.lang.isArrayLike(_5d0)){
dojo.lang.forEach(_5d0,dojo.html.show);
}else{
dojo.html.show(_5d0);
}
});
return anim;
};
dojo.lfx.html.fadeHide=function(_5d6,_5d7,_5d8,_5d9){
var anim=dojo.lfx.html.fadeOut(_5d6,_5d7,_5d8,function(){
if(dojo.lang.isArrayLike(_5d6)){
dojo.lang.forEach(_5d6,dojo.html.hide);
}else{
dojo.html.hide(_5d6);
}
if(_5d9){
_5d9(_5d6,anim);
}
});
return anim;
};
dojo.lfx.html.wipeIn=function(_5db,_5dc,_5dd,_5de){
_5db=dojo.lfx.html._byId(_5db);
var _5df=[];
dojo.lang.forEach(_5db,function(node){
var _5e1={};
var _5e2,_5e3,_5e4;
with(node.style){
_5e2=top;
_5e3=left;
_5e4=position;
top="-9999px";
left="-9999px";
position="absolute";
display="";
}
var _5e5=dojo.html.getBorderBox(node).height;
with(node.style){
top=_5e2;
left=_5e3;
position=_5e4;
display="none";
}
var anim=dojo.lfx.propertyAnimation(node,{"height":{start:1,end:function(){
return _5e5;
}}},_5dc,_5dd);
anim.connect("beforeBegin",function(){
_5e1.overflow=node.style.overflow;
_5e1.height=node.style.height;
with(node.style){
overflow="hidden";
_5e5="1px";
}
dojo.html.show(node);
});
anim.connect("onEnd",function(){
with(node.style){
overflow=_5e1.overflow;
_5e5=_5e1.height;
}
if(_5de){
_5de(node,anim);
}
});
_5df.push(anim);
});
return dojo.lfx.combine(_5df);
};
dojo.lfx.html.wipeOut=function(_5e7,_5e8,_5e9,_5ea){
_5e7=dojo.lfx.html._byId(_5e7);
var _5eb=[];
dojo.lang.forEach(_5e7,function(node){
var _5ed={};
var anim=dojo.lfx.propertyAnimation(node,{"height":{start:function(){
return dojo.html.getContentBox(node).height;
},end:1}},_5e8,_5e9,{"beforeBegin":function(){
_5ed.overflow=node.style.overflow;
_5ed.height=node.style.height;
with(node.style){
overflow="hidden";
}
dojo.html.show(node);
},"onEnd":function(){
dojo.html.hide(node);
with(node.style){
overflow=_5ed.overflow;
height=_5ed.height;
}
if(_5ea){
_5ea(node,anim);
}
}});
_5eb.push(anim);
});
return dojo.lfx.combine(_5eb);
};
dojo.lfx.html.slideTo=function(_5ef,_5f0,_5f1,_5f2,_5f3){
_5ef=dojo.lfx.html._byId(_5ef);
var _5f4=[];
var _5f5=dojo.html.getComputedStyle;
if(dojo.lang.isArray(_5f0)){
dojo.deprecated("dojo.lfx.html.slideTo(node, array)","use dojo.lfx.html.slideTo(node, {top: value, left: value});","0.5");
_5f0={top:_5f0[0],left:_5f0[1]};
}
dojo.lang.forEach(_5ef,function(node){
var top=null;
var left=null;
var init=(function(){
var _5fa=node;
return function(){
var pos=_5f5(_5fa,"position");
top=(pos=="absolute"?node.offsetTop:parseInt(_5f5(node,"top"))||0);
left=(pos=="absolute"?node.offsetLeft:parseInt(_5f5(node,"left"))||0);
if(!dojo.lang.inArray(["absolute","relative"],pos)){
var ret=dojo.html.abs(_5fa,true);
dojo.html.setStyleAttributes(_5fa,"position:absolute;top:"+ret.y+"px;left:"+ret.x+"px;");
top=ret.y;
left=ret.x;
}
};
})();
init();
var anim=dojo.lfx.propertyAnimation(node,{"top":{start:top,end:(_5f0.top||0)},"left":{start:left,end:(_5f0.left||0)}},_5f1,_5f2,{"beforeBegin":init});
if(_5f3){
anim.connect("onEnd",function(){
_5f3(_5ef,anim);
});
}
_5f4.push(anim);
});
return dojo.lfx.combine(_5f4);
};
dojo.lfx.html.slideBy=function(_5fe,_5ff,_600,_601,_602){
_5fe=dojo.lfx.html._byId(_5fe);
var _603=[];
var _604=dojo.html.getComputedStyle;
if(dojo.lang.isArray(_5ff)){
dojo.deprecated("dojo.lfx.html.slideBy(node, array)","use dojo.lfx.html.slideBy(node, {top: value, left: value});","0.5");
_5ff={top:_5ff[0],left:_5ff[1]};
}
dojo.lang.forEach(_5fe,function(node){
var top=null;
var left=null;
var init=(function(){
var _609=node;
return function(){
var pos=_604(_609,"position");
top=(pos=="absolute"?node.offsetTop:parseInt(_604(node,"top"))||0);
left=(pos=="absolute"?node.offsetLeft:parseInt(_604(node,"left"))||0);
if(!dojo.lang.inArray(["absolute","relative"],pos)){
var ret=dojo.html.abs(_609,true);
dojo.html.setStyleAttributes(_609,"position:absolute;top:"+ret.y+"px;left:"+ret.x+"px;");
top=ret.y;
left=ret.x;
}
};
})();
init();
var anim=dojo.lfx.propertyAnimation(node,{"top":{start:top,end:top+(_5ff.top||0)},"left":{start:left,end:left+(_5ff.left||0)}},_600,_601).connect("beforeBegin",init);
if(_602){
anim.connect("onEnd",function(){
_602(_5fe,anim);
});
}
_603.push(anim);
});
return dojo.lfx.combine(_603);
};
dojo.lfx.html.explode=function(_60d,_60e,_60f,_610,_611){
var h=dojo.html;
_60d=dojo.byId(_60d);
_60e=dojo.byId(_60e);
var _613=h.toCoordinateObject(_60d,true);
var _614=document.createElement("div");
h.copyStyle(_614,_60e);
if(_60e.explodeClassName){
_614.className=_60e.explodeClassName;
}
with(_614.style){
position="absolute";
display="none";
var _615=h.getStyle(_60d,"background-color");
backgroundColor=_615?_615.toLowerCase():"transparent";
backgroundColor=(backgroundColor=="transparent")?"rgb(221, 221, 221)":backgroundColor;
}
dojo.body().appendChild(_614);
with(_60e.style){
visibility="hidden";
display="block";
}
var _616=h.toCoordinateObject(_60e,true);
with(_60e.style){
display="none";
visibility="visible";
}
var _617={opacity:{start:0.5,end:1}};
dojo.lang.forEach(["height","width","top","left"],function(type){
_617[type]={start:_613[type],end:_616[type]};
});
var anim=new dojo.lfx.propertyAnimation(_614,_617,_60f,_610,{"beforeBegin":function(){
h.setDisplay(_614,"block");
},"onEnd":function(){
h.setDisplay(_60e,"block");
_614.parentNode.removeChild(_614);
}});
if(_611){
anim.connect("onEnd",function(){
_611(_60e,anim);
});
}
return anim;
};
dojo.lfx.html.implode=function(_61a,end,_61c,_61d,_61e){
var h=dojo.html;
_61a=dojo.byId(_61a);
end=dojo.byId(end);
var _620=dojo.html.toCoordinateObject(_61a,true);
var _621=dojo.html.toCoordinateObject(end,true);
var _622=document.createElement("div");
dojo.html.copyStyle(_622,_61a);
if(_61a.explodeClassName){
_622.className=_61a.explodeClassName;
}
dojo.html.setOpacity(_622,0.3);
with(_622.style){
position="absolute";
display="none";
backgroundColor=h.getStyle(_61a,"background-color").toLowerCase();
}
dojo.body().appendChild(_622);
var _623={opacity:{start:1,end:0.5}};
dojo.lang.forEach(["height","width","top","left"],function(type){
_623[type]={start:_620[type],end:_621[type]};
});
var anim=new dojo.lfx.propertyAnimation(_622,_623,_61c,_61d,{"beforeBegin":function(){
dojo.html.hide(_61a);
dojo.html.show(_622);
},"onEnd":function(){
_622.parentNode.removeChild(_622);
}});
if(_61e){
anim.connect("onEnd",function(){
_61e(_61a,anim);
});
}
return anim;
};
dojo.lfx.html.highlight=function(_626,_627,_628,_629,_62a){
_626=dojo.lfx.html._byId(_626);
var _62b=[];
dojo.lang.forEach(_626,function(node){
var _62d=dojo.html.getBackgroundColor(node);
var bg=dojo.html.getStyle(node,"background-color").toLowerCase();
var _62f=dojo.html.getStyle(node,"background-image");
var _630=(bg=="transparent"||bg=="rgba(0, 0, 0, 0)");
while(_62d.length>3){
_62d.pop();
}
var rgb=new dojo.gfx.color.Color(_627);
var _632=new dojo.gfx.color.Color(_62d);
var anim=dojo.lfx.propertyAnimation(node,{"background-color":{start:rgb,end:_632}},_628,_629,{"beforeBegin":function(){
if(_62f){
node.style.backgroundImage="none";
}
node.style.backgroundColor="rgb("+rgb.toRgb().join(",")+")";
},"onEnd":function(){
if(_62f){
node.style.backgroundImage=_62f;
}
if(_630){
node.style.backgroundColor="transparent";
}
if(_62a){
_62a(node,anim);
}
}});
_62b.push(anim);
});
return dojo.lfx.combine(_62b);
};
dojo.lfx.html.unhighlight=function(_634,_635,_636,_637,_638){
_634=dojo.lfx.html._byId(_634);
var _639=[];
dojo.lang.forEach(_634,function(node){
var _63b=new dojo.gfx.color.Color(dojo.html.getBackgroundColor(node));
var rgb=new dojo.gfx.color.Color(_635);
var _63d=dojo.html.getStyle(node,"background-image");
var anim=dojo.lfx.propertyAnimation(node,{"background-color":{start:_63b,end:rgb}},_636,_637,{"beforeBegin":function(){
if(_63d){
node.style.backgroundImage="none";
}
node.style.backgroundColor="rgb("+_63b.toRgb().join(",")+")";
},"onEnd":function(){
if(_638){
_638(node,anim);
}
}});
_639.push(anim);
});
return dojo.lfx.combine(_639);
};
dojo.lang.mixin(dojo.lfx,dojo.lfx.html);
dojo.provide("dojo.lfx.*");

